<?php
/**
 *  Name - Dummy panel 
 *  Dependency - Core Admin Class
 *  Version - 1.0
 *  Code Name - Nobody
 */

if(!is_admin()) return;

class LEAPADMIN extends IOA_PANEL_CORE {
	

	
	// init menu
	function __construct () { parent::__construct( __('Chat Admin','ioa'),'page','lchat','','edit_posts');  }
	
	// setup things before page loads , script loading etc ...
	function manager_admin_init(){	

		

	  }	
	
	
	/**
	 * Main Body for the Panel
	 */

	function panelmarkup(){	
		$current_user = wp_get_current_user();
		
		?>

		<div class="ioa-panel" data-logo='<?php echo leap_chat_URL.'/admin/css/i/leap.png' ?>'  data-operator='<?php  if($current_user->first_name!='') echo $current_user->first_name; else echo 'Operator'; ?>' data-uid='<?php  echo $current_user->ID ?>'>
			<div class="ioa_panel_wrap" > <!-- Panel Wrapper -->
			

				<div class="ioa-panel-body  leap-chat-body clearfix">
					
					<div class="leap-visitor-tree-wrap" >
						<h5><?php _e('All Visitors','leap') ?></h5>
						<ul id="leap-visitor-tree">
							
						</ul>
					</div>	
					<div  class='leap-active-chat-box'>
						<div class="leap-tab-nav">
							<ul class='clearfix'>
								
							</ul>
						</div>
						<div class="leap-chat-tab-panel">
						</div>
					</div>
			
				</div>
			
			<div class="clone-chat-tab">
				<div class="leap-chat-box" id="">
					<a href="" class="leap-chat-box-close"><?php _e('Close Chat Window','leap') ?></a>
					<a href="" class="leap-chat-box-session-close"><?php _e('End & Archive Chat  Session','leap') ?></a>
					<div class="leap-chat-box-user-info">
						<h5><?php _e('Location','leap') ?></h5>
						<ul class='location-data'>
							<li><?php _e('Getting Location...','leap') ?></li>		
						</ul>
						<h5><?php _e('User Submitted Information','leap') ?></h5>
						<ul class='meta-data'>
							<li><?php _e('Getting Information...','leap') ?></li>	
						</ul>
						<h5><?php _e('Technical Information','leap') ?></h5>
						<ul class='technical-data'>
							<li><?php _e('Getting Information...','leap') ?></li>	
						</ul>
					</div>
					<div class="leap-chat-box-header"></div>
					<div class="leap-chat-box-body">
						<div class="leap-chat-box-body--canvas">
							
						</div>
						<div class='leap-chat-typing-indicator'>
							 <?php _e(' User is Typing... ','ioa') ?>
						</div>
					</div>

					<div class="leap-chat-box-footer">
						<textarea class="leap-chat-box-footer--input"></textarea>
						<a href="" class='leap-chat-box-footer--send' ><?php _e('Send','leap') ?></a>
                        <a href="" class='leap-chat-box-footer--attach'>
                      <svg xmlns="http://www.w3.org/2000/svg" width="50" height="50" viewBox="0 0 50 50" style="fill: rgb(255, 255, 255);">
    <path style="text-indent:0;text-align:start;line-height:normal;text-transform:none;block-progression:tb;-inkscape-font-specification:Bitstream Vera Sans" d="M 38.1875 6.71875 C 36.26351 6.8140672 34.343702 7.6472143 32.84375 9.09375 C 32.811817 9.1245456 32.781536 9.1561348 32.75 9.1875 C 32.744452 9.193018 32.724286 9.1819644 32.71875 9.1875 A 2.0002 2.0002 0 0 0 32.59375 9.34375 A 2.0002 2.0002 0 0 0 32.46875 9.5 L 13.65625 28.40625 A 2.0002 2.0002 0 0 0 13.53125 28.5625 C 11.762263 30.482368 11.795077 33.513827 13.65625 35.375 C 15.563965 37.28605 18.749203 37.287052 20.65625 35.375 A 2.0108349 2.0108349 0 0 0 20.90625 35.0625 A 2.0002 2.0002 0 0 0 21.15625 34.84375 L 35.25 20.9375 A 2.0002 2.0002 0 0 0 33.625 17.5 A 2.0002 2.0002 0 0 0 32.4375 18.09375 L 18.34375 32 A 2.0002 2.0002 0 0 0 18.1875 32.21875 A 2.0108349 2.0108349 0 0 0 18.125 32.25 A 2.0002 2.0002 0 0 0 18.09375 32.3125 A 2.0108349 2.0108349 0 0 0 17.8125 32.53125 C 17.433547 32.911198 16.880285 32.9122 16.5 32.53125 C 16.119972 32.151222 16.118971 31.600112 16.5 31.21875 L 35.59375 12.03125 A 2.0002 2.0002 0 0 0 35.71875 11.875 C 37.363251 10.360717 39.560145 10.372645 40.78125 11.59375 A 2.0108349 2.0108349 0 0 0 41.0625 11.8125 A 2.0108349 2.0108349 0 0 0 41.09375 11.84375 A 2.0002 2.0002 0 0 0 41.28125 12.0625 C 42.425278 13.206528 42.233282 15.620202 40.625 17.3125 A 2.0002 2.0002 0 0 0 40.53125 17.40625 L 19.84375 38.625 A 2.0108349 2.0108349 0 0 0 19.65625 38.78125 C 16.972754 41.466311 12.351618 41.789118 9.78125 39.21875 C 7.2605421 36.699512 7.5234442 32.140949 10.09375 29.4375 A 2.0002 2.0002 0 0 0 10.21875 29.3125 L 27.25 12.46875 A 2.0002 2.0002 0 0 0 25.625 9.03125 A 2.0002 2.0002 0 0 0 24.4375 9.625 L 7.5 26.375 A 2.0002 2.0002 0 0 0 7.40625 26.46875 A 2.0002 2.0002 0 0 0 7.28125 26.625 C 3.2332797 30.818431 2.6845896 37.780818 6.9375 42.03125 C 11.161258 46.255008 18.080842 45.806007 22.28125 41.8125 A 2.0002 2.0002 0 0 0 22.40625 41.71875 C 22.416783 41.708456 22.427003 41.697839 22.4375 41.6875 A 2.0002 2.0002 0 0 0 22.5 41.625 A 2.0108349 2.0108349 0 0 0 22.5 41.59375 L 22.625 41.46875 A 2.0108349 2.0108349 0 0 0 22.75 41.3125 L 43.40625 20.21875 A 2.0002 2.0002 0 0 0 43.78125 19.75 C 46.418589 16.732694 46.991241 12.147491 44.09375 9.25 A 2.0002 2.0002 0 0 0 43.9375 9.125 A 2.0108349 2.0108349 0 0 0 43.625 8.75 C 42.147191 7.2721912 40.159656 6.6210466 38.1875 6.71875 z" color="#000" overflow="visible" enable-background="accumulate" font-family="Bitstream Vera Sans"/>
</svg>
                        </a>
					</div>
				</div>
			</div>
			
					
         		</div>       	
        	 </div>       
        	 <?php 
        	 $sound_url =  leap_chat_URL.'/sprites/sound.mp3';
        	 $new_sound_url =  leap_chat_URL.'/sprites/new_user_sound.mp3';
        	  ?>
        	 <div class="leap-audio-notification">
		<audio autobuffer id="leap-chat-audio">
			<source src="<?php echo $sound_url ?>">
		</audio>
	</div>	
	 <div class="new-leap-audio-notification">
		<audio autobuffer id="new-leap-chat-audio">
			<source src="<?php echo $new_sound_url ?>">
		</audio>
	</div>



		<?php
	

	    
	 }
	 

}

