<?php
/**
 *  Name - Dummy panel 
 *  Dependency - Core Admin Class
 *  Version - 1.0
 *  Code Name - Nobody
 */

if(!is_admin()) return;

class LEAPADMINANALYTICS extends IOA_PANEL_CORE {
	

	
	// init menu
	function __construct () { parent::__construct( __('Analytics','ioa'),'submenu','lchatan');  }
	
	// setup things before page loads , script loading etc ...
	function manager_admin_init(){	

		

	  }	
	
	 function manager_admin_menu(){
		
	   	 add_submenu_page("lchat", 'Analytics', 'Analytics', 'edit_pages', 'lchatan' ,array($this,'manager_admin_wrap')); 
		  
	  }
	
	/**
	 * Main Body for the Panel
	 */

	function panelmarkup(){	
		$current_user = wp_get_current_user();
		
		?>

		<div class="ioa-panel" >
			<div class="ioa_panel_wrap" > <!-- Panel Wrapper -->
			
				<div class="ioa-panel-title">
					<h2><?php _e('Analytics',"leap") ?></h2>
				</div>

				<div class="ioa-panel-body  leap-chat-settings clearfix">
					
					<div class="leap-analytics-table-wrap">
						<?php 
						$offset =  0;								
						if(isset($_GET['offset']))
							$offset = $_GET['offset'];

						if( isset($_GET['step'])  && $_GET['step'] == 'next'  )
							$offset += 10;

						if( isset($_GET['step'])  && $_GET['step'] == 'prev'  )
							$offset -= 10;

						$ga = get_option('LEAP_ANALYTICS');
								if(!$ga)	
									$ga = array();
						$ga = array_reverse($ga);		
						$init = $offset;
						$limit = $init + 10;
						 ?>

						<div class="leap-analytics-pagination clearfix">
							   <?php ?><a class="button-save" href='<?php echo admin_url('admin.php?page=lchatan&step=prev&offset='.$offset) ?>'><?php _e('Previous','leap') ?></a><?php ?>
							 <?php if( $limit  < count($ga) ) : ?><a class="button-save" href='<?php echo admin_url('admin.php?page=lchatan&step=next&offset='.$offset) ?>'><?php _e('Next','leap') ?></a><?php endif; ?>

                             <a href="" id="leap-purge-analytics" class='button-default' ><?php  _e('Delete All','leap') ?></a> 
						</div>

						 <table class='leap-analytics-table'>
					 	<thead>
					 		<tr>
					 			<th><strong><?php _e('Index','ioa') ?></strong></th>
					 			<th><?php _e('Visitor Name','ioa') ?></th>
					 			<th><?php _e('Date/Time','ioa') ?></th>
					 			<th><?php _e('Assigned Operator','ioa') ?></th>
					 			<th><?php _e('Screen Resolution','ioa') ?></th>
					 			<th><?php _e('OS','ioa') ?></th>
					 			<th><?php _e('Browser','ioa') ?></th>
					 			<th><?php _e('Cookies','ioa') ?></th>
					 			<th><?php _e('Data Submitted','ioa') ?></th>
					 			<th><?php _e('Country','ioa') ?></th>
					 			<th><?php _e(' Location','ioa') ?></th>
					 			<th><?php _e('IP','ioa') ?></th>
					 		</tr>
					 	</thead>
					 	<tbody>
					 		<?php 
								

								$i = 0;
								foreach ($ga as $key => $visitor) {

									if(isset($visitor['name']) && $visitor['name']!='' ) :

								 if($i >= $init && $i < $limit) {	 
									
									if(isset($visitor['location']))
										$location = $visitor['location'];
									
									if(isset($visitor['location']))
										$data = $visitor['data'];
									if(isset($visitor['technical']))
										$technical = $visitor['technical'];
									?> <tr> 
									<td> <strong><?php echo $i+1 ?></strong> </td>
									<td><?php echo $visitor['name'] ?></td>
									<td><?php if(isset($visitor['time'])) echo date(' d  F Y ,h:i:s A', $visitor['time']); ?></td>
						 			<td><?php echo $visitor['operator'] ?></td>
						 			<td><?php echo $technical['screen'] ?></td>
						 			<td><?php echo $technical['os'].'('.$technical['osVersion'].')' ?></td>
						 			<td><?php echo $technical['browser'].'('.$technical['browserVersion'].')' ?></td>
						 			<td><?php echo $technical['cookies'] ?></td>
						 			<td><?php 
						 				foreach($data  as $pair)	
						 					echo "<p><strong>".$pair['name']." : </strong>".$pair['value']."</p>"
						 			?></td>
						 			
						 			<td><?php  if(isset($location['city'])) echo $location['city'].' / ';  if(isset($location['region'])) echo $location['region']; if(!isset($location['region']) && ! isset($location['city']))  echo "NA" ?></td>
						 			<td><?php  if(isset($location['country'])) echo $location['country'].' / ';  if(isset($location['continent'])) echo $location['continent']; if(!isset($location['continent']) && ! isset($location['country']))  echo "NA" ?></td>
						 			<td><?php  if(isset($location['ip'])) echo $location['ip']; else echo 'NA';  ?></td>
            
									</tr> <?php
									}

									$i++;
									endif;
								}

							 ?>
					 	</tbody>
					 </table>
					</div>					
					
				</div>
			
	         		</div>       	
	        	 </div>       	



		<?php
	

	    
	 }
	 

}



