/**
 * @description : Main file for Framework inputs / media api / widgets
 * @version : 1.0
 * @author Abhin Sharma [ASI]
 */


 jQuery(document).ready(function()
 {


// Global Framework variables
var ioa_msg = null , loader = null ; 

if( jQuery('.rad-lightbox').length == 0 )
{
        load_IOAmods();
}

var doc = jQuery(document), body = jQuery('body') , mediaFrame , 
ioa_wrap = jQuery('.ioa_wrap ') , videoFrame, vmedia;
var win = {
  obj: jQuery(window),
  width: null,
  height: null
},
responsive = {

  ratio: 1,
  width: 1060,
  height: 600,

};

function load_IOAmods() {


 var doc = jQuery(document), body = jQuery('body') , mediaFrame , 
ioa_wrap = jQuery('.ioa_wrap ');
var win = {
  obj: jQuery(window),
  width: null,
  height: null
},
responsive = {

  ratio: 1,
  width: 1060,
  height: 600,

};

 mediaFrame = null,
hmedia = {

      init: function(title)
      {


            mediaFrame = wp.media(
            {

                  title: title,
                  multiple: true,
                  library:
                  {
                        type: 'image'
                  }

            });



      },

      open: function(title, button_label, callback)
      {
            hmedia.init(title);
            mediaFrame.on('toolbar:render:select', function(view)
            {
                  view.set(
                  {
                        select:
                        {
                              style: 'primary',
                              text: button_label,

                              click: function()
                              {

                                    var attachment = mediaFrame.state().get('selection'),
                                    models = attachment.models,
                                    images = [];

                                    jQuery(models).each(function(i)
                                    {

                                          images[i] = this.attributes;

                                    });

                                    mediaFrame.close();
                                    callback(images);
                              }
                        }
                  });
            });
            mediaFrame.setState('library').open();

      }
};





videoFrame = null,
vmedia = {

init: function(title)
{


videoFrame = wp.media(
{

    title: title,
    multiple: true,
    library:
    {
                            type: 'video,audio'
    }

});



},

open: function(title, button_label, callback)
{
vmedia.init(title);
videoFrame.on('toolbar:render:select', function(view)
{
    view.set(
    {
                            select:
                            {
                                                    style: 'primary',
                                                    text: button_label,

                                                    click: function()
                                                    {

                                                                            var attachment = videoFrame.state().get('selection'),
                                                                                                    models = attachment.models,
                                                                                                    videos = [];

                                                                            jQuery(models).each(function(i)
                                                                            {


                                                                                                    videos[i] = this.attributes;



                                                                            });

                                                                            videoFrame.close();
                                                                            callback(videos);
                                                    }
                            }
    });
});
videoFrame.setState('library').open();

}
},


attachFrame = null,
atmedia = {

        init: function(title)
        {


                attachFrame = wp.media(
                {

                    title: title,
                    multiple: false,
                    library:
                    {
                                            type: 'all'
                    }

                });



        },

        open: function(title, button_label, callback)
        {
                atmedia.init(title);
                attachFrame.on('toolbar:render:select', function(view)
                {
                    view.set(
                    {
                                            select:
                                            {
                                                                    style: 'primary',
                                                                    text: button_label,

                                                                    click: function()
                                                                    {

                                                                                            var attachment = attachFrame.state().get('selection'),
                                                                                                                    models = attachment.models,
                                                                                                                    videos = [];

                                                                                            jQuery(models).each(function(i)
                                                                                            {


                                                                                                                    videos[i] = this.attributes;



                                                                                            });

                                                                                            attachFrame.close();
                                                                                            callback(videos);
                                                                    }
                                            }
                    });
                });
                attachFrame.setState('library').open();

        }
}
;



/**
* Slider Input Support for the framework
*/


jQuery(".ioa_input .ioa_slider").each(function()
{
    temp = jQuery(this), obj = temp.parent().find("input");
    temp1 = obj.val();
    if (jQuery.trim(temp1) == "") temp1 = 0;
                  
                  temp.slider(
                  {
                      value: parseInt(temp1),
                      min: 0,
                      range: "min",
                      max: parseInt(obj.data('max')),
                      step: parseInt(obj.data('steps')),
                      slide: function(event, ui)
                      {
                          jQuery(this).parent().find("input").val(ui.value);
                    }
              });

            });


   

/**
* Framework MEDIA Api
*/


doc.on('click', '.input-val-delete', function(e)
{
    e.preventDefault();
    jQuery(this).parents('.ioa_input').find('input,textarea').val(' ');
    jQuery(this).parents('.ioa_input').find('input,textarea').trigger('focusout');
    if (jQuery(this).parents('.ioa_input').find('.ioa_slider').length > 0)
        jQuery(this).parents('.ioa_input').find(".ioa_slider").slider("value", 0);

});

doc.on('click', 'a.picker-delete', function(e)
{
    e.preventDefault();
    jQuery(this).parent().find('.ioa-minicolors').minicolors('value', '');
    jQuery(this).parent().find('span.minicolors-swatch >span').css('background', 'transparent');
    jQuery(this).parent().find('input').trigger('pickertrans');

});
 doc.on('mouseleave','.ioa_module_container',function(){
            computeModuleData( jQuery(this));
    });

doc.on('click', 'div.input-image-preview .himage-remove',function(e)
{
            e.preventDefault();
            temp = jQuery(this).parents('.ioa_input');
            temp.find('.input-image-preview').removeClass('has-image');
            temp.find('input').val('');
});

doc.on('click', '.image_upload', function(e)
{

      e.preventDefault();
      temp = jQuery(this);

      hmedia.open(temp.data('title'), temp.data('label'), function(images)
      {

            if(typeof images[0] === "undefined") return;


            if( ! temp.data('multi')  )   
                  temp.parents('.image_upload_wrap').find('input').val(images[0].id);
            else  
            {
                  temp1 = [];
                  for(i=0;i<images.length;i++)
                  {
                        temp1[i] = images[i].id; 
                  }
                  temp.parents('.image_upload_wrap').val( temp1.join(',') );

            }


            obj = temp.parents('div.input-image-preview').find('img');

            if(typeof images[0].sizes == "undefined")
                  obj.attr('src', images[0].url);
            else if(typeof images[0].sizes.medium == 'undefined')
                 obj.attr('src', images[0].url);
           else
               obj.attr('src',  images[0].sizes.medium.url);

         obj.fadeIn('normal');
         obj.parent().addClass('has-image');

         temp.trigger('ioa_image_added',[images]);

   });


});


doc.on('click', 'a.add-ioa-module', function(e)
{
  e.preventDefault();
  var thumb,med,mod = jQuery(this).parents('.ioa_module_container').find('div.module_list');
  var bl = jQuery(this).parents('.ioa_module_container').find('div.ioa_module.hide'), op= false;
  bl = bl.clone().removeClass('hide'),bobj  = jQuery(this);

  if(  jQuery(this).hasClass('image-mod-trigger')  )
  {
        hmedia.open('Add Images', 'Add', function(images)
        {

              for (var i = 0; i < images.length; i++)
              {
                    temp = bl.clone();
                    mod.append(temp);

                    if (typeof images[i].sizes.thumbnail != 'undefined')
                      thumb = images[i].sizes.thumbnail.url;
                else
                      thumb = images[i].sizes.full.url;

                if (typeof images[i].sizes.medium != 'undefined')
                      med = images[i].sizes.medium.url;
                else
                      med = images[i].sizes.full.url;


                if( typeof   temp.find('.ioa-minicolors').data('op') != "undefined" && temp.find('.ioa-minicolors').data('op')   )
                    op = true;

              temp.find(".module_head").prepend('<img src="' + thumb + '" />');
              temp.find(".module_head").addClass('has-thumb');  

              temp.find('.module_body').find('.image_thumb').val(thumb);
              temp.find('.module_body').find('.image_med').val(med);

              temp.find('.ioa-minicolors').minicolors('destroy');
              temp.find('.ioa-minicolors').minicolors(
              {
                    textfield: true,
                    opacity: false,
                    change: function(hex, opacity)
                    {

                      jQuery(this).parent().next().val(opacity);
                      jQuery(this).trigger('change');

                }

          });



              temp.find('.minicolors.minicolors-theme-default').wrap('<div class="ioa_input_holder"><div class="colorpicker-wrap"></div></div>');
              temp.find('.minicolors.minicolors-theme-default').parent().append("<a class='picker-delete' href=''></a>");


              var tar = temp.find('.'+bobj.data('target'));

              var img = temp.find('div.input-image-preview img');

              if(typeof images[0].sizes.medium == 'undefined')
                    img.attr('src', images[i].url);
              else
                    img.attr('src',  images[i].sizes.medium.url);

              img.show();
              img.parent().addClass('has-image');

              tar.val(images[i].id);


        }

  });
return;
}

mod.append(bl);


if( typeof   bl.find('.ioa-minicolors').data('op') != "undefined" && bl.find('.ioa-minicolors').data('op')   )
  op = true;

bl.find('.ioa-minicolors').minicolors('destroy');
bl.find('.ioa-minicolors').minicolors(
{
  textfield: true,
  opacity: op,
  change: function(hex, opacity)
  {

        jQuery(this).parent().next().val(opacity);
        jQuery(this).trigger('change');

  }

});
bl.find('.minicolors.minicolors-theme-default').wrap('<div class="ioa_input_holder"><div class="colorpicker-wrap"></div></div>');
bl.find('.minicolors.minicolors-theme-default').parent().append("<a class='picker-delete' href=''></a>");

bl.find(".ioa_input .ioa_slider").each(function()
{
   obj  = jQuery(this).parent().find("input");
   temp1 = obj.val();
   if (jQuery.trim(temp1) == "") temp1 = 0;
                        jQuery(this).slider(
                        {
                            value: parseInt(temp1),
                            min: 0,
                            range: "min",
                            max: parseInt(obj.data('max')),
                            step: parseInt(obj.data('steps')),
                            slide: function(event, ui)
                            {
                                jQuery(this).parent().find("input").val(ui.value);
                          }
                    });

                  });

mod.sortable(
{
  handle: '.module_head',
  stop: function(event, ui)
  {
        computeModuleData(ui.item.parents('div.ioa_module_container'));
  },
  start : function(e,ui){  jQuery(ui.helper).addClass('sorting') },
  stop : function(e,ui){  jQuery(this).children().removeClass('sorting') }
});

});


doc.on('click', 'a.add-multi-ioa-module', function(e)
{
  e.preventDefault();
  var mod = jQuery(this).parents('.ioa_module_container').find('div.module_list');
  var bl = jQuery(this).parents('.ioa_module_container').find('div.ioa_module.hide');
  bl = bl.clone().removeClass('hide');
  var op = false;
  hmedia.open('Add Image Icon', 'Add', function(images)
  {

        for (var i = 0; i < images.length; i++)
        {
              temp = bl.clone();
              mod.append(temp);

              if (typeof images[i].sizes.thumbnail != 'undefined')
                thumb = images[i].sizes.thumbnail.url;
          else
                thumb = images[i].sizes.full.url;

          if( typeof   temp.find('.ioa-minicolors').data('op') != "undefined" && temp.find('.ioa-minicolors').data('op')   )
              op = true;

        temp.find(".module_head").append('<img src="' + thumb + '" />');
        temp.find('.module_body').find('.image_thumb').val(thumb);
        clone.find(".module_head").addClass('has-thumb');  
        temp.find('.image, .logo_icon').val(images[i].id);

        temp.find('.ioa-minicolors').minicolors('destroy');
        temp.find('.ioa-minicolors').minicolors(
        {
              textfield: true,
              opacity: false,
              change: function(hex, opacity)
              {

                jQuery(this).parent().next().val(opacity);
                jQuery(this).trigger('change');

          }

    });
        temp.find('.minicolors.minicolors-theme-default').wrap('<div class="ioa_input_holder"><div class="colorpicker-wrap"></div></div>');
        temp.find('.minicolors.minicolors-theme-default').parent().append("<a class='picker-delete' href=''></a>");
  }

});


mod.sortable(
{
  handle: '.module_head',
  stop: function(event, ui)
  {
        computeModuleData(ui.item.parents('div.ioa_module_container'));
        jQuery(this).children().removeClass('sorting')
  },
  start : function(e,ui){  jQuery(ui.helper).addClass('sorting') }
});

});

doc.on('click', 'a.save-ioa-module', function(e)
{
  e.preventDefault();
  computeModuleData(jQuery(this).parents('div.ioa_module_container'));
  temp = jQuery(this);
  temp.html(temp.data('save'));
  setTimeout(function()
  {
        temp.html(temp.data('restore'));
  }, 500)
});

if (jQuery('div.module_list').length > 0)
  jQuery('div.module_list').sortable(
  {
        handle :  '.module_head',
        stop: function(event, ui)
        {
              computeModuleData(ui.item.parents('div.ioa_module_container'));
              jQuery(this).children().removeClass('sorting');
        },
        start : function(e,ui){  jQuery(ui.helper).addClass('sorting') }
  });

jQuery(document).on('click', 'div.module_head a.edit-mod', function(e)
{
  e.preventDefault();

  jQuery(this).parent().next().slideToggle('normal');

});

jQuery(document).on('click', 'div.module_head a.clone-mod', function(e)
{
  e.preventDefault();

  var op = false;
  temp = jQuery(this).parents('.ioa_module');

  obj = temp.clone();
  temp.after(obj);

  if( typeof   obj.find('.ioa-minicolors').data('op') != "undefined" && obj.find('.ioa-minicolors').data('op')   )
   op = true;

obj.find('.ioa-minicolors').minicolors({

      textfield: true,
      opacity: op,
      change: function(hex, opacity)
      {

            jQuery(this).parent().next().val(opacity);
            jQuery(this).trigger('change');

      }

});

var v;
obj.find('.ioa_input').each(function(){
  v = jQuery(this).find('input[type=text],textarea,select,input[type=hidden]');
  v.val(temp.find("." + v.attr('name')).val());
});

});

}

win.width = win.obj.width();
win.height = win.obj.height();



win.obj.load(function(){

     jQuery.material.init()

});

/* ============================================ */


var loader = {
  obj: jQuery('span.waiting'),
  show: function()
  {
       loader.obj.fadeIn('normal');
 },
 hide: function()
 {
       loader.obj.stop(true, true).fadeOut('fast');
 }
}

var hexDigits = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f");

//Function to convert hex format to a rgb color
function rgb2hex(rgb)
{

    if (rgb == "transparent" || jQuery.trim(rgb) == "" || !rgb) return "";

    rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);

    if (!rgb) return 'transparent';
    return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
}

function hex(x)
{
     return isNaN(x) ? "00" : hexDigits[(x - x % 16) / 16] + hexDigits[x % 16];
}


var obj, temp, i, j,SN = 'IOAPR';

    /**
    * Colorpicker for the framework with RGBA support
    */


    win.obj.load(function(){

        var op = false , IOA_color_lock = false, ioamin;
        jQuery('.ioa-minicolors').each(function()
        {
          op = false;
          ioamin = jQuery(this);

          if( typeof ioamin.data('op') != "undefined" && ioamin.data('op')   )
              op = true;


        ioamin.minicolors(
        {
              textfield: true,
              opacity: op,
              changeDelay:  1000,
              change: function(hex, opacity)
              {

                  if( IOA_color_lock === false)
                        jQuery(this).trigger('minicolor-change');

            },
            hide: function(hex, opacity)
            {

              jQuery(this).trigger('mini-hidden');

        },

  });

  });

  });



jQuery('.leap-admin-nav li a').click(function(e){
  e.preventDefault();
    jQuery('.leap-admin-nav li').removeClass('active');
    jQuery(this).parent().addClass('active');
    
    jQuery('.leap-admin-settings').children().hide();
    jQuery(jQuery(this).attr('href')).show();
});

    jQuery('.leap-admin-settings').children().hide();
        jQuery('.leap-admin-settings').children().first().show();


jQuery(document).on('click', 'a.delete-mod', function(e)
{
  e.preventDefault();
  var p = jQuery(this).parents('div.ioa_module_container');
  jQuery(this).parents('div.ioa_module').remove();
  computeModuleData(p);

});


function computeModuleData(parent)
{
  var code = '',
  temp;

  parent.find('div.module_list').children().each(function()
  {
        code += "[ioa_mod]";

        jQuery(this).find('div.ioa_input').each(function()
        {
              temp = jQuery(this);

              code += "[inp]" + temp.find('input,select,textarea').attr('name') + "[ioas]" + jQuery.trim(temp.find('input,select,textarea').val()) + "[ioas]";

              if( jQuery(this).find('input').hasClass('ioa-minicolors') )
              {
                   code += "[inp]" + temp.find('input,select,textarea').attr('name') + "_opacity[ioas]" + jQuery(this).find('.ioa-minicolors').minicolors('opacity') + "[ioas]";
             }

       });

  });

  parent.find('.mod_data').find('input').val(code);
  parent.find('.mod_data').find('input').trigger('change');
}


function ioa_selectOptionByText(selectElement, targetText)
{
  var $selectElement, $opts, $targetOption;

  $selectElement = jQuery(selectElement);
  $opts = $selectElement.find('option');
  $opts.removeAttr('selected');
  $targetOption = $opts.filter(
        function()
        {
              return jQuery(this).val() == targetText
        }
        );
  if (jQuery().prop)
  {
        $targetOption.prop('selected', true);
  }
  else
  {
        $targetOption.attr('selected', 'true');
  }
}



ioa_msg = {
  msg_block: jQuery(".ioa-message"),
  icon: jQuery(".ioa-message i"),
  setMessage: function(title)
  {

      ioa_msg.msg_block.find('div.ioa-message-body h3').html(title);
      ioa_msg.msg_block.find('div.ioa-message-body p').html('');
},
setMessage: function(title, message)
{

      ioa_msg.msg_block.find('div.ioa-message-body h3').html(title);
      ioa_msg.msg_block.find('div.ioa-message-body p').html(message);
},
setMessage: function(title, message, type)
{

      ioa_msg.msg_block.removeClass('ioa-error ioa-warning ioa-information ioa-success').addClass("ioa-" + type);
      switch (type)
      {
            case 'success':
            ioa_msg.icon.removeClass().addClass('ioa-front-icon checkicon-');
            break;
            case 'information':
            ioa_msg.icon.removeClass().addClass('ioa-front-icon  infoicon-');
            break;
            case 'error':
            ioa_msg.icon.removeClass().addClass('ioa-front-icon  cancel-circled-2icon-');
            break;
            case 'warning':
            ioa_msg.icon.removeClass().addClass('ioa-front-icon  attention-3icon-');
            break;
            case 'custom':
            ioa_msg.icon.removeClass().addClass('ioa-front-icon ' + type);
            break;
            default:
            ioa_msg.icon.removeClass().addClass('ioa-front-icon checkicon-');
      }
      ioa_msg.msg_block.css('display', 'none');
      ioa_msg.msg_block.find('div.ioa-message-body h3').html(title);
      ioa_msg.msg_block.find('div.ioa-message-body p').html(message);

},
setIconMessage: function(title, message, icon)
{

    ioa_msg.msg_block.removeClass('error warning information success').addClass("ioa-" + type);
    ioa_msg.icon.removeClass().addClass('ioa-front-icon ' + icon);
    ioa_msg.msg_block.css('display', 'none');
    ioa_msg.msg_block.find('div.ioa-message-body h3').html(title);
    ioa_msg.msg_block.find('div.ioa-message-body p').html(message);

},
show: function()
{

    ioa_msg.msg_block.hide();
    ioa_msg.msg_block.fadeIn('normal');
    setTimeout(function()
    {
      ioa_msg.msg_block.fadeOut('fast');
}, 3000);

},

showStatic: function()
{
    ioa_msg.msg_block.hide();
    ioa_msg.msg_block.fadeIn('normal');
},

hide: function()
{
    ioa_msg.msg_block.fadeOut('fast');
}

};

// Chat plugin code
                 

                var  chatbox  = jQuery('.clone-chat-tab').children() , setMetaDatalock = false; 
                  var input = jQuery('.leap-chat-box-footer--input') , canvas = jQuery('.leap-chat-box-body--canvas') , indicator = jQuery('.leap-chat-typing-indicator') , indicator_timer , indicator_lock = false ;    
                 var LEAP_CHAT = {

                                          status : 'done',
                                          message : '',
                                          flag : 'none',
                                          
                                          operator_id : '',
                                          operator_msg : '',
                                          operator_flag : '',
                                           timestamp : '',
                                           users : {   } ,
                                           
                                         current_user : '',
                                         lock : false,

                                         poller : false,
                                        pending : [],
                                        sendLock : false,
                                        pendingLock : false,
                                        pendingTimer : '',
                                        isPending:false,
                                        audio_notice : false,
                                        new_audio_notice : false,
                                       userpool : {},
                                          init : function(){

                                                      LEAP_CHAT.operator_id =   jQuery('.ioa-panel').data('operator');
                                                     LEAP_CHAT.setupVisitorTree();                         
                                                     LEAP_CHAT.listener();

                                                     if( jQuery('.leap-audio-notification').length > 0 ) { 

                                                        LEAP_CHAT.audio_notice  = new MediaElementPlayer('#leap-chat-audio',{
                                                          enableKeyboard: false
                                                        });

                                                        }

                                                          if( jQuery('.new-leap-audio-notification').length > 0 ) { 

                                                        LEAP_CHAT.new_audio_notice  = new MediaElementPlayer('#new-leap-chat-audio',{
                                                          enableKeyboard: false
                                                        });

                                                        }

                                                        jQuery.post(leap_listener_url,{

                                                                    type:'get-all-visitors' , 
                                                                    action: 'leap_chat_Listener', 

                                                           },function(data){
                                                            data = LEAP_CHAT.cleanMessages(data);

                                                            if(data=='') data = '{}';
                                                             data = JSON.parse(data);

                                                                       jQuery.each(data,function(index,node)       {

                                                                            if(node.user_id!='' && node.operator_id ===  LEAP_CHAT.operator_id  )
                                                                                    {
                                                                                              LEAP_CHAT.createNewThread(node.user_id,node.user_name,'reconnected') ;
                                                                                      }

                                                                            });

                                                                         setTimeout(function(){
                                                                                                          jQuery('.leap-tab-nav  li').removeClass('active');
                                                                                                            jQuery('.leap-tab-nav  li').last().addClass('active');
                                                                                                              LEAP_CHAT.current_user =  jQuery('.leap-tab-nav  li').last().find('a').data('id');
                                                                                            
                                                                                             if( jQuery('.leap-chat-tab-panel').children().length == 0 )
                                            jQuery('.leap-chat-tab-panel').html('<div class="leap-duh">'+leap_admin_localize.duh+' :(</div>');
                                                               
                                                                                  },1000);

                                                                     });

                                          },
                                        
                                        chatArchiver : function(message,timestamp){


                                                var archive = "";

                                                if(LEAP_CHAT.current_user!=''){

                                                  
                                                  if(LEAP_CHAT.checkRegistry(LEAP_CHAT.current_user+'-op-archive'))
                                                  {
                                                    archive =  LEAP_CHAT.getRegistry(LEAP_CHAT.current_user+'-op-archive');
                                                  }
                                                  
                                                  archive  += message;        
                                                  LEAP_CHAT.addLocalRegistry(LEAP_CHAT.current_user+'-op-archive',archive);
                                                  LEAP_CHAT.addLocalRegistry(LEAP_CHAT.current_user+'-op-timestamp',timestamp);
                                                }

                                              
                                                
                                              },

                                               /**
                                                    *
                                                    * Add to Cache 
                                                    *
                                                    **/
                                                    
                                                    addLocalRegistry : function(key,widget_string)
                                                    {

                                                            if(Modernizr.localstorage)
                                                            {
                                                                    localStorage.setItem(key,widget_string);
                                                            }

                                                    },

                                                    /**
                                                    *
                                                    * Check if Key exists
                                                    *
                                                    **/
                                                    
                                                    checkRegistry : function(key)
                                                    { 
                                                          
                                                            if( Modernizr.localstorage && localStorage.getItem(key) )
                                                                    return true;
                                                            else
                                                                    return false;
                                                    },

                                                    /**
                                                    *
                                                    * Get Data from cache
                                                    *
                                                    **/
                                                    
                                                    getRegistry : function(key)
                                                    {
                                                      if(Modernizr.localstorage)
                                                                  return localStorage.getItem(key);
                                                                else 
                                                                  return '';
                                                    } ,

                                        alertNewVistor : function(user) {



                                            if( typeof  LEAP_CHAT.userpool[user.user_id] !== "undefined" )
                                                return;


                                              LEAP_CHAT.userpool[user.user_id] = user;

                                               if(LEAP_CHAT.new_audio_notice) {
                                                      LEAP_CHAT.new_audio_notice.play();
                                                  }

                                                  ioa_msg.setMessage('New Visitor','You have a new vistor '+user.user_name,'information');
                                                  ioa_msg.show();

                                                    if( LEAP_CHAT.checkRegistry(user.user_id+'-op-archive') ) {
                                                                
                                                                      LEAP_CHAT.addLocalRegistry(user.user_id+'-op-archive',' ');
                                                                        LEAP_CHAT.addLocalRegistry(user.user_id+'-op-timestamp',' ');                                                           

                                                         }

                                                    LEAP_CHAT.desktopNotification('New Visitor','You have a new vistor '+user.user_name,5000);


                                        },

                                          setupVisitorTree : function(){

                                               var str = [],locked;

                                               jQuery.post(leap_listener_url,{

                                                        type:'get-all-visitors' , 
                                                        action: 'leap_chat_Listener', 

                                               },function(data){
data = LEAP_CHAT.cleanMessages(data);
 if(data=='') data = '{}';
                                                          data = JSON.parse(data);

                                                           jQuery.each(data,function(index,node)       {
                                                        
                                                                      if(index!='' )
                                                                        {
                                                                                
                                                                                    temp = '';
                                                                                     var status = ''; 
                                                                                    if(!node.user_name) 
                                                                                               node.user_name ='Visitor';

                                                                                      locked = '';
                                                                                      if(  node.flag =='new-connection') {

                                                                                                             status = 'Start Chat'; 
                                                                                                             temp = '<span>New !</span>';

                                                                                                             LEAP_CHAT.alertNewVistor(node);
                                                                                      }
                                                                                        else
                                                                                         {
                                                                                             if(node.operator_id !==  LEAP_CHAT.operator_id )
                                                                                                          locked = 'locked';
                                                                                         
                                                                                             if(node.operator_id ===  LEAP_CHAT.operator_id )
                                                                                                             status = 'Chatting'; 
                                                                                          
                                                                                               temp = '<span><i class="leap-font-icon icon-chat-empty "></i> '+node.operator_id+'</span>';
                                                                                         } 

                                                                                      if(node.user_name=='Visitor')
                                                                                       locked += ' visitor';   
                                                                                     
                                                                                     if(node.flag == 'disconnect')
                                                                                      {
                                                                                                       status = 'Left'; 
                                                                                           //          str.push( '<li class="offline">'+node.user_name+' <strong>'+temp+'</strong> <a href="'+node.user_id+'" data-name="'+node.user_name+'">'+status+'</a></li>');
                                                                                      }
                                                                                    else
                                                                                         str.push( '<li class="online '+locked+'">'+node.user_name+' <strong>'+temp+'</strong> <a href="'+node.user_id+'" data-name="'+node.user_name+'">'+status+'</a></li>');
                                                                        }     
                                                           });
                                                            jQuery('#leap-visitor-tree').html(str.join(''));
                                                            setTimeout( function(){
                                                                LEAP_CHAT.setupVisitorTree()
                                                            },4000);
                                               });
                                               

                                          },

                                          getDueMessages : function(){

                                                  if(LEAP_CHAT.lock || LEAP_CHAT.current_user =='') return;
                                                  var messages = [];
                                                  LEAP_CHAT.lock = true;
                                                  jQuery.post(leap_listener_url, { 
                                                         
                                                                type:'get-operator-messages' , 
                                                                action: 'leap_chat_Listener', 
                                                                'user_ids' :  LEAP_CHAT.users,
                                                                'timestamp' :  LEAP_CHAT.timestamp,


                                                              },function(data){
data = LEAP_CHAT.cleanMessages(data);
                                                                data = LEAP_CHAT.cleanMessages(data);
                                                                if(data === '')
                                                                {
                                                                  LEAP_CHAT.lock = false;
                                                                  return;
                                                                }
                                                                data = JSON.parse(data);

                                                                   jQuery.each(data,function(index,user){
                                                                            
                                                                                    if(user!=='')
                                                                                        {

                                                                                           if(user.messages == 'killed')
                                                                                           {
                                                                                                      
                                                                                                

                                                                                                      obj = jQuery("<div class='leap-chat-box-end'> "+leap_admin_localize.left+".</div>");
                                                                                                        canvas.append(obj);
                                                                                                        canvas[0].scrollTop = canvas[0].scrollHeight;
                                                                                                       LEAP_CHAT.current_user = '';
                                                                                           }
                                                                                           else
                                                                                                 LEAP_CHAT.setMessage(index,user.messages,user.user_flag);       
                                                                                        } 

                                                                                   if(index === LEAP_CHAT.current_user && ! LEAP_CHAT.users[index].meta )    
                                                                                     {
                                                                                             LEAP_CHAT.setMetaData(index);
                                                                                     }

                                                                   });

                                                                      LEAP_CHAT.lock = false;

                                                                       
                                                              });
                                                  
                                                },

                                          listener : function(){

                                                LEAP_CHAT.poll(function(){ 
                                                      
                                                             LEAP_CHAT.getDueMessages();
                                                                                                      
                                                      return false;

                                                } ,  2000); 

                                          },

                                          setMessage : function(userid,messages,status){
                                                          
                                                          var m = [],istyping = false,rw = [];
                                                          canvas =  jQuery('#user-thread-'+userid).find('.leap-chat-box-body--canvas');
                                                          indicator_lock = false;

                                                          if(typeof LEAP_CHAT.users[userid].user_name == "undefined") return;

                                                           var currentdate = new Date(), time = "<small>" + formatAMPM(currentdate) + "</small>",label = "<span>"+LEAP_CHAT.users[userid].user_name+"</span>";
                                                          if(canvas.children().last().hasClass('leap-chat-box-user-wrap'))
                                                          {
                                                            label = '';
                                                            time = '';
                                                          }

                                                          if(status && status!=='' && userid == LEAP_CHAT.current_user && LEAP_CHAT.users[LEAP_CHAT.current_user].user_flag !== status ) {

                                                                         if(indicator_timer)
                                                                        {
                                                                              clearTimeout(indicator_timer);
                                                                        }
                                                                         

                                                                          indicator.css("opacity",1).html(leap_admin_localize.is_typing+'... ('+status+')');
                                                                           LEAP_CHAT.users[LEAP_CHAT.current_user].user_flag = status;

                                                                          indicator_timer = setTimeout(function(){
                                                                              indicator.css("opacity",0);
                                                                          },8000);
                                                          }
                                                      
                                                        if( jQuery.trim(messages) ==="" || typeof messages!=='object' ) return;

                                                        jQuery.each(messages,function(index,msg){
                                                                          if(msg =='' || ! msg) return;
                                                                         
                                                                         LEAP_CHAT.users[userid].timestamp = index;

                                                                           m.push("<div class='leap-chat-box-user-msg '>"+msg+"</div>");
                                                                          rw.push(""+msg+" \n");
                                                                    
                                                                        istyping = false;
                                                                        indicator_lock = true;
                                                        });
                                                                   
                                                                   if(!indicator_lock) return;

                                                                   var block = jQuery("<div class='leap-chat-box-user-wrap '>"+label+time+m.join('')+"</div>");
                                                                       indicator.css("opacity",0);
                                                                  if( ifvisible.now('hidden') ){
                                                                                                    LEAP_CHAT.desktopNotification('Message From '+LEAP_CHAT.users[userid].user_name,rw.join(''),2000);
                                                                                  }

                                                                   block.find('a').attr('target','_BLANK');

                                                                      canvas.append(block);
                                                                        LEAP_CHAT.chatArchiver("<div class='leap-chat-box-user-wrap '>"+label+time+m.join('')+"</div>",LEAP_CHAT.users[userid].timestamp);

                                                                       LEAP_CHAT.smiley(block);
                                                                       canvas[0].scrollTop = canvas[0].scrollHeight;

                                                                       if(LEAP_CHAT.audio_notice) {
                                                                            LEAP_CHAT.audio_notice.play();
                                                                        }



                                                                        if(userid != LEAP_CHAT.current_user)
                                                                        {
                                                                                var link =  jQuery('.leap-tab-nav').find('.'+userid).next('span');
                                                                                if(link.html() == '')
                                                                                        link.html('1');
                                                                                      else
                                                                                        link.html(parseInt(link.html())+1);
                                                                                link.css("display","block");
                                                                        }

                                          },

                                          createNewThread : function(userid,name,status){
                                                    

                                                         if(status =='connected' && obj instanceof jQuery)
                                                                           obj.html(leap_admin_localize.connecting);
                                                                         
                                                         jQuery.post(leap_listener_url, { 
             
                                                                                  type:'set_user_status' , 
                                                                                  action: 'leap_chat_Listener', 
                                                                                  'user_id' :  userid,
                                                                                  'operator_id' :  LEAP_CHAT.operator_id,
                                                                                  'operator_uid' :  jQuery('.ioa-panel').data('uid'),
                                                                                  'status' :  status,

                                                                                },function(data){
                                                                                
                                                                    data = LEAP_CHAT.cleanMessages(data);
                                                                                     if(status =='connected' && obj instanceof jQuery){ 
                                                                                obj.html(leap_admin_localize.connected);
                                                                                obj.prev().remove();
                                                                              }

                                                                              jQuery('.leap-chat-tab-panel').find('.leap-duh').remove();

                                                                                    jQuery('.leap-chat-tab-panel').find('.leap-chat-tab-panel').remove();
                                                                                     jQuery('.leap-chat-tab-panel').children().hide();

                                                                                     if( jQuery('#user-thread-'+userid).length >0 )
                                                                                     {
                                                                                          jQuery('#user-thread-'+userid).show();
                                                                                     }
                                                                                     else
                                                                                     {
                                                                                          temp = chatbox.clone();
                                                                                          temp.attr('id','user-thread-'+userid);
                                                                                       
                                                                                          jQuery('.leap-chat-tab-panel').append(temp);
                                                                                          jQuery('.leap-tab-nav ul').append("<li class='active'><a class='"+userid+"' data-id='"+userid+"' href='#user-thread-"+userid+"'>"+name+"</a><span></span></li>");
                                                                                 

                                                                                     }  
                                                                                    
                                                                                    canvas =  jQuery('#user-thread-'+userid).find('.leap-chat-box-body--canvas');
                                                                                    input = jQuery('#user-thread-'+userid).find('.leap-chat-box-footer--input');
                                                                                     indicator = canvas.parent().find('.leap-chat-typing-indicator'); 
                                                                                     
                                                                                     if(typeof LEAP_CHAT.users['userid']=== 'undefined')
                                                                                              LEAP_CHAT.users[userid] = {
                                                                                                   user_msg : '',
                                                                                                    user_id : userid,
                                                                                                    user_name : name,
                                                                                                    user_time : '',
                                                                                                    message_stamp : '',
                                                                                                    user_data : false,
                                                                                                    timestamp : '',
                                                                                                    op_typing : '',
                                                                                                    user_typing : '',
                                                                                                    flag:'',
                                                                                                    meta : false
                                                                                                  }; 

                                                                                     


                                                                                     if( LEAP_CHAT.checkRegistry(userid+'-op-archive') ) {

                                                                                              archive =  LEAP_CHAT.getRegistry(userid+'-op-archive');

                                                                                              canvas.prepend(archive);
                                                                                              LEAP_CHAT.users[userid].timestamp = LEAP_CHAT.getRegistry(userid+'-op-timestamp');
                                                                                              canvas[0].scrollTop = canvas[0].scrollHeight;

                                                                                     }

                                                                                     LEAP_CHAT.operator_flag = 'assigned'; 
                                                                                      LEAP_CHAT.setMetaData(userid);
                                                                                      canvas[0].scrollTop = canvas[0].scrollHeight;

                                                        });
                                          },

                                          setMetaData  : function(userid){

                                                                  if(setMetaDatalock) return;

                                                                  setMetaDatalock = true;
                                                                 jQuery.post(leap_listener_url,{
                                                                                user_id : userid,
                                                                                 type:'get-user-metadata' , 
                                                                                action: 'leap_chat_Listener', 

                                                                    },function(data){
                                                                     data = LEAP_CHAT.cleanMessages(data);
                                                                    setMetaDatalock = false;
                                                                     if(data=='') return;



                                                                      var userdata = JSON.parse(data);
                                                                       if(!userdata && typeof userdata !== 'object' ) 
                                                                       {
                                                                                  return;
                                                                       }

                                                               LEAP_CHAT.users[userid].user_data =  userdata;
                                                               LEAP_CHAT.users[userid].meta = true;



                                                                   var i =0,str=[] , parent =    jQuery('#user-thread-'+userid).find('.leap-chat-box-user-info');

                                                                                for(i=0;i<userdata.data.length;i++)
                                                                                {
                                                                                  str[i] = "<li class='clearfix'><strong> "+userdata.data[i].name+":</strong> <span>"+userdata.data[i].value+"</span></li>";
                                                                                }
                                                                                
                                                                                 parent.find('.meta-data ').html(str.join(''));
                                                                              
                                                                               str = [];

                                                                                if( userdata.location && userdata.location !== "" && typeof userdata.location === 'object')
                                                                                {
                                                                                              jQuery.each(userdata.location,function(v,k){
                                                                                                    str.push("<li class='clearfix'><strong> "+v+":</strong>  <span>"+k+" </span></li>");
                                                                                                });

                                                                                                   parent.find('.location-data ').html(str.join(''));
                                                                                }
                                                                                else
                                                                                {
                                                                                          parent.find('.location-data ').html('<li class="leap-nav-na">'+leap_admin_localize.na+'</li>');
                                                                                }

                                                                                str = [];

                                                                                jQuery.each(userdata.technical,function(v,k){
                                                                           
                                                                                    str.push("<li class='clearfix'><strong> "+v+":</strong>  <span>"+k+" </span></li>");
                                                                                  
                                                                                })

                                                                                   parent.find('.technical-data').html(str.join(''));

                                                                                     });


                                          },

                                          desktopNotification: function(title,message,time) {

                                                if (!("Notification" in window)) {
                                                  return;
                                                }
                                                else if (Notification.permission === "granted") {
                                                     var notification = new Notification(title,{ body : message , icon : jQuery('.ioa-panel').data('logo') });
                                                           setTimeout(function(){ notification.close();  },time);
                                                }
                                                else if (Notification.permission !== 'denied') {

                                                  Notification.requestPermission(function (permission) {
                                                
                                                    if (permission === "granted") {


                                                           var notification = new Notification(title,{ body : message , icon : jQuery('.ioa-panel').data('logo') });
                                                           setTimeout(function(){ notification.close();  },time);
                                                    }

                                                  });
 
                                                }

                                                // At last, if the user has denied notifications, and you 
                                                // want to be respectful there is no need to bother them any more.
                                              },

                                          smiley : function(obj){

                                                              if(typeof window.wp.emoji === "undefined") return;

                                                               jQuery.post(leap_listener_url, { 
                                                                   
                                                                            type:'translate_smiley' , 
                                                                            action: 'leap_chat_Listener', 
                                                                            'text' : obj.html(),

                                                                          },function(data){
                                                                              data = LEAP_CHAT.cleanMessages(data);
                                                                                if(data!='')
                                                                                {
                                                                                    obj.html(window.wp.emoji.parse(data) ); 
                                                                                }                                                                

                                                                }); 

                                                            },

                                              poll : function(fn,  interval) {

                                                  (function p() {
                                                          
                                                          if(fn()) {
                                                          //    callback();
                                                          }
                                                          else {
                                                              setTimeout(p, interval);
                                                          }
                                                   
                                                  })();
                                              },


                                              ajaxSend : function(message,userid){
                                                LEAP_CHAT.sendLock = true;
                                                jQuery.post(leap_listener_url,{
                                                                    user_id : userid ,
                                                                    message : message,
                                                                    operator_flag : '',
                                                                    type: "set-operator-message",
                                                                    action: 'leap_chat_Listener'

                                                                                            },function(data){
                                                                                                data = LEAP_CHAT.cleanMessages(data);
                                                                                                    setTimeout(function(){ LEAP_CHAT.sendLock = false; },1000);
                                                                                            }); 

                                            },
                                          cleanMessages: function(message) { 
                                                var msg = message;
                                                if(msg=='false' || msg===false ) msg = '';
                                                msg = jQuery.trim(msg);
                                                return msg;
                                              },    
                                          sendPendingMessages: function(userid){

                                                if(LEAP_CHAT.pendingLock) return; // Wait for earlier messags to be delivered
                                              
                                                LEAP_CHAT.pendingLock = true;
                                                LEAP_CHAT.sendLock = true;
                                                
                                               
                                            
                                                LEAP_CHAT.pendingTimer = setInterval(function(){

                                                        if(! LEAP_CHAT.isPending){

                                                           var msg = LEAP_CHAT.pending;
                                                              LEAP_CHAT.pending = [];
                                                          LEAP_CHAT.sendLock = true;
                                                           LEAP_CHAT.isPending = true; 

                                                            jQuery.post(leap_listener_url,{
                                                                        user_id : userid,
                                                                        message : msg,
                                                                        type: "set-operator-message",
                                                                        action: 'leap_chat_Listener'

                                                                    },function(data){
                                                                        data = LEAP_CHAT.cleanMessages(data);
                                                                            LEAP_CHAT.sendLock = false; 
                                                                        LEAP_CHAT.pendingLock = false;
                                                                        LEAP_CHAT.isPending = false;
                                                                        
                                                                        clearInterval(LEAP_CHAT.pendingTimer);

                                                                        if(LEAP_CHAT.pending.length > 0)
                                                                            LEAP_CHAT.sendPendingMessages(userid);
                                                                    });

                                                            
                                                            

                                                        }

                                                },1000);

                                            },
                                                sendMessage : function(userid, fp){

                                                     LEAP_CHAT.operator_flag = '';
                                                     LEAP_CHAT.operator_msg = input.val();

                                                     if(typeof(fp)!=="undefined")
                                                           LEAP_CHAT.operator_msg = fp; 

                                                    if(LEAP_CHAT.operator_msg =='') return; 



                                                    if(LEAP_CHAT.sendLock || LEAP_CHAT.pending.length > 0)
                                                    {

                                                        LEAP_CHAT.pending.push(LEAP_CHAT.operator_msg);
                                                        LEAP_CHAT.sendPendingMessages(userid);
                                                    }
                                                    else
                                                        LEAP_CHAT.ajaxSend(LEAP_CHAT.operator_msg,userid);

                                                       var currentdate = new Date();
                                                      var time = "<small>" + formatAMPM(currentdate) + "</small>";
                                                      var label = "<span>"+  LEAP_CHAT.operator_id+"</span>";
                                                      if(canvas.children().last().hasClass('leap-chat-box-operator-msg'))
                                                      {
                                                                  label = '';
                                                                 time = '';
                                                      }

                                                    obj = jQuery("<div class='leap-chat-box-operator-msg'>"+label+LEAP_CHAT.operator_msg+time+"</div>");
                                                     canvas.append(obj);

                                                     if(typeof LEAP_CHAT.users[userid]  !== "undefined" && typeof LEAP_CHAT.users[userid].timestamp !== "undefined")
                                                      LEAP_CHAT.chatArchiver("<div class='leap-chat-box-operator-msg'>"+label+LEAP_CHAT.operator_msg+time+"</div>",LEAP_CHAT.users[userid].timestamp);

                                                    LEAP_CHAT.smiley(obj);

                                                    input.val('');
                                                    input.focus();
                                                    canvas[0].scrollTop = canvas[0].scrollHeight;

                                                    

                                                  },

                                    }

                      
                             doc.on('keydown','.leap-chat-box-footer--input',function(e){
                           if (e.keyCode == 13) {
                                    LEAP_CHAT.sendMessage(LEAP_CHAT.current_user);
                                    return false;
                                 }

                        });
                   
                         doc.on('click','.leap-chat-box-footer--send',function(e){
                              e.preventDefault();
                            
                             LEAP_CHAT.sendMessage(LEAP_CHAT.current_user);

                        });

                       doc.on('click','.leap-chat-box-footer--attach',function(e){

                              atmedia.open('Attach File','Add', function(files)
                              {

                                    if(typeof files[0] === "undefined") return;


                                   var message = "<a class='leap-attachment' href='"+files[0].url+"' title='"+files[0].filename+"' target='_BLANK'>"+files[0].title+"</a>";
                                   LEAP_CHAT.sendMessage(LEAP_CHAT.current_user,message);
                           });


                                e.preventDefault();
                            });


                    
                           

                           var keyinterval = false;
                                  doc.on('keypress','.leap-chat-box-footer--input',function(e){
                              
                              if(keyinterval) clearTimeout(keyinterval);

                               var  val = jQuery(this).val() ,qar =  val.length , parent = jQuery(this);
                             if(qar > 5 && ! LEAP_CHAT.sendLock && e.keyCode != 13)
                             {
                              
                              keyinterval = setTimeout(function(){

                                LEAP_CHAT.sendLock = true;
                                           jQuery.post(leap_listener_url,{
                                                        user_id : LEAP_CHAT.current_user ,
                                                        message : parent.val(),
                                                       type: "set-operator-typing",
                                                        action: 'leap_chat_Listener'

                                                    },function(data){
                                                        data = LEAP_CHAT.cleanMessages(data);
                                                         LEAP_CHAT.sendLock = false; 
                                            }); 

                              },1500)

                             }


                        });

                           jQuery('#leap-purge-cache').click(function(e){
                                      e.preventDefault();
                                      loader.show();
                                      jQuery.post(   leap_listener_url , {

                                                   type: "purge-cache",
                                                   action: 'leap_chat_Listener'

                                   } , function(data){
                                  data = LEAP_CHAT.cleanMessages(data);
                                  loader.hide();
                                  ioa_msg.setMessage(leap_admin_localize.cache_title, leap_admin_localize.cache_desc,'success');
                                               ioa_msg.show();
                                                                                
                                   });

                           });

                                jQuery('#leap-purge-analytics').click(function(e){
                                      e.preventDefault();
                                      loader.show();
                                      jQuery.post(   leap_listener_url , {

                                                   type: "purge-analytics",
                                                   action: 'leap_chat_Listener'

                                   } , function(data){
                                  data = LEAP_CHAT.cleanMessages(data);
                                  loader.hide();
                                  ioa_msg.setMessage('Analytics Deleted !','All data has been removed succcessfully.','success');
                                               ioa_msg.show();
                                                                                
                                   });

                           });


                                 jQuery('#leap-purge-archive').click(function(e){
                                      e.preventDefault();
                                      loader.show();
                                      jQuery.post(   leap_listener_url , {

                                                   type: "purge-archives",
                                                   action: 'leap_chat_Listener'

                                   } , function(data){
                                  data = LEAP_CHAT.cleanMessages(data);
                                  loader.hide();
                                  ioa_msg.setMessage('Archives Deleted !','All data has been removed succcessfully.','success');
                                               ioa_msg.show();
                                                                                
                                   });

                           });


                     doc.on('click','#leap-visitor-tree li a',function(e){
                                  e.preventDefault();

                                  obj = jQuery(this);

                                  if(  obj.parent().hasClass('locked') )
                                   {
                                                ioa_msg.setMessage(leap_admin_localize.ochat_title, leap_admin_localize.ochat_desc ,'error');
                                               ioa_msg.show();
                                                return;
                                   }         


                                  LEAP_CHAT.createNewThread(obj.attr('href'),obj.data('name'),'connected') ;
                                    LEAP_CHAT.current_user = obj.attr('href');
                                    setTimeout(function(){
                                              jQuery("#user-thread-"+LEAP_CHAT.current_user).parent().addClass('active');
                                    },500);
                      });

                    doc.on('click','.leap-chat-box-close',function(e){
                             
                                e.preventDefault();
                                var parent = jQuery(this).parent();
                               loader.show();

                                jQuery('a[href=#'+parent.attr('id')+']').parent().remove();
                                jQuery(parent).remove();
                                   loader.hide();

                                  if( jQuery('.leap-chat-tab-panel').children().length == 0 )
                                            jQuery('.leap-chat-tab-panel').html('<div class="leap-duh">'+leap_admin_localize.duh+' :(</div>');

                    }); 


                       doc.on('click','.leap-chat-box-session-close',function(e){
                             
                                e.preventDefault();
                                var parent = jQuery(this).parent();
                               loader.show();
                                ioa_msg.setMessage(leap_admin_localize.end_con_title,leap_admin_localize.end_con_desc);
                                 ioa_msg.show();

                               jQuery.post(   leap_listener_url , {

                                                   type: "kill_session",
                                                    user_id:  LEAP_CHAT.current_user,
                                                   action: 'leap_chat_Listener',
                                                   chat_log : canvas.html()

                                   } , function(data){
                                    data = LEAP_CHAT.cleanMessages(data);
                                            delete LEAP_CHAT.users[LEAP_CHAT.current_user];

                                                obj = jQuery("<div class='leap-chat-box-end'> "+leap_admin_localize.disconnected+".</div>");
                                                     canvas.append(obj);

                                                        //   delete LEAP_CHAT.users[LEAP_CHAT.current_user];
                                                             delete  LEAP_CHAT.userpool[LEAP_CHAT.current_user] ;

                                                           LEAP_CHAT.current_user = '';
                                           loader.hide();



                                   });


                    }); 

                     doc.on('click','.leap-tab-nav ul li a ',function(e){
                                  e.preventDefault();
                                  jQuery('.leap-tab-nav ul li').removeClass('active');
                                   jQuery('.leap-chat-tab-panel').children().hide();

                                    jQuery(this).next().html('0');
                                   jQuery(this).next().hide();

                                   jQuery(jQuery(this).attr('href')).show();
                                   jQuery(this).parent().addClass('active');

                                    LEAP_CHAT.current_user = jQuery(this).data('id');
                                   var parent = jQuery('#user-thread-'+LEAP_CHAT.current_user);

                                     canvas =  parent.find('.leap-chat-box-body--canvas');
                                     input = parent.find('.leap-chat-box-footer--input');
                                     indicator = canvas.parent().find('.leap-chat-typing-indicator'); 
                                
                      });

                       //  if( jQuery('.leap-chat-body').length > 0 )
                        LEAP_CHAT.init();

                             if (("Notification" in window)) {
                                             
                                                 if (Notification.permission !== 'denied') {

                                                  Notification.requestPermission(function (permission) {   });

                                                }

                                  }

                                            

                        jQuery('.leap-archive-item h6 a ').click(function(e){
                                e.preventDefault();
                                temp = jQuery(this).parent().next();
                                jQuery('.leap-analytics-table-content').html(temp.html());

                        });
        


        jQuery('.save_leap_settings').click(function(e){
                  e.preventDefault();

                  loader.show();
                     var options = [];

                        jQuery('.leap-chat-settings').find('.ioa_input').each(function(j)
                        {

                                                var inp = jQuery(this).find('input[type=text],textarea,select,input[type=checkbox],input[type=hidden]') , val = inp.val();

                                                   if( inp.is(':checkbox') )
                                                      {

                                                        str = [];
                                                        jQuery(this).find('input[type=checkbox]').each(function(l){

                                                            if( jQuery(this).is(':checked') )
                                                              str[l]= jQuery(this).val();
                                                        });
                                                        val = str.join(',');
                                                      }

                                                options[j] = {
                                                                        name: inp.attr('name'),
                                                                        value: val
                                                };

                        });

                          jQuery.post(   leap_listener_url , {

                                                   type: "options_save",
                                                    options:  options,
                                                   action: 'leap_chat_Listener'

                                   } , function(data){
                                            data = LEAP_CHAT.cleanMessages(data);
                                          ioa_msg.setMessage(leap_admin_localize.options_title,leap_admin_localize.options_desc);
                                           ioa_msg.show();
                                           loader.hide();

                                   })

        });               

    function formatAMPM(date) {
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var ampm = hours >= 12 ? 'pm' : 'am';
    hours = hours % 12;
    hours = hours ? hours : 12; // the hour '0' should be '12'
    minutes = minutes < 10 ? '0'+minutes : minutes;
    var strTime = hours + ':' + minutes + ' ' + ampm;
    return strTime;
  }


});

(function(){!function(a,b){return"function"==typeof define&&define.amd?define(function(){return b()}):"object"==typeof exports?module.exports=b():a.ifvisible=b()}(this,function(){var a,b,c,d,e,f,g,h,i,j,k,l,m,n;return i={},c=document,k=!1,l="active",g=6e4,f=!1,b=function(){var a,b,c,d,e,f,g;return a=function(){return(65536*(1+Math.random())|0).toString(16).substring(1)},e=function(){return a()+a()+"-"+a()+"-"+a()+"-"+a()+"-"+a()+a()+a()},f={},c="__ceGUID",b=function(a,b,d){return a[c]=void 0,a[c]||(a[c]="ifvisible.object.event.identifier"),f[a[c]]||(f[a[c]]={}),f[a[c]][b]||(f[a[c]][b]=[]),f[a[c]][b].push(d)},d=function(a,b,d){var e,g,h,i,j;if(a[c]&&f[a[c]]&&f[a[c]][b]){for(i=f[a[c]][b],j=[],g=0,h=i.length;h>g;g++)e=i[g],j.push(e(d||{}));return j}},g=function(a,b,d){var e,g,h,i,j;if(d){if(a[c]&&f[a[c]]&&f[a[c]][b])for(j=f[a[c]][b],g=h=0,i=j.length;i>h;g=++h)if(e=j[g],e===d)return f[a[c]][b].splice(g,1),e}else if(a[c]&&f[a[c]]&&f[a[c]][b])return delete f[a[c]][b]},{add:b,remove:g,fire:d}}(),a=function(){var a;return a=!1,function(b,c,d){return a||(a=b.addEventListener?function(a,b,c){return a.addEventListener(b,c,!1)}:b.attachEvent?function(a,b,c){return a.attachEvent("on"+b,c,!1)}:function(a,b,c){return a["on"+b]=c}),a(b,c,d)}}(),d=function(a,b){var d;return c.createEventObject?a.fireEvent("on"+b,d):(d=c.createEvent("HTMLEvents"),d.initEvent(b,!0,!0),!a.dispatchEvent(d))},h=function(){var a,b,d,e,f;for(e=void 0,f=3,d=c.createElement("div"),a=d.getElementsByTagName("i"),b=function(){return d.innerHTML="<!--[if gt IE "+ ++f+"]><i></i><![endif]-->",a[0]};b(););return f>4?f:e}(),e=!1,n=void 0,"undefined"!=typeof c.hidden?(e="hidden",n="visibilitychange"):"undefined"!=typeof c.mozHidden?(e="mozHidden",n="mozvisibilitychange"):"undefined"!=typeof c.msHidden?(e="msHidden",n="msvisibilitychange"):"undefined"!=typeof c.webkitHidden&&(e="webkitHidden",n="webkitvisibilitychange"),m=function(){var b,d;return b=!1,d=function(){return clearTimeout(b),"active"!==l&&i.wakeup(),f=+new Date,b=setTimeout(function(){return"active"===l?i.idle():void 0},g)},d(),a(c,"mousemove",d),a(c,"keyup",d),a(window,"scroll",d),i.focus(d),i.wakeup(d)},j=function(){var b;return k?!0:(e===!1?(b="blur",9>h&&(b="focusout"),a(window,b,function(){return i.blur()}),a(window,"focus",function(){return i.focus()})):a(c,n,function(){return c[e]?i.blur():i.focus()},!1),k=!0,m())},i={setIdleDuration:function(a){return g=1e3*a},getIdleDuration:function(){return g},getIdleInfo:function(){var a,b;return a=+new Date,b={},"idle"===l?(b.isIdle=!0,b.idleFor=a-f,b.timeLeft=0,b.timeLeftPer=100):(b.isIdle=!1,b.idleFor=a-f,b.timeLeft=f+g-a,b.timeLeftPer=(100-100*b.timeLeft/g).toFixed(2)),b},focus:function(a){return"function"==typeof a?this.on("focus",a):(l="active",b.fire(this,"focus"),b.fire(this,"wakeup"),b.fire(this,"statusChanged",{status:l}))},blur:function(a){return"function"==typeof a?this.on("blur",a):(l="hidden",b.fire(this,"blur"),b.fire(this,"idle"),b.fire(this,"statusChanged",{status:l}))},idle:function(a){return"function"==typeof a?this.on("idle",a):(l="idle",b.fire(this,"idle"),b.fire(this,"statusChanged",{status:l}))},wakeup:function(a){return"function"==typeof a?this.on("wakeup",a):(l="active",b.fire(this,"wakeup"),b.fire(this,"statusChanged",{status:l}))},on:function(a,c){return j(),b.add(this,a,c)},off:function(a,c){return j(),b.remove(this,a,c)},onEvery:function(a,b){var c,d;return j(),c=!1,b&&(d=setInterval(function(){return"active"===l&&c===!1?b():void 0},1e3*a)),{stop:function(){return clearInterval(d)},pause:function(){return c=!0},resume:function(){return c=!1},code:d,callback:b}},now:function(a){return j(),l===(a||"active")}}})}).call(this);


/* Modernizr 2.7.1 (Custom Build) | MIT & BSD
 * Build: http://modernizr.com/download/#-localstorage-sessionstorage-webworkers
 */
;window.Modernizr=function(a,b,c){function t(a){i.cssText=a}function u(a,b){return t(prefixes.join(a+";")+(b||""))}function v(a,b){return typeof a===b}function w(a,b){return!!~(""+a).indexOf(b)}function x(a,b,d){for(var e in a){var f=b[a[e]];if(f!==c)return d===!1?a[e]:v(f,"function")?f.bind(d||b):f}return!1}var d="2.7.1",e={},f=b.documentElement,g="modernizr",h=b.createElement(g),i=h.style,j,k={}.toString,l={},m={},n={},o=[],p=o.slice,q,r={}.hasOwnProperty,s;!v(r,"undefined")&&!v(r.call,"undefined")?s=function(a,b){return r.call(a,b)}:s=function(a,b){return b in a&&v(a.constructor.prototype[b],"undefined")},Function.prototype.bind||(Function.prototype.bind=function(b){var c=this;if(typeof c!="function")throw new TypeError;var d=p.call(arguments,1),e=function(){if(this instanceof e){var a=function(){};a.prototype=c.prototype;var f=new a,g=c.apply(f,d.concat(p.call(arguments)));return Object(g)===g?g:f}return c.apply(b,d.concat(p.call(arguments)))};return e}),l.localstorage=function(){try{return localStorage.setItem(g,g),localStorage.removeItem(g),!0}catch(a){return!1}},l.sessionstorage=function(){try{return sessionStorage.setItem(g,g),sessionStorage.removeItem(g),!0}catch(a){return!1}},l.webworkers=function(){return!!a.Worker};for(var y in l)s(l,y)&&(q=y.toLowerCase(),e[q]=l[y](),o.push((e[q]?"":"no-")+q));return e.addTest=function(a,b){if(typeof a=="object")for(var d in a)s(a,d)&&e.addTest(d,a[d]);else{a=a.toLowerCase();if(e[a]!==c)return e;b=typeof b=="function"?b():b,typeof enableClasses!="undefined"&&enableClasses&&(f.className+=" "+(b?"":"no-")+a),e[a]=b}return e},t(""),h=j=null,e._version=d,e}(this,this.document);
