/**
 *
 * Contains Code for the LEAP JS Plugin 
 *
 */


 jQuery(function(){

    var chat_box  = jQuery('.leap-chat-box') , input = chat_box.find('.leap-chat-box-footer--input') , canvas = chat_box.find('.leap-chat-box-body--canvas') , indicator = chat_box.find('.leap-chat-typing-indicator') , indicator_timer , indicator_lock = false ;      
        
var checker ;
    var LEAP_CHAT = {

                    status : 'new-connection',
                                  message : '',
                                  message_stamp : '',
                                  
                                  user_msg : '',
                                  user_id : '',
                                  user_flag : '',
                                  user_name: '',
                                  user_data : [],
                                  reconnected : false,
                                  operator_id : '',
                                  audio_notice : false,
                     runOnce : true,    
                     lock : false,
                     poller : false,
                    pending : [],
          sendLock : false,
          isPending : false,
        pendingLock : false,
          pendingTimer : '',
                     timestamp: '',
                     operator_flag : '',
                     effect : {  user : 'bounceInRight' , operator : 'bounceInLeft'  },


        setup: function(){

            if(chat_box.length === 0) return;
            
            LEAP_CHAT.user_id = LEAP_CHAT.uniqueid();

            if( typeof chat_box.data('usereffect') !== "undefined"  )
                LEAP_CHAT.effect.user =  chat_box.data('usereffect');

            if( typeof chat_box.data('operatoreffect') !== "undefined"  )
                LEAP_CHAT.effect.operator =  chat_box.data('operatoreffect');

            if( ! LEAP_CHAT.checkRegistry('leap-id'))
            {
                LEAP_CHAT.addLocalRegistry('leap-id',LEAP_CHAT.user_id);
            }
            else
            {
                LEAP_CHAT.user_id =  LEAP_CHAT.getRegistry('leap-id');
            }


            jQuery('#leap-chat').attr('id',LEAP_CHAT.user_id);

            if( jQuery('.leap-audio-notification').length > 0 ) { 

            LEAP_CHAT.audio_notice  = new MediaElementPlayer('#leap-chat-audio',{
                enableKeyboard: false
            });

            }

            if( ! chat_box.hasClass('leap-is-offline')  )
            LEAP_CHAT.checkUserThread();
            
        },
        checkUserThread : function(){

             jQuery.ajax(leap_listener_url, { 
                            data : {
                              type:'user_status' , 
                              action: 'leap_chat_Listener', 
                              'user_id' :  LEAP_CHAT.user_id,
                            },
                         
                              method:"POST",
                             
                            success :  function(data){
                                      data = LEAP_CHAT.cleanMessages(data);
                                          if(data!='' && data!='none'){
                                            LEAP_CHAT.status = data;

                                            if( LEAP_CHAT.user_name==''  &&  LEAP_CHAT.checkRegistry('leap-name'))
                        {
                            LEAP_CHAT.user_name =  LEAP_CHAT.getRegistry('leap-name');
                            
                        }


                        data = 'connected';
                                            if(data == 'disconnect' || data == 'connected')
                                            {
                                                chat_box.removeClass('leap-hide-chat');
                                                LEAP_CHAT.status = 'connected';
                                                LEAP_CHAT.reconnected = true;
                                                LEAP_CHAT.setupConnection();
                                            }

                                          }    


                            }  ,
                              complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                   

                                 }

                              }                                         

                  });

        },

        chatArchiver : function(message,timestamp){


            var archive = "";

            if(LEAP_CHAT.user_id!=''){

                
                if(LEAP_CHAT.checkRegistry(LEAP_CHAT.user_id+'-archive'))
                {
                    archive =  LEAP_CHAT.getRegistry(LEAP_CHAT.user_id+'-archive');
                }
                
                archive  += message;                
                LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive',archive);
                LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp',timestamp);
            }

            
            
        },
        init : function(uname){


            LEAP_CHAT.user_name =  uname;
            
            chat_box.find('.leap-chat-box-body--canvas').html('');
            LEAP_CHAT.reconnected = false;
            LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive','');
            LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp','');

            if(LEAP_CHAT.user_name!='')
            {
                LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_name);
            }   
            
            LEAP_CHAT.requestNewConnection();       
                
            chat_box.addClass('leap-init');

        },

        getStatus :  function(){

            if(LEAP_CHAT.lock ) return;
            /**
              * Temporary Status lock
              *
              */

            LEAP_CHAT.lock = true;
             jQuery.ajax(leap_listener_url, { 
                             
                             data : {   type:'user_status' , 
                              action: 'leap_chat_Listener', 
                              'user_id' :  LEAP_CHAT.user_id,
                                     },
                             
                              method : 'POST',
                              success : function(data){
                                data = LEAP_CHAT.cleanMessages(data);
                                          if(data!=''){
                                            LEAP_CHAT.lock = false;
                                            LEAP_CHAT.status = data;
                                          }

                                          }   ,
                              complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                     LEAP_CHAT.lock = false; // firefox fix

                                 }

                              }                                           

                  });


        },
        cleanMessages : function(data) {
            
            return jQuery.trim(data);
        },

        requestNewConnection : function(){

            
            
            LEAP_CHAT.status = 'new-connection';

            if(LEAP_CHAT.user_name!=='Visitor') {
                 jQuery(' .leap-start-overlay').fadeIn('fast');
                 clearInterval(checker);
            }
               

             jQuery.ajax(leap_listener_url, { 
                         data : {    
                              type:'add_new_visitor' , 
                              action: 'leap_chat_Listener', 
                              'user_id' :  LEAP_CHAT.user_id,
                              'user_name' :  LEAP_CHAT.user_name,
                              'flag' :  LEAP_CHAT.status,
                          },
                           
                              
                                
                              method : 'POST',
                              complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                     LEAP_CHAT.requestNewConnection();

                                 }

                              }    ,
                           success : function(data){
                            
                             data = LEAP_CHAT.cleanMessages(data);

                                if(typeof data == 'string' && data=='offline')
                                {
                                    jQuery('.start-leap-chap').html(leap_localize.offline_message);
                                    return;
                                }

                                if(typeof window.LEAP_USER_INFO === "string"){
                                    var url = "http://ipinfo.io/";
                                    if (location.protocol === 'https:')  {
                                        url = "https://ipinfo.io/";
                                    }
                                    jQuery.get(url+window.LEAP_USER_INFO, function(response) {
                        window.LEAP_USER_INFO = response;
                    }, "jsonp");
                                
                                }
                                

                                
                                LEAP_CHAT.lock = false;
                                checker =  setInterval(function(){

                                    LEAP_CHAT.getStatus();

                                    if(LEAP_CHAT.status  == 'connected'){
                                        clearInterval(checker);
                                        LEAP_CHAT.setupConnection();
                                    }

                                },2000);
                        }
                });

        },

        userAuth : function(){
            
            setInterval(function(){

                 jQuery.ajax(leap_listener_url, { 
             
                                 data : {
                                     type:'user-auth' , 
                                  action: 'leap_chat_Listener', 
                                  user_id :  LEAP_CHAT.user_id,
                                 },
                                 complete : function(xhr,status) { },
                                success :function(data){
                                    

                                    }

                      });

            },30000);

        },

        setupConnection : function(){

            LEAP_CHAT.user_data = [];
            chat_box.find('.leap-chat-box-intro--form').find('.leap-chat--input').each(function(){
                temp = jQuery(this).find('textarea,select,input[type=text]');
                LEAP_CHAT.user_data.push({  name : jQuery(this).find('label').html() ,  value : temp.val()  });
            });

            var f = false,op='';
            if( ! LEAP_CHAT.reconnected ) 
                {
                    f = true;
                    
                }
                else {

                    op = LEAP_CHAT.getRegistry('operator_uid');
                }
                
            if(typeof  window.LEAP_USER_INFO['URL'] !== "undefined")
            window.LEAP_USER_INFO['URL'] = window.location.href;
            
           

             jQuery.ajax(leap_listener_url, { 
             
                              data : {

                                type:'setup_chat' , 
                              action: 'leap_chat_Listener', 
                              forceNewConnection : f,
                              'user_id' :  LEAP_CHAT.user_id,
                              'operator_uid' :  op,
                              'flag' :  LEAP_CHAT.status,
                               'user_data' :  LEAP_CHAT.user_data,
                               'technical' : window.jscd,
                               'location' : window.LEAP_USER_INFO ,

                              },
                               method : 'POST',
                                
                              
                             complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') { // ff fix

                                   LEAP_CHAT.setupConnection();

                                 }

                              },
                           success :function(data){
                                
                            data = LEAP_CHAT.cleanMessages(data);
                                 console.log(data);
                                data = JSON.parse(data);    
                                LEAP_CHAT.operator_id  = data.operator_id; 
                                LEAP_CHAT.status  = data.flag; 
                            
                            if(data.operator_id=='') return;                            

                           if( ! LEAP_CHAT.reconnected )  {
                                     LEAP_CHAT.addLocalRegistry('operator_uid',data.operator_id);
                                }

                                 //has-operator-meta

                                 LEAP_CHAT.operator_msg  = LEAP_START_MESSAGE.replace('{name}',data.operator_id);
                    
                                 if( chat_box.find('.leap-chat-operator-meta').length  > 0 )
                                 {
                                    chat_box.addClass('has-operator-meta');
                                    
                                    if(typeof data.operator_avatar !== "undefined" && data.operator_avatar!=='' ) {
                                        chat_box.find('.leap-chat-avatar img').show();
                                        chat_box.find('.leap-chat-avatar img').attr('src',data.operator_avatar);
                                        chat_box.find('.leap-chat-operator-meta').removeClass('no-avatar');
                                    }
                                    else{
                                        chat_box.find('.leap-chat-operator-meta').addClass('no-avatar');
                                        chat_box.find('.leap-chat-avatar img').hide();
                                    }
                                    if(typeof data.operator_id !== "undefined" && data.operator_id!=='' )
                                        chat_box.find('.leap-chat-operator-meta h4').html(  data.operator_id );

                                    if(typeof data.operator_desig !== "undefined" && data.operator_desig!=='' )
                                        chat_box.find('.leap-chat-operator-meta h6').html(  data.operator_desig );
                                 }

                               chat_box.find('.leap-start-overlay').fadeOut('fast',function(){
                                chat_box.addClass('hide-leap-intro');
                                 chat_box.removeClass('leap-hide-chat');

                                if( ! LEAP_CHAT.reconnected ) {
                                    var  label = "<span>"+LEAP_CHAT.operator_id+"</span>";
                                   
                                                                                LEAP_CHAT.timestamp = '';
                                            messages = jQuery( "<div class='leap-chat-box-operator-wrap "+LEAP_CHAT.effect.operator+" animated'>"+label+"<div class='leap-chat-box-operator-msg '>"+LEAP_CHAT.operator_msg+"</div></div>");

                                            canvas.append(messages);
                                             LEAP_CHAT.smiley(messages);
                                             canvas[0].scrollTop = canvas[0].scrollHeight;
                                            if(LEAP_CHAT.audio_notice)
                                            LEAP_CHAT.audio_notice.play();
                                      
                                        }
                                 else
                                 {
                                    if(LEAP_CHAT.checkRegistry(LEAP_CHAT.user_id+'-archive'))
                                {
                                    archive =  LEAP_CHAT.getRegistry(LEAP_CHAT.user_id+'-archive');

                                    canvas.prepend(archive);
                                     canvas.find('a').attr('target','_BLANK');
                                    canvas.find('.animated').removeClass('animated');
                                    LEAP_CHAT.smiley(canvas);
                                    LEAP_CHAT.timestamp = LEAP_CHAT.getRegistry(LEAP_CHAT.user_id+'-timestamp');
                                    canvas[0].scrollTop = canvas[0].scrollHeight;
                                }
                                 }      


                          });

                          LEAP_CHAT.poller = false;
                          LEAP_CHAT.listener();
                          LEAP_CHAT.userAuth();
                            }

                });

        },

        uniqueid : function(){
   
                   // always start with a letter (for DOM friendlyness)
                    var idstr=String.fromCharCode(Math.floor((Math.random()*25)+65));
                   
                    do {                
                    // between numbers and characters (48 is 0 and 90 is Z (42-48 = 90)
                   
                             var ascicode=Math.floor((Math.random()*42)+48);
                             if (ascicode<58 || ascicode>64){
                            // exclude all chars between : (58) and @ (64)
                                    idstr+=String.fromCharCode(ascicode);    
                            }                
                    } while (idstr.length<32);

                      return (idstr);
         },
        
        getDueMessages : function(){

            if(LEAP_CHAT.lock) return;

            var messages = [], istyping = false;
            LEAP_CHAT.lock = true;
            jQuery.ajax(leap_listener_url, { 
             
                        data : {
                              type:'get-user-messages' , 
                          action: 'leap_chat_Listener', 
                          'user_id' :  LEAP_CHAT.user_id,
                          'timestamp' :  LEAP_CHAT.timestamp,
                      },
                      method:"POST",
                       
                              

                       complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                     LEAP_CHAT.getDueMessages();

                                 }

                              }   ,   
                      success:function(data){
                            data = LEAP_CHAT.cleanMessages(data);

                            if(data === '' ||  ! data || data == "0" )
                            {
                                LEAP_CHAT.lock = false;
                                return;
                            }
                            
                            data = JSON.parse(data);

                            if(data.message === 'killed')
                            {
                                chat_box.addClass('end-leap-chat')
                                 LEAP_CHAT.addLocalRegistry('operator_uid','');
                                LEAP_CHAT.poller = true;
                                return;
                            }

                        

                            if(typeof data !== "object")
                            {
                                LEAP_CHAT.lock = false;
                                return;
                            }
                             
                        
                            if(data.operator_flag!==''  && LEAP_CHAT.operator_flag !== data.operator_flag ) {

                                                                             if(indicator_timer)
                                                                            {
                                                                                  clearTimeout(indicator_timer);
                                                                            }
                                                                      
                                                                              indicator.css("opacity",1);
                                                                               LEAP_CHAT.operator_flag = data.operator_flag;
                                                                              indicator_timer = setTimeout(function(){
                                                                                  indicator.css("opacity",0);
                                                                              },4000);
                                                              }
                
                if(data.message  ===''){
                                LEAP_CHAT.lock = false;
                                return;
                            }


                            var currentdate = new Date(), time = "<small>" + formatAMPM(currentdate) + "</small>",label = "<span>"+LEAP_CHAT.operator_id+"</span>";

                            if(canvas.children().last().hasClass('leap-chat-box-operator-wrap'))
                {
                    label = '';
                    time = '';
                }

                            jQuery.each(data.message,function(index,msg){

                                  LEAP_CHAT.timestamp = index;
                                    
                                messages.push("<div class='leap-chat-box-operator-msg '>"+msg+"</div>");
                                indicator.css("opacity",0);
                                                                                       
                            });
                            LEAP_CHAT.lock = false;

                            messages =  "<div class='leap-chat-box-operator-wrap "+LEAP_CHAT.effect.operator+" animated'>"+label+time+""+messages.join('')+"</div>";
                          LEAP_CHAT.chatArchiver(messages,LEAP_CHAT.timestamp);
                            messages = jQuery(messages);
                            canvas.append(messages);
                             LEAP_CHAT.smiley(messages);
                             canvas[0].scrollTop = canvas[0].scrollHeight;
                            if(LEAP_CHAT.audio_notice)
                            LEAP_CHAT.audio_notice.play();

                    }

            });
            
        },
        getMessageTimeStamp : function(){

             var currentdate = new Date(); 
             var datetime = LEAP_CHAT.user_id + currentdate.getDate() +  (parseInt(currentdate.getMonth())    + 1)  + currentdate.getFullYear()  + currentdate.getHours()   + currentdate.getMinutes()  + currentdate.getSeconds(); 

             return datetime;
        },
        listener : function(){

            
            LEAP_CHAT.poll(function(){ 
                
                LEAP_CHAT.getDueMessages();
                
                return LEAP_CHAT.poller;

            } ,  2000); 

        },

          poll : function(fn,  interval) {

                (function p() {
                        
                        if(fn()) {
                         //   callback();
                        }
                        else {
                            setTimeout(p, interval);
                        }
                 
                })();
            },

            smiley : function(obj){

                 jQuery.ajax(leap_listener_url, { 
                            
                            data: {
                              type:'translate_smiley' , 
                              action: 'leap_chat_Listener', 
                              'text' : obj.html(),
                          },
                           
                              
                            method:'POST',
                            success: function(data){
                                data = LEAP_CHAT.cleanMessages(data);
                                  if(data!='')
                                  {
                                        obj.html(window.wp.emoji.parse(data) ); 
                                  } 
                             },
                            complete : function(xhr,status) { 
                                
                                 if(xhr.statusText=='ajaxok') { 


                                 }

                            }                                                                  

                  });   

            },

            ajaxSend : function(message){
                
                LEAP_CHAT.sendLock = true;
                jQuery.ajax(leap_listener_url,{
                                                             data : {
                                                                   user_id : LEAP_CHAT.user_id ,
                                                                user_flag : '' ,
                                                                message : message,
                                                               type: "set-user-message",
                                                                action: 'leap_chat_Listener'

                                                             },
                                                              
                              
                                                             method : "POST",
                                                              complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {
                                    console.log(message);
                                    LEAP_CHAT.ajaxSend(message);

                                 }

                              }      ,
                                                             success:function(data){
                                                                data = LEAP_CHAT.cleanMessages(data);
                                                                    setTimeout(function(){ LEAP_CHAT.sendLock = false; },1000);
                        }
                   }); 

            },
            sendPendingMessages: function(){

                if(LEAP_CHAT.pendingLock) return; // Wait for earlier messags to be delivered

                LEAP_CHAT.pendingLock = true;
                
                
                LEAP_CHAT.sendLock = true;

                LEAP_CHAT.pendingTimer = setInterval(function(){

                        if(! LEAP_CHAT.isPending){

                            LEAP_CHAT.sendLock = true;
                            LEAP_CHAT.isPending = true; 
                            var msg = LEAP_CHAT.pending;
                            LEAP_CHAT.pending = [];

                            jQuery.ajax(leap_listener_url,{
                                                                        data : {
                                                                                user_id : LEAP_CHAT.user_id ,
                                                                            message : msg,
                                                                           type: "set-user-message",
                                                                            action: 'leap_chat_Listener'
                                                                        },
                                                                         
                              
                                                                        method : "POST",
                                                                         complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                     LEAP_CHAT.sendPendingMessages();

                                 }

                              }  ,    
                            success:function(data){
                                data = LEAP_CHAT.cleanMessages(data);
                                    LEAP_CHAT.sendLock = false; 
                                LEAP_CHAT.pendingLock = false;
                                LEAP_CHAT.isPending = false;
                                clearInterval(LEAP_CHAT.pendingTimer);

                                if(LEAP_CHAT.pending.length > 0)
                                    LEAP_CHAT.sendPendingMessages();
                            }

                                                                        });

                        }

                },1000);

            },
            sendMessage : function(){
                
                LEAP_CHAT.user_msg =  input.val();
                if(LEAP_CHAT.user_msg =='') return; 

                if(LEAP_CHAT.sendLock || LEAP_CHAT.pending.length > 0)
                {

                    LEAP_CHAT.pending.push(LEAP_CHAT.user_msg);
                    LEAP_CHAT.sendPendingMessages();
                }
                else
                    LEAP_CHAT.ajaxSend(LEAP_CHAT.user_msg);

                

                var currentdate = new Date();
                var label = "<span>"+LEAP_CHAT.user_name+"</span>";
                                                            var time = "<small>" + formatAMPM(currentdate) + "</small>";
                LEAP_CHAT.user_flag = 'sent';
                LEAP_CHAT.message_stamp = LEAP_CHAT.getMessageTimeStamp();
                


                if(canvas.children().last().hasClass('leap-chat-box-user-msg'))
                {
                    time = '';
                    label = '';
                }

                var currentdate = new Date();

                obj = jQuery("<div class='leap-chat-box-user-msg "+LEAP_CHAT.effect.user+" animated'>"+time+label+LEAP_CHAT.user_msg+"</div>");
                 obj.find('a').attr('target','_BLANK');
                canvas.append(obj);
                
                LEAP_CHAT.smiley(obj);
                
                LEAP_CHAT.chatArchiver("<div class='leap-chat-box-user-msg "+LEAP_CHAT.effect.user+" animated'>"+time+label+LEAP_CHAT.user_msg+"</div>",LEAP_CHAT.timestamp);
                
                input.val('');
                canvas[0].scrollTop = canvas[0].scrollHeight;
                if(LEAP_CHAT.audio_notice)
                    LEAP_CHAT.audio_notice.play();

                input.focus();

            },

            die : function(){

                 jQuery.ajax(leap_listener_url, { 
                                
                            data: {
                                 type:'set_user_status' , 
                                  action: 'leap_chat_Listener', 
                                  status : 'disconnect',
                                  'user_id' :  LEAP_CHAT.user_id,
                                  'operator_id' :  LEAP_CHAT.operator_id,
                              },
                              method: 'POST',
                               complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                   LEAP_CHAT.die();

                                 }

                              }   ,   

                              success:function(data){
                                            data = LEAP_CHAT.cleanMessages(data);
                                              if(data!=''){
                                                LEAP_CHAT.status = 'disconnect';
                                              }    

                                              }                                          

                      });

            },

         /**
                *
                * Add to Cache 
                *
                **/
                
                addLocalRegistry : function(key,widget_string)
                {

                        if(Modernizr.localstorage)
                        {
                                localStorage.setItem(key,widget_string);
                        }

                },

                /**
                *
                * Check if Key exists
                *
                **/
                
                checkRegistry : function(key)
                { 
                      
                        if( Modernizr.localstorage && localStorage.getItem(key) )
                                return true;
                        else
                                return false;
                },

                /**
                *
                * Get Data from cache
                *
                **/
                
                getRegistry : function(key)
                {
                    if(Modernizr.localstorage)
                                return localStorage.getItem(key);
                            else 
                                return '';
                }       

    }

      
                             jQuery(document).on('keydown','#leap-chat-name',function(e){
                           if (e.keyCode == 13) {
                                    jQuery('.leap-start-chat a').trigger('click');
                                    return false;
                                 }

                        });

                          var keyinterval = false;
                                  jQuery(document).on('keyup','.leap-chat-box-footer--input',function(e){
                        
                        if(keyinterval) clearTimeout(keyinterval);

                                 var  val = jQuery(this).val() ,qar =  val.length,parent = jQuery(this);
                             if(qar > 5 && ! LEAP_CHAT.sendLock && e.keyCode != 13)
                             {
                                
                                keyinterval = setTimeout(function(){

                                    LEAP_CHAT.sendLock = true;
                                             jQuery.ajax(leap_listener_url,{
                                                        data : {
                                                              user_id : LEAP_CHAT.user_id ,
                                                          message : parent.val(),
                                                         type: "set-user-typing",
                                                          action: 'leap_chat_Listener'
                                                      },
                                                       complete : function(xhr,status) { },      
                                                      success:function(data){
                                                          data = LEAP_CHAT.cleanMessages(data);
                                                           LEAP_CHAT.sendLock = false; 
                                             
                                                       }

                                              });   

                                },1500)

                             }


                        });

                  jQuery('.leap-chat-restart').click(function(e){

                        e.preventDefault();
        chat_box.removeClass('end-leap-chat hide-leap-intro leap-init');    

                  });      

                  

                  jQuery('.leap-offline-button a').click(function(e){
        e.preventDefault();
        var contact_test = false,input,val,fields = {};
        

        chat_box.find('.leap-offline-form div.leap-chat--input').each(function(){
            input = jQuery(this).find('input,textarea,select');
            val = input.val();
            if( jQuery.trim(val) === '' )
            {
                contact_test = true;
                jQuery(this).addClass('leap-input-error');
            }
            else
                jQuery(this).removeClass('leap-input-error');

            fields[jQuery(this).find('label').html()] = val;

        });

        if(contact_test)
        {
            jQuery('.leap-chat-box-intro--form').scrollTop(0);
            return;
        }

        jQuery('.leap-offline-form').css("opacity",0.4);
        obj = jQuery(this);
        obj.html('Sending...');

        jQuery.ajax(leap_listener_url,{
                                           data : {   type: "offline-message",
                                                      action: 'leap_chat_Listener',
                                                      fields : fields,
                                                  },
                                           method : "POST",  
                                            complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                    jQuery('.leap-offline-button a').trigger('click');

                                 }

                              }      ,     
                                                success: function(data){
                                                      data = LEAP_CHAT.cleanMessages(data);
                                                    jQuery('.leap-offline-form div.leap-chat--input').each(function(){
                                                        jQuery(this).find('input,textarea').val('');    
                                                     });
                                                    obj.html('Sent !');
                                                    jQuery('.leap-offline-form').fadeOut('fast');
                                                    jQuery('.leap-offline-success-message').css("top","30px");
                                                }

                                          });

        
    });

    jQuery('.leap-start-chat a').click(function(e){
        e.preventDefault();
        var contact_test = false;

        if( jQuery.trim(chat_box.find('#leap-chat-name').val()) === '' )
        {
            contact_test = true;
        }

        if(contact_test)
        {
            
            chat_box.find('#leap-chat-name').parent().addClass('leap-input-error');
            chat_box.find('.leap-chat-box-intro--form').scrollTop(0);
            return;
        }

        LEAP_CHAT.addLocalRegistry('leap-name',chat_box.find('#leap-chat-name').val());
        LEAP_CHAT.init(chat_box.find('#leap-chat-name').val());
    });


    jQuery(window).load(function(){
       

        LEAP_CHAT.addLocalRegistry('leap-name','Visitor');
        LEAP_CHAT.init('Visitor');
    
    });



    jQuery('div.leap-chat-box-compact-bar').click(function(e){
        e.preventDefault();
        chat_box.removeClass('leap-hide-chat');

    });  


    jQuery('div.leap-chat-box-mobile-bubble').click(function(e){
        e.preventDefault();
        chat_box.removeClass('leap-hide-chat');
        
    });

     jQuery(document).on('click','.trigger-leap-chat',function(e){
        e.preventDefault();
        chat_box.removeClass('leap-hide-chat');

    });



    jQuery(document).on('click','.leap-chat-box-open',function(){
        e.preventDefault();
        chat_box.removeClass('leap-hide-chat');
    });

    jQuery('div.leap-chat-box-expand-bar').click(function(e){
        e.preventDefault();
        chat_box.removeClass('leap-hide-chat hide-leap-intro');

    });

    

    jQuery('.leap-chat-box-close').click(function(e){
        e.preventDefault();

        if(chat_box.hasClass('end-leap-chat') || chat_box.hasClass('leap-is-offline') ||  LEAP_CHAT.status === 'new-connection')
            chat_box.addClass('leap-hide-chat');
        else{
            chat_box.find('.leap-chat-box-close-modal').fadeIn('normal');
        }

    });


    jQuery('.leap-modal-close').click(function(e){
        e.preventDefault();
        chat_box.find('.leap-chat-box-close-modal').fadeOut('normal');
    });

    jQuery('.leap-kill-session').click(function(e){
            e.preventDefault();

                chat_box.addClass('leap-hide-chat');
                chat_box.removeClass('hide-leap-intro');
                                          chat_box.find('.leap-chat-box-close-modal').fadeOut('normal');
                                          jQuery('.leap-start-overlay').hide();
                                          
                                   jQuery.ajax(   leap_listener_url , {
                                                data : {
                                                       type: "kill_session",
                                                        user_id:  LEAP_CHAT.user_id,
                                                       action: 'leap_chat_Listener'
                                                   },
                                                   method : "POST",
                                                    complete : function(xhr,status) {

                                 if(xhr.statusText=='ajaxok') {

                                     jQuery('.leap-kill-session').trigger('click');

                                 }

                              }      ,
                                                   success : function(data){
                                     data = LEAP_CHAT.cleanMessages(data);
                                            LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive','');
                LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp','');
                                          }

                                       });

    });

    input.keydown(function(event) {
            if (event.keyCode == 13) {
                LEAP_CHAT.sendMessage();
                return false;
             }
        });

    jQuery('.leap-chat-box-footer--send').click(function(e){
        e.preventDefault();
        LEAP_CHAT.sendMessage();

        });
    

       window.onbeforeunload = LEAPKILLCHAT;


        function LEAPKILLCHAT() {   LEAP_CHAT.die();   }
    function formatAMPM(date) {
      var hours = date.getHours();
      var minutes = date.getMinutes();
      var ampm = hours >= 12 ? 'pm' : 'am';
      hours = hours % 12;
      hours = hours ? hours : 12; // the hour '0' should be '12'
      minutes = minutes < 10 ? '0'+minutes : minutes;
      var strTime = hours + ':' + minutes + ' ' + ampm;
      return strTime;
    }

    LEAP_CHAT.setup();
    /**
      *  Kill Any session if open
      *
      **/


        
 });


/* Modernizr 2.7.1 (Custom Build) | MIT & BSD
 * Build: http://modernizr.com/download/#-localstorage-sessionstorage-webworkers
 */
;window.Modernizr=function(a,b,c){function t(a){i.cssText=a}function u(a,b){return t(prefixes.join(a+";")+(b||""))}function v(a,b){return typeof a===b}function w(a,b){return!!~(""+a).indexOf(b)}function x(a,b,d){for(var e in a){var f=b[a[e]];if(f!==c)return d===!1?a[e]:v(f,"function")?f.bind(d||b):f}return!1}var d="2.7.1",e={},f=b.documentElement,g="modernizr",h=b.createElement(g),i=h.style,j,k={}.toString,l={},m={},n={},o=[],p=o.slice,q,r={}.hasOwnProperty,s;!v(r,"undefined")&&!v(r.call,"undefined")?s=function(a,b){return r.call(a,b)}:s=function(a,b){return b in a&&v(a.constructor.prototype[b],"undefined")},Function.prototype.bind||(Function.prototype.bind=function(b){var c=this;if(typeof c!="function")throw new TypeError;var d=p.call(arguments,1),e=function(){if(this instanceof e){var a=function(){};a.prototype=c.prototype;var f=new a,g=c.apply(f,d.concat(p.call(arguments)));return Object(g)===g?g:f}return c.apply(b,d.concat(p.call(arguments)))};return e}),l.localstorage=function(){try{return localStorage.setItem(g,g),localStorage.removeItem(g),!0}catch(a){return!1}},l.sessionstorage=function(){try{return sessionStorage.setItem(g,g),sessionStorage.removeItem(g),!0}catch(a){return!1}},l.webworkers=function(){return!!a.Worker};for(var y in l)s(l,y)&&(q=y.toLowerCase(),e[q]=l[y](),o.push((e[q]?"":"no-")+q));return e.addTest=function(a,b){if(typeof a=="object")for(var d in a)s(a,d)&&e.addTest(d,a[d]);else{a=a.toLowerCase();if(e[a]!==c)return e;b=typeof b=="function"?b():b,typeof enableClasses!="undefined"&&enableClasses&&(f.className+=" "+(b?"":"no-")+a),e[a]=b}return e},t(""),h=j=null,e._version=d,e}(this,this.document);

/**
 * JavaScript Client Detection
 * (C) viazenetti GmbH (Christian Ludwig)
 */

(function (window) {
    {
        var unknown = '-';

        // screen
        var screenSize = '';
        if (screen.width) {
            width = (screen.width) ? screen.width : '';
            height = (screen.height) ? screen.height : '';
            screenSize += '' + width + " x " + height;
        }

        //browser
        var nVer = navigator.appVersion;
        var nAgt = navigator.userAgent;
        var browser = navigator.appName;
        var version = '' + parseFloat(navigator.appVersion);
        var majorVersion = parseInt(navigator.appVersion, 10);
        var nameOffset, verOffset, ix;

        // Opera
        if ((verOffset = nAgt.indexOf('Opera')) != -1) {
            browser = 'Opera';
            version = nAgt.substring(verOffset + 6);
            if ((verOffset = nAgt.indexOf('Version')) != -1) {
                version = nAgt.substring(verOffset + 8);
            }
        }
        // MSIE
        else if ((verOffset = nAgt.indexOf('MSIE')) != -1) {
            browser = 'Microsoft Internet Explorer';
            version = nAgt.substring(verOffset + 5);
        }
        // Chrome
        else if ((verOffset = nAgt.indexOf('Chrome')) != -1) {
            browser = 'Chrome';
            version = nAgt.substring(verOffset + 7);
        }
        // Safari
        else if ((verOffset = nAgt.indexOf('Safari')) != -1) {
            browser = 'Safari';
            version = nAgt.substring(verOffset + 7);
            if ((verOffset = nAgt.indexOf('Version')) != -1) {
                version = nAgt.substring(verOffset + 8);
            }
        }
        // Firefox
        else if ((verOffset = nAgt.indexOf('Firefox')) != -1) {
            browser = 'Firefox';
            version = nAgt.substring(verOffset + 8);
        }
        // MSIE 11+
        else if (nAgt.indexOf('Trident/') != -1) {
            browser = 'Microsoft Internet Explorer';
            version = nAgt.substring(nAgt.indexOf('rv:') + 3);
        }
        // Other browsers
        else if ((nameOffset = nAgt.lastIndexOf(' ') + 1) < (verOffset = nAgt.lastIndexOf('/'))) {
            browser = nAgt.substring(nameOffset, verOffset);
            version = nAgt.substring(verOffset + 1);
            if (browser.toLowerCase() == browser.toUpperCase()) {
                browser = navigator.appName;
            }
        }
        // trim the version string
        if ((ix = version.indexOf(';')) != -1) version = version.substring(0, ix);
        if ((ix = version.indexOf(' ')) != -1) version = version.substring(0, ix);
        if ((ix = version.indexOf(')')) != -1) version = version.substring(0, ix);

        majorVersion = parseInt('' + version, 10);
        if (isNaN(majorVersion)) {
            version = '' + parseFloat(navigator.appVersion);
            majorVersion = parseInt(navigator.appVersion, 10);
        }

        // mobile version
        var mobile = /Mobile|mini|Fennec|Android|iP(ad|od|hone)/.test(nVer);

        // cookie
        var cookieEnabled = (navigator.cookieEnabled) ? true : false;

        if (typeof navigator.cookieEnabled == 'undefined' && !cookieEnabled) {
            document.cookie = 'testcookie';
            cookieEnabled = (document.cookie.indexOf('testcookie') != -1) ? true : false;
        }

        // system
        var os = unknown;
        var clientStrings = [
            {s:'Windows 10', r:/(Windows 10.0|Windows NT 10.0)/},
            {s:'Windows 8.1', r:/(Windows 8.1|Windows NT 6.3)/},
            {s:'Windows 8', r:/(Windows 8|Windows NT 6.2)/},
            {s:'Windows 7', r:/(Windows 7|Windows NT 6.1)/},
            {s:'Windows Vista', r:/Windows NT 6.0/},
            {s:'Windows Server 2003', r:/Windows NT 5.2/},
            {s:'Windows XP', r:/(Windows NT 5.1|Windows XP)/},
            {s:'Windows 2000', r:/(Windows NT 5.0|Windows 2000)/},
            {s:'Windows ME', r:/(Win 9x 4.90|Windows ME)/},
            {s:'Windows 98', r:/(Windows 98|Win98)/},
            {s:'Windows 95', r:/(Windows 95|Win95|Windows_95)/},
            {s:'Windows NT 4.0', r:/(Windows NT 4.0|WinNT4.0|WinNT|Windows NT)/},
            {s:'Windows CE', r:/Windows CE/},
            {s:'Windows 3.11', r:/Win16/},
            {s:'Android', r:/Android/},
            {s:'Open BSD', r:/OpenBSD/},
            {s:'Sun OS', r:/SunOS/},
            {s:'Linux', r:/(Linux|X11)/},
            {s:'iOS', r:/(iPhone|iPad|iPod)/},
            {s:'Mac OS X', r:/Mac OS X/},
            {s:'Mac OS', r:/(MacPPC|MacIntel|Mac_PowerPC|Macintosh)/},
            {s:'QNX', r:/QNX/},
            {s:'UNIX', r:/UNIX/},
            {s:'BeOS', r:/BeOS/},
            {s:'OS/2', r:/OS\/2/},
            {s:'Search Bot', r:/(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\/Teoma|ia_archiver)/}
        ];
        for (var id in clientStrings) {
            var cs = clientStrings[id];
            if (cs.r.test(nAgt)) {
                os = cs.s;
                break;
            }
        }

        var osVersion = unknown;

        if (/Windows/.test(os)) {
            osVersion = /Windows (.*)/.exec(os)[1];
            os = 'Windows';
        }

        switch (os) {
            case 'Mac OS X':
                osVersion = /Mac OS X (10[\.\_\d]+)/.exec(nAgt)[1];
                break;

            case 'Android':
                osVersion = /Android ([\.\_\d]+)/.exec(nAgt)[1];
                break;

            case 'iOS':
                osVersion = /OS (\d+)_(\d+)_?(\d+)?/.exec(nVer);
                osVersion = osVersion[1] + '.' + osVersion[2] + '.' + (osVersion[3] | 0);
                break;
        }
        
        // flash (you'll need to include swfobject)
        /* script src="//ajax.googleapis.com/ajax/libs/swfobject/2.2/swfobject.js" */
        var flashVersion = 'no check';
        if (typeof swfobject != 'undefined') {
            var fv = swfobject.getFlashPlayerVersion();
            if (fv.major > 0) {
                flashVersion = fv.major + '.' + fv.minor + ' r' + fv.release;
            }
            else  {
                flashVersion = unknown;
            }
        }
    }

    window.jscd = {
        screen: screenSize,
        browser: browser,
        browserVersion: version,
        mobile: mobile,
        os: os,
        osVersion: osVersion,
        cookies: cookieEnabled,
        flashVersion: flashVersion
    };
}(this));