<?php
/**
 *  Name - Dummy panel 
 *  Dependency - Core Admin Class
 *  Version - 1.0
 *  Code Name - Nobody
 */

if(!is_admin()) return;

class LEAPADMINARCHIVES extends IOA_PANEL_CORE {
	

	
	// init menu
	function __construct () { parent::__construct( __('Archives','ioa'),'submenu','lchatar');  }
	
	// setup things before page loads , script loading etc ...
	function manager_admin_init(){	

		

	  }	
	
	 function manager_admin_menu(){
		
	   	 add_submenu_page("lchat", 'Archives', 'Archives', 'edit_pages', 'lchatar' ,array($this,'manager_admin_wrap')); 
		  
	  }
	
	/**
	 * Main Body for the Panel
	 */

	function panelmarkup(){	
		$current_user = wp_get_current_user();
		
		?>

		<div class="ioa-panel" >
			<div class="ioa_panel_wrap" > <!-- Panel Wrapper -->
			
				<div class="ioa-panel-title">
					<h2><?php _e('Archives',"leap") ?></h2>
				</div>
                <div class="leap-analytics-pagination clearfix">

                             <a href="" id="leap-purge-archive" class='button-default' ><?php  _e('Delete All','leap') ?></a> 
                        </div>

				<div class="ioa-panel-body  leap-chat-settings clearfix">
					
                    <div class='leap-analytics-table-content clearfix'>
                            
                        </div>    
					<div class="leap-analytics-table-wrap">
						<?php 
						$offset =  0;								
						if(isset($_GET['offset']))
							$offset = $_GET['offset'];

						if( isset($_GET['step'])  && $_GET['step'] == 'next'  )
							$offset += 10;

						if( isset($_GET['step'])  && $_GET['step'] == 'prev'  )
							$offset -= 10;

						$ga = get_option('LEAP_ANALYTICS');
								if(!$ga)	
									$ga = array();
						$ga = array_reverse($ga);		
						$init = $offset;
						$limit = $init + 10;
						 ?>
						<div class="leap-chat-archive-list">
							  <?php 
								$query = new WP_Query("post_type=leapchatarchive&posts_per_page=-1");  

								while ($query->have_posts()) : $query->the_post();   ?> 
							     	<div class="leap-archive-item clearfix">
									<h6 class='clearfix'><?php the_title(); ?>
										<a href="" class=""></a>
									</h6>
									<div class="leap-archive-item-data clearfix">
										<div class="archive-chat-box">
											<?php 
                                               
												$session = get_post_meta(get_the_ID(),'human_log',true);
												echo stripslashes($session);
											 ?>
										</div>
										<div class="archive-meta-data">
											<?php 
												$session = get_post_meta(get_the_ID(),'session',true  );
												$data = get_post_meta(get_the_ID(),'init_data' ,true );

											 ?>
											 <ul>
											 	<li><strong><?php _e('Operator Name ') ?> :</strong> <?php echo $session['operator_id'] ?></li>
											 	<li><strong><?php _e('User Name ') ?> :</strong> <?php if(isset($session['user_name'])) echo $session['user_name'] ?></li>
												
												<?php if(isset($session['user_data'])) :  ?>	

											 	<?php 
											 		$user_data = $session['user_data'];
											 		$data = Leap_IOAAssocMap($user_data['data'],'value');
											 		$location =  $user_data['location'];
											 		$technical =  $user_data['technical'];
											 	 ?>
											 	 <li class='heading'><h5 ><?php _e('User Submitted Data','ioa') ?></h5></li>
											 	<?php
											 		foreach($data as $key => $d) {
											 			echo "<li><strong>$key</strong> $d</li>";
											 		}
											 	?>
											 	 <li class='heading'><h5 ><?php _e('Location','ioa') ?></h5></li>
											 	<?php
											 		if(is_array($location))
											 		foreach($location as $key => $d) {
											 			echo "<li><strong>$key</strong> $d</li>";
											 		}
											 	?>
											 	 <li class='heading'><h5 ><?php _e('Technical','ioa') ?></h5></li>
											 	<?php
											 		if(is_array($technical))
											 		foreach($technical as $key => $d) {
											 			echo "<li><strong>$key</strong> $d</li>";
											 		}
											 	?>

											 <?php endif; ?>

											 </ul>
										</div>
									</div>
							     	</div> 
							       <?php  endwhile; ?>
						</div>
					</div>		



					
				</div>
			
	         		</div>       	
	        	 </div>       	



		<?php
	

	    
	 }
	 

}



