<?php
/**
 *  Name - Dummy panel 
 *  Dependency - Core Admin Class
 *  Version - 1.0
 *  Code Name - Nobody
 */

if(!is_admin()) return;

class LEAPADMINOPTIONS extends IOA_PANEL_CORE {
	

	
	// init menu
	function __construct () { parent::__construct( __('Settings','leap'),'submenu','lchatop');  }
	
	// setup things before page loads , script loading etc ...
	function manager_admin_init(){	

		

	  }	
	
	 function manager_admin_menu(){
		
	   	 add_submenu_page("lchat", 'Settings', 'Settings', 'edit_pages', 'lchatop' ,array($this,'manager_admin_wrap')); 
		  
	  }
	
	/**
	 * Main Body for the Panel
	 */

	function panelmarkup(){	
		$current_user = wp_get_current_user();
		
		?>

		<div class="ioa-panel" >
			<div class="ioa_panel_wrap" > <!-- Panel Wrapper -->
			
				<div class="ioa-panel-title">
					<h2><?php _e('Settings','leap') ?></h2>
				</div>


				<div class="ioa-panel-body  leap-chat-settings clearfix">
					
					<div class="leap-menu-panel clearfix">
						<a class="button-save save_leap_settings" id=""><?php _e('Save Settings','leap') ?></a>
						<a class="button-default" id="leap-purge-cache" href=''><?php _e('Purge Cache','leap') ?></a>
						<a class="button-default" id="leap-purge-analytics" href=''><?php _e('Purge Analytics','leap') ?></a>
					</div>
					<?php 
					$users = get_users();
					$u = array();

					foreach ($users as $key => $user) {
						$u[$user->ID] = $user->display_name ;
					}



					$inps = array(
										array( 
												"label" => __("Enter Input Name",'leap') , 
												"name" => "in_name" , 
												"default" => "" , 
												"type" => "text",
												"value" => ""   
										) ,
										array( 
												"label" => __("Select Input Type",'leap') , 
												"name" => "in_type" , 
												"default" => "text" , 
												"type" => "select",
												"value" => ""  ,
												"options" => array("text" => "Text Input","textarea" => "Text Area","select" => "Dropdown")
												
										) ,
										
										array( 
												"label" => __("Dropdown Options",'leap') , 
												"name" => "in_d_opts" , 
												"default" => "" , 
												"type" => "textarea",
												"description" => __("If you are using a dropdown enter options here separated by ;",'leap'),
												"value" => ""   
										) 	
											

								);

					global $leap_google_webfonts;

					$google_webfonts = array();
				 	foreach ($leap_google_webfonts as $key => $value) {
				 		$google_webfonts[] = $value['name'];
				 	}

					$panels = array(

							__("General Settings",'leap') => array(

								array( "label" => __("Set Chat to Offline Mode",'leap')  , "name" => "LEAP_offline" , "type" => "select"  , "default" => "false", "options" => array("false" => __("No",'leap') , "true" => __("Yes",'leap')) , "value" => "" , "description" => __("When you don't want vistors to use live chat, set this option to yes and users will see a contact form instead.",'leap') ),

                                array( "label" => __("Hide Chat on mobile",'leap')  , "name" => "LEAP_mobile_hide" , "type" => "select"  , "default" => "false", "options" => array("false" => __("No",'leap') , "true" => __("Yes",'leap')) , "value" => "" , "description" => __("If you want to hide the chat on mobile set this to no.",'leap') ),



								array( "label" => __("Hide Chat",'leap')  , "name" => "LEAP_preview" , "type" => "select"  , "default" => "false", "options" => array("false" => __("No",'leap') , "true" => __("Yes",'leap')) , "value" => "" , "description" => __("When you don't want vistors to use live chat,  but you want to view the chat box set this to true. It is useful when you want to make changes in UI",'leap') ),

								array( "label" => __("Select Bar Style",'leap')  , "name" => "LEAP_compact" , "type" => "select"  , "default" => "default", "options" =>  array("default" => "Compact Bar","expand" => "Expanded Bar" ), "value" => "" , "description" => __("Set the style the visitor is seeing before the open it.",'leap') ),

								array( "label" => __("Select Email Notifications for New Visitors",'leap')  , "name" => "LEAP_op_notify" , "type" => "select"  , "default" => "false", "options" =>  array("false" => "No","true" => "Yes" ), "value" => "" , "description" => __("Operators will receive an email notification when a new visitor requests for a chat.",'leap') ),

								array( "label" => __("Select Main Font",'leap')  , "name" => "LEAP_google_font" , "type" => "select"  , "default" => "none", "options" =>  $google_webfonts , "value" => "" , "description" => __("Select main font for the chat box",'leap') ),
								
								array( "label" => __("Show or Hide Operator Information",'leap')  , "name" => "LEAP_meta_op" , "type" => "select"  , "default" => "show", "options" => array("show" => __("Show",'leap') , "hide" => __("Hide",'leap')  ) , "value" => "" , "description" => __("If you want to show Operator's image, name and designation set this option to show. You can edit these details in User - Edit your Profile page.",'leap')  ),
								

								array( "label" => __("Use sound notification for visitors",'leap')  , "name" => "LEAP_sound" , "type" => "select"  , "default" => "true", "options" => array("false" => __("No",'leap') , "true" => __("Yes",'leap')) , "value" => "" , "description" => __("You can turn off or on sound notification for buyers when a new message is received.",'leap') ),

								array( "label" => __("Add your own sound notification for visitors(mp3 or wav",'leap')  , "name" => "LEAP_custom_sound" , "type" => "video"  , "default" => "" , "value" => "" , "description" => __("You can add your own custom sound from here. Leave it empty to use  default sound.",'leap') ),

								array( "label" => __("Set your start message",'leap')  , "name" => "LEAP_start_box_msg" , "type" => "textarea"  , "default" => "Please Fill in the details before starting chat !" , "value" => "", "description" => __("Set the Message you wan to show at the information input panel. ",'leap')  ),

								array( 'inputs' => $inps, 'label' => __('Set inputs for start panel' ,'leap') , 	'name' => 'rad_tab','type'=>'module','unit' => __(' Input','leap') , "description" => __('Add your own inputs from here. The data collected from these will be visible to operator and in analytics.','leap')   ),

								array( "label" => __("Background Colour for compact bar and expanded bar",'leap')  , "name" => "LEAP_compactbar_bg" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Applies to both styles.",'leap') ),
								
								array( "label" => __("Background image for compact bar and expanded bar",'leap')  , "name" => "LEAP_compact_bgimage" , "type" => "upload"  , "default" => "" , "value" => "", "description" => __("Applies to both styles.",'leap')  ),
								
								array( "label" => __("Background Position for compact bar and expanded bar",'leap')  , "name" => "LEAP_compact_posimage" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Applies to both styles.",'leap')  ),

								),
								
							__("Compact Bar settings",'leap') => array(

								array( "label" => __("Add title",'leap')  , "name" => "LEAP_compact_title" , "type" => "textarea"  , "default" => "Chat with Us" , "value" => "" , "description" => __("Set Title for bar when leap is first visible in compact style.",'leap') ),
								
								array( "label" => __("Set Icon",'leap')  , "name" => "LEAP_compact_icon" , "type" => "upload"  , "default" => "" , "value" => "", "description" => __("Set Image Icon for Compact style.",'leap')  ),

								),
								
							__("Expanded Bar Settings",'leap') => array(

								array( "label" => __("Title Colour",'leap')  , "name" => "LEAP_compactbar_title" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set title colour here.",'leap') ),
								
								array( "label" => __("Title Top Position",'leap')  , "name" => "LEAP_title_pos_top" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Set the top position of the title here. e.g. 10px or 2%",'leap')  ),
								
								array( "label" => __("Title Left Position",'leap')  , "name" => "LEAP_title_pos_left" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Set the left position of the title here. e.g. 10px or 2%",'leap')  ),
								
								array( "label" => __("Title Width",'leap')  , "name" => "LEAP_title_pos_width" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Set the width for the title area here. Example 100px or 50% ",'leap')  ),
								
								array( "label" => __("Title Font Size",'leap')  , "name" => "LEAP_title_fz" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Set custom font size for title from here. Example 14px",'leap')  ),
								
								array( "label" => __("Set logo",'leap')  , "name" => "LEAP_expand_icon" , "type" => "upload"  , "default" => "" , "value" => "", "description" => __("Set Logo for expanded style bar.",'leap')  ),

								array( "label" => __("Logo Top Position",'leap')  , "name" => "LEAP_image_pos_top" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Set the left position of the logo here. Example 10px or 2%",'leap')  ),
								
								array( "label" => __("Logo Left Position",'leap')  , "name" => "LEAP_image_pos_left" , "type" => "text"  , "default" => "" , "value" => "", "description" => __("Set the left position of the logo here. Example 10px or 2%",'leap')  ),
								
								),
								
							__("Chatbox Settings",'leap') => array(
								
								array( "label" => __("Set Message on Chat Start",'leap')  , "name" => "LEAP_start_msg" , "type" => "textarea"  , "default" => "Hi, My name is {name} , how can I help you ? " , "value" => "", "description" => __("Set the Message you wan to show when chat session has started. Use {name} if you want add assigned operator name.",'leap') ),
								
								array( "label" => __("Set Effect for messages",'leap')  , "name" => "LEAP_message_effect" , "type" => "select"  , "default" => "bounce", "options" => array("none" => __("None",'leap') , "bounce" => __("Bounce",'leap') , "fade" => __("Fade",'leap') ) , "value" => "" , "description" => __("When you don't want vistors to use live chat, set this option to yes and users will see a contact form instead.",'leap') ),
								
								array( "label" => __("Select Users for Live Chat Access" ,'leap') , "name" => "LEAP_chat_users" , "type" => "checkbox" , "options" => $u , "default" => "" , "value" => "" , "description" => __("Select which users should have access to chat Admin Panel from here.",'leap')),
								
								array( "label" => __("Enable Chat for Logged In Users only",'leap')  , "name" => "LEAP_logged_user_only" , "type" => "select" , "options" => array("yes" => "Yes" , "no" => "No") , "default" => "no" , "value" => "no" , "description" => __("If you want to allow only logged in users to view live chat , set this option to Yes.",'leap')),
								
								array( "label" => __("Set Title for Chat box when Opened",'leap')  , "name" => "LEAP_chat_box_title" , "type" => "text"  , "default" => "Live Anytime !" , "value" => "" , "description" => __("You can set the title of chat box when chat box has been opened.",'leap') ),

								array( "label" => __("Chat Box Title Background Colour",'leap')  , "name" => "LEAP_chatbar_bg" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for Chat Box Title from here.",'leap') ),
								
								array( "label" => __("Chat Box  Title Colour",'leap')  , "name" => "LEAP_chatbar_title" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for Chat Box Title from here.",'leap') ),

								array( "label" => __("Chat Box Background Colour",'leap')  , "name" => "LEAP_chatbox" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for Chat Box.",'leap') ),
								
								array( "label" => __("Chat Box Chat Message Text Colour",'leap')  , "name" => "LEAP_chatbox_msg" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set colour for Chat Box.",'leap') ),
								
								array( "label" => __("Chat Box Chat Message User Name Colour",'leap')  , "name" => "LEAP_chatbox_label" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set colour for Chat Box name labels.",'leap') ),
								
								array( "label" => __("Chat Box Chat Message Time Colour",'leap')  , "name" => "LEAP_chatbox_time" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set colour for Chat Box name labels.",'leap') ),
								
								array( "label" => __("Chat Box Text Colour",'leap')  , "name" => "LEAP_chatbox_text" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set colour for Chat Box.",'leap') ),

								array( "label" => __("Chat Box Inputs & Text-area Background Colour",'leap')  , "name" => "LEAP_chatbox_input_bg" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for Chat Box Inputs.",'leap') ),
								
								array( "label" => __("Chat Box Inputs & Text-area border colour",'leap')  , "name" => "LEAP_chatbox_input_br" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set border colour for Chat Box Inputs.",'leap') ),
								
								array( "label" => __("Chat Box Inputs & Text-area text colour",'leap')  , "name" => "LEAP_chatbox_input_cr" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set colour for Chat Box Inputs.",'leap') ),

								array( "label" => __("Chat Box Button Background",'leap')  , "name" => "LEAP_chatbox_button_bg" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for the chat box button.",'leap') ),

                                array( "label" => __("Chat Box Button Background on hover",'leap')  , "name" => "LEAP_chatbox_button_bg_hover" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for the chat box button on hover.",'leap') ),
								
								array( "label" => __("Chat Box Button Text Colour",'leap')  , "name" => "LEAP_chatbox_button_cr" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set text colour for the chat box button.",'leap') ),

                                array( "label" => __("Chat Box Button Text Colour on hover",'leap')  , "name" => "LEAP_chatbox_button_cr_hover" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set text colour for the chat box button on hover.",'leap') ),
								
								array( "label" => __("Operator Information Background Colour",'leap')  , "name" => "LEAP_chatbox_op_bg" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set background colour for Chat Box operator.",'leap') ),
								
								array( "label" => __("Operator Information Border Colour",'leap')  , "name" => "LEAP_chatbox_op_br" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set border colour for Chat Box operator.",'leap') ),

								array( "label" => __("Operator Information Title Colour",'leap')  , "name" => "LEAP_chatbox_op_title" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set title colour for Chat Box operator.",'leap') ),
								
								array( "label" => __("Operator Information Designation Colour",'leap')  , "name" => "LEAP_chatbox_op_subtitle" , "type" => "colorpicker"  , "default" => "", "value" => "" , "description" => __("Set designation colour for Chat Box operator.",'leap') ),
								
								),
								
							__("Offline Mode Settings",'leap') => array(

								array( "label" => __("Set Title  when chat is offline",'leap')  , "name" => "LEAP_chat_offline_box_title" , "type" => "text"  , "default" => "We are Offline" , "value" => "" , "description" => __("This title will appear when chat is set in offline mode",'leap')  ),

								array( "label" => __("Chat Box Height in offline mode",'leap')  , "name" => "LEAP_chat_offline_height" , "type" => "text"  , "default" => "", "value" => "" , "description" => __("Set height of chat box in offline mode in numbers only example 400.",'leap') ),

								array( "label" => __("Set Message when chat is offline",'leap')  , "name" => "LEAP_offline_msg" , "type" => "textarea"  , "default" => "This message will appear when chat is set in offline mode" , "value" => "" ),
								array( "label" => __("Confirmation message when message is sent",'leap')  , "name" => "LEAP_offline_s_msg" , "type" => "textarea"  , "default" => "Thank you for contacting us, We will be in touch shortly." , "value" => "","description" => __("This message will show once mail has been sent.","leap") ),

								array( "label" => __("Set email for to receive offline messages",'leap')  , "name" => "LEAP_offline_email" , "type" => "text"  , "default" => "" , "value" => ""  , "description" => __("Mails from contact form will be sent to this mail , when chat is in offline mode.",'leap') ),
								
								
								array( 'inputs' => $inps, 'label' => __('Set Offline Contact Form Inputs' ,'leap') , 	'name' => 'rad_offline_tab','type'=>'module','unit' => __(' Input','leap') , "description" => __('You can set offline contact form inputs fields here.','leap')   ),
								),

						);

					?>
					<ul class='leap-admin-nav clearfix'>
						<?php
						$i =0;
						foreach ($panels as $key => $panel) {
						?>
							<li  class="<?php if($i==0) echo 'active'; $i++; ?>"><a href="#<?php echo str_replace(' ','_',$key) ?>"><?php echo $key ?></a></li>
						<?php
						} ?>
					</ul>

					<div class="clearfix leap-admin-settings">
						<?php

						foreach ($panels as $key => $panel) {
						?>
							<div  id="<?php echo str_replace(' ','_',$key) ?>">
								<?php 
								foreach ($panel as $key => $input) {
									$te = $input;

									if(get_option($input['name']))	
										$te['value'] = get_option($input['name']);
										
									echo getIOAInput($te);
								}

								 ?>
							</div>
						<?php
						} ?>
					</div>
					

					<div class="ioa-padding-30">
						<a class="button-save save_leap_settings" id=""><?php _e('Save Settings','leap') ?></a>
					</div>
				</div>
			
	         		</div>       	
	        	 </div>       	



		<?php
	

	    
	 }
	 

}



