<?php 

global $leap_google_webfonts;

/**
 * Global variable for fonts list.
 * @var array
 */

$leap_google_webfonts =  array( 
 'ABeeZee' => array('name'=>'ABeeZee','category'=>'sans-serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Abel' => array('name'=>'Abel','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Abril Fatface' => array('name'=>'Abril Fatface','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Aclonica' => array('name'=>'Aclonica','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Acme' => array('name'=>'Acme','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Actor' => array('name'=>'Actor','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Adamina' => array('name'=>'Adamina','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Advent Pro' => array('name'=>'Advent Pro','category'=>'sans-serif','variants' => '100,200,300,400,500,600,700'  , 'subsets' => 'latin-ext:greek:latin' ) 
, 'Aguafina Script' => array('name'=>'Aguafina Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Akronim' => array('name'=>'Akronim','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Aladin' => array('name'=>'Aladin','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Aldrich' => array('name'=>'Aldrich','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Alef' => array('name'=>'Alef','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Alegreya' => array('name'=>'Alegreya','category'=>'serif','variants' => '400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Alegreya SC' => array('name'=>'Alegreya SC','category'=>'serif','variants' => '400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Alegreya Sans' => array('name'=>'Alegreya Sans','category'=>'sans-serif','variants' => '100,100italic,300,300italic,400,italic,500,500italic,700,700italic,800,800italic,900,900italic'  , 'subsets' => 'latin-ext:latin:vietnamese' ) 
, 'Alegreya Sans SC' => array('name'=>'Alegreya Sans SC','category'=>'sans-serif','variants' => '100,100italic,300,300italic,400,italic,500,500italic,700,700italic,800,800italic,900,900italic'  , 'subsets' => 'latin-ext:latin:vietnamese' ) 
, 'Alex Brush' => array('name'=>'Alex Brush','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Alfa Slab One' => array('name'=>'Alfa Slab One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Alice' => array('name'=>'Alice','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Alike' => array('name'=>'Alike','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Alike Angular' => array('name'=>'Alike Angular','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Allan' => array('name'=>'Allan','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Allerta' => array('name'=>'Allerta','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Allerta Stencil' => array('name'=>'Allerta Stencil','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Allura' => array('name'=>'Allura','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Almendra' => array('name'=>'Almendra','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Almendra Display' => array('name'=>'Almendra Display','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Almendra SC' => array('name'=>'Almendra SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Amarante' => array('name'=>'Amarante','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Amaranth' => array('name'=>'Amaranth','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Amatic SC' => array('name'=>'Amatic SC','category'=>'handwriting','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Amethysta' => array('name'=>'Amethysta','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Anaheim' => array('name'=>'Anaheim','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Andada' => array('name'=>'Andada','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Andika' => array('name'=>'Andika','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Angkor' => array('name'=>'Angkor','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Annie Use Your Telescope' => array('name'=>'Annie Use Your Telescope','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Anonymous Pro' => array('name'=>'Anonymous Pro','category'=>'monospace','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Antic' => array('name'=>'Antic','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Antic Didone' => array('name'=>'Antic Didone','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Antic Slab' => array('name'=>'Antic Slab','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Anton' => array('name'=>'Anton','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Arapey' => array('name'=>'Arapey','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Arbutus' => array('name'=>'Arbutus','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Arbutus Slab' => array('name'=>'Arbutus Slab','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Architects Daughter' => array('name'=>'Architects Daughter','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Archivo Black' => array('name'=>'Archivo Black','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Archivo Narrow' => array('name'=>'Archivo Narrow','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Arimo' => array('name'=>'Arimo','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Arizonia' => array('name'=>'Arizonia','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Armata' => array('name'=>'Armata','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Artifika' => array('name'=>'Artifika','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Arvo' => array('name'=>'Arvo','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Asap' => array('name'=>'Asap','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Asset' => array('name'=>'Asset','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Astloch' => array('name'=>'Astloch','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Asul' => array('name'=>'Asul','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Atomic Age' => array('name'=>'Atomic Age','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Aubrey' => array('name'=>'Aubrey','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Audiowide' => array('name'=>'Audiowide','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Autour One' => array('name'=>'Autour One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Average' => array('name'=>'Average','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Average Sans' => array('name'=>'Average Sans','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Averia Gruesa Libre' => array('name'=>'Averia Gruesa Libre','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Averia Libre' => array('name'=>'Averia Libre','category'=>'display','variants' => '300,300italic,400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Averia Sans Libre' => array('name'=>'Averia Sans Libre','category'=>'display','variants' => '300,300italic,400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Averia Serif Libre' => array('name'=>'Averia Serif Libre','category'=>'display','variants' => '300,300italic,400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Bad Script' => array('name'=>'Bad Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin:cyrillic' ) 
, 'Balthazar' => array('name'=>'Balthazar','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bangers' => array('name'=>'Bangers','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Basic' => array('name'=>'Basic','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Battambang' => array('name'=>'Battambang','category'=>'display','variants' => '400,700'  , 'subsets' => 'khmer' ) 
, 'Baumans' => array('name'=>'Baumans','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bayon' => array('name'=>'Bayon','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Belgrano' => array('name'=>'Belgrano','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Belleza' => array('name'=>'Belleza','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'BenchNine' => array('name'=>'BenchNine','category'=>'sans-serif','variants' => '300,400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bentham' => array('name'=>'Bentham','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Berkshire Swash' => array('name'=>'Berkshire Swash','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bevan' => array('name'=>'Bevan','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bigelow Rules' => array('name'=>'Bigelow Rules','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bigshot One' => array('name'=>'Bigshot One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bilbo' => array('name'=>'Bilbo','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bilbo Swash Caps' => array('name'=>'Bilbo Swash Caps','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bitter' => array('name'=>'Bitter','category'=>'serif','variants' => '400,italic,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Black Ops One' => array('name'=>'Black Ops One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bokor' => array('name'=>'Bokor','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Bonbon' => array('name'=>'Bonbon','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Boogaloo' => array('name'=>'Boogaloo','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bowlby One' => array('name'=>'Bowlby One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bowlby One SC' => array('name'=>'Bowlby One SC','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Brawler' => array('name'=>'Brawler','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Bree Serif' => array('name'=>'Bree Serif','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bubblegum Sans' => array('name'=>'Bubblegum Sans','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Bubbler One' => array('name'=>'Bubbler One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Buda' => array('name'=>'Buda','category'=>'display','variants' => '300'  , 'subsets' => 'latin' ) 
, 'Buenard' => array('name'=>'Buenard','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Butcherman' => array('name'=>'Butcherman','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Butterfly Kids' => array('name'=>'Butterfly Kids','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Cabin' => array('name'=>'Cabin','category'=>'sans-serif','variants' => '400,italic,500,500italic,600,600italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Cabin Condensed' => array('name'=>'Cabin Condensed','category'=>'sans-serif','variants' => '400,500,600,700'  , 'subsets' => 'latin' ) 
, 'Cabin Sketch' => array('name'=>'Cabin Sketch','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Caesar Dressing' => array('name'=>'Caesar Dressing','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Cagliostro' => array('name'=>'Cagliostro','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Calligraffitti' => array('name'=>'Calligraffitti','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Cambo' => array('name'=>'Cambo','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Candal' => array('name'=>'Candal','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Cantarell' => array('name'=>'Cantarell','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Cantata One' => array('name'=>'Cantata One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Cantora One' => array('name'=>'Cantora One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Capriola' => array('name'=>'Capriola','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Cardo' => array('name'=>'Cardo','category'=>'serif','variants' => '400,italic,700'  , 'subsets' => 'latin-ext:greek:latin:greek-ext' ) 
, 'Carme' => array('name'=>'Carme','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Carrois Gothic' => array('name'=>'Carrois Gothic','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Carrois Gothic SC' => array('name'=>'Carrois Gothic SC','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Carter One' => array('name'=>'Carter One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Caudex' => array('name'=>'Caudex','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:greek:latin:greek-ext' ) 
, 'Cedarville Cursive' => array('name'=>'Cedarville Cursive','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Ceviche One' => array('name'=>'Ceviche One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Changa One' => array('name'=>'Changa One','category'=>'display','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Chango' => array('name'=>'Chango','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Chau Philomene One' => array('name'=>'Chau Philomene One','category'=>'sans-serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Chela One' => array('name'=>'Chela One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Chelsea Market' => array('name'=>'Chelsea Market','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Chenla' => array('name'=>'Chenla','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Cherry Cream Soda' => array('name'=>'Cherry Cream Soda','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Cherry Swash' => array('name'=>'Cherry Swash','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Chewy' => array('name'=>'Chewy','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Chicle' => array('name'=>'Chicle','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Chivo' => array('name'=>'Chivo','category'=>'sans-serif','variants' => '400,italic,900,900italic'  , 'subsets' => 'latin' ) 
, 'Cinzel' => array('name'=>'Cinzel','category'=>'serif','variants' => '400,700,900'  , 'subsets' => 'latin' ) 
, 'Cinzel Decorative' => array('name'=>'Cinzel Decorative','category'=>'display','variants' => '400,700,900'  , 'subsets' => 'latin' ) 
, 'Clicker Script' => array('name'=>'Clicker Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Coda' => array('name'=>'Coda','category'=>'display','variants' => '400,800'  , 'subsets' => 'latin' ) 
, 'Coda Caption' => array('name'=>'Coda Caption','category'=>'sans-serif','variants' => '800'  , 'subsets' => 'latin' ) 
, 'Codystar' => array('name'=>'Codystar','category'=>'display','variants' => '300,400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Combo' => array('name'=>'Combo','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Comfortaa' => array('name'=>'Comfortaa','category'=>'display','variants' => '300,400,700'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic' ) 
, 'Coming Soon' => array('name'=>'Coming Soon','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Concert One' => array('name'=>'Concert One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Condiment' => array('name'=>'Condiment','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Content' => array('name'=>'Content','category'=>'display','variants' => '400,700'  , 'subsets' => 'khmer' ) 
, 'Contrail One' => array('name'=>'Contrail One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Convergence' => array('name'=>'Convergence','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Cookie' => array('name'=>'Cookie','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Copse' => array('name'=>'Copse','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Corben' => array('name'=>'Corben','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Courgette' => array('name'=>'Courgette','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Cousine' => array('name'=>'Cousine','category'=>'monospace','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Coustard' => array('name'=>'Coustard','category'=>'serif','variants' => '400,900'  , 'subsets' => 'latin' ) 
, 'Covered By Your Grace' => array('name'=>'Covered By Your Grace','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Crafty Girls' => array('name'=>'Crafty Girls','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Creepster' => array('name'=>'Creepster','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Crete Round' => array('name'=>'Crete Round','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Crimson Text' => array('name'=>'Crimson Text','category'=>'serif','variants' => '400,italic,600,600italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Croissant One' => array('name'=>'Croissant One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Crushed' => array('name'=>'Crushed','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Cuprum' => array('name'=>'Cuprum','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Cutive' => array('name'=>'Cutive','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Cutive Mono' => array('name'=>'Cutive Mono','category'=>'monospace','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Damion' => array('name'=>'Damion','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Dancing Script' => array('name'=>'Dancing Script','category'=>'handwriting','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Dangrek' => array('name'=>'Dangrek','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Dawning of a New Day' => array('name'=>'Dawning of a New Day','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Days One' => array('name'=>'Days One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Delius' => array('name'=>'Delius','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Delius Swash Caps' => array('name'=>'Delius Swash Caps','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Delius Unicase' => array('name'=>'Delius Unicase','category'=>'handwriting','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Della Respira' => array('name'=>'Della Respira','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Denk One' => array('name'=>'Denk One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Devonshire' => array('name'=>'Devonshire','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Didact Gothic' => array('name'=>'Didact Gothic','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Diplomata' => array('name'=>'Diplomata','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Diplomata SC' => array('name'=>'Diplomata SC','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Domine' => array('name'=>'Domine','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Donegal One' => array('name'=>'Donegal One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Doppio One' => array('name'=>'Doppio One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Dorsa' => array('name'=>'Dorsa','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Dosis' => array('name'=>'Dosis','category'=>'sans-serif','variants' => '200,300,400,500,600,700,800'  , 'subsets' => 'latin-ext:latin' ) 
, 'Dr Sugiyama' => array('name'=>'Dr Sugiyama','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Droid Sans' => array('name'=>'Droid Sans','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Droid Sans Mono' => array('name'=>'Droid Sans Mono','category'=>'monospace','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Droid Serif' => array('name'=>'Droid Serif','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Duru Sans' => array('name'=>'Duru Sans','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Dynalight' => array('name'=>'Dynalight','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'EB Garamond' => array('name'=>'EB Garamond','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:vietnamese:cyrillic' ) 
, 'Eagle Lake' => array('name'=>'Eagle Lake','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Eater' => array('name'=>'Eater','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Economica' => array('name'=>'Economica','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ek Mukta' => array('name'=>'Ek Mukta','category'=>'sans-serif','variants' => '200,300,400,500,600,700,800'  , 'subsets' => 'latin-ext:latin:devanagari' ) 
, 'Electrolize' => array('name'=>'Electrolize','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Elsie' => array('name'=>'Elsie','category'=>'display','variants' => '400,900'  , 'subsets' => 'latin-ext:latin' ) 
, 'Elsie Swash Caps' => array('name'=>'Elsie Swash Caps','category'=>'display','variants' => '400,900'  , 'subsets' => 'latin-ext:latin' ) 
, 'Emblema One' => array('name'=>'Emblema One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Emilys Candy' => array('name'=>'Emilys Candy','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Engagement' => array('name'=>'Engagement','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Englebert' => array('name'=>'Englebert','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Enriqueta' => array('name'=>'Enriqueta','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Erica One' => array('name'=>'Erica One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Esteban' => array('name'=>'Esteban','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Euphoria Script' => array('name'=>'Euphoria Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ewert' => array('name'=>'Ewert','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Exo' => array('name'=>'Exo','category'=>'sans-serif','variants' => '100,100italic,200,200italic,300,300italic,400,italic,500,500italic,600,600italic,700,700italic,800,800italic,900,900italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Exo 2' => array('name'=>'Exo 2','category'=>'sans-serif','variants' => '100,100italic,200,200italic,300,300italic,400,italic,500,500italic,600,600italic,700,700italic,800,800italic,900,900italic'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Expletus Sans' => array('name'=>'Expletus Sans','category'=>'display','variants' => '400,italic,500,500italic,600,600italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Fanwood Text' => array('name'=>'Fanwood Text','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Fascinate' => array('name'=>'Fascinate','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Fascinate Inline' => array('name'=>'Fascinate Inline','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Faster One' => array('name'=>'Faster One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Fasthand' => array('name'=>'Fasthand','category'=>'serif','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Fauna One' => array('name'=>'Fauna One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Federant' => array('name'=>'Federant','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Federo' => array('name'=>'Federo','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Felipa' => array('name'=>'Felipa','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Fenix' => array('name'=>'Fenix','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Finger Paint' => array('name'=>'Finger Paint','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Fira Mono' => array('name'=>'Fira Mono','category'=>'monospace','variants' => '400,700'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic' ) 
, 'Fira Sans' => array('name'=>'Fira Sans','category'=>'sans-serif','variants' => '300,300italic,400,italic,500,500italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic' ) 
, 'Fjalla One' => array('name'=>'Fjalla One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Fjord One' => array('name'=>'Fjord One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Flamenco' => array('name'=>'Flamenco','category'=>'display','variants' => '300,400'  , 'subsets' => 'latin' ) 
, 'Flavors' => array('name'=>'Flavors','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Fondamento' => array('name'=>'Fondamento','category'=>'handwriting','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Fontdiner Swanky' => array('name'=>'Fontdiner Swanky','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Forum' => array('name'=>'Forum','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Francois One' => array('name'=>'Francois One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Freckle Face' => array('name'=>'Freckle Face','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Fredericka the Great' => array('name'=>'Fredericka the Great','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Fredoka One' => array('name'=>'Fredoka One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Freehand' => array('name'=>'Freehand','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Fresca' => array('name'=>'Fresca','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Frijole' => array('name'=>'Frijole','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Fruktur' => array('name'=>'Fruktur','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Fugaz One' => array('name'=>'Fugaz One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'GFS Didot' => array('name'=>'GFS Didot','category'=>'serif','variants' => '400'  , 'subsets' => 'greek' ) 
, 'GFS Neohellenic' => array('name'=>'GFS Neohellenic','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'greek' ) 
, 'Gabriela' => array('name'=>'Gabriela','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gafata' => array('name'=>'Gafata','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Galdeano' => array('name'=>'Galdeano','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Galindo' => array('name'=>'Galindo','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gentium Basic' => array('name'=>'Gentium Basic','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gentium Book Basic' => array('name'=>'Gentium Book Basic','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Geo' => array('name'=>'Geo','category'=>'sans-serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Geostar' => array('name'=>'Geostar','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Geostar Fill' => array('name'=>'Geostar Fill','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Germania One' => array('name'=>'Germania One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Gilda Display' => array('name'=>'Gilda Display','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Give You Glory' => array('name'=>'Give You Glory','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Glass Antiqua' => array('name'=>'Glass Antiqua','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Glegoo' => array('name'=>'Glegoo','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gloria Hallelujah' => array('name'=>'Gloria Hallelujah','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Goblin One' => array('name'=>'Goblin One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Gochi Hand' => array('name'=>'Gochi Hand','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Gorditas' => array('name'=>'Gorditas','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Goudy Bookletter 1911' => array('name'=>'Goudy Bookletter 1911','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Graduate' => array('name'=>'Graduate','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Grand Hotel' => array('name'=>'Grand Hotel','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gravitas One' => array('name'=>'Gravitas One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Great Vibes' => array('name'=>'Great Vibes','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Griffy' => array('name'=>'Griffy','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gruppo' => array('name'=>'Gruppo','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Gudea' => array('name'=>'Gudea','category'=>'sans-serif','variants' => '400,italic,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Habibi' => array('name'=>'Habibi','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Hammersmith One' => array('name'=>'Hammersmith One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Hanalei' => array('name'=>'Hanalei','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Hanalei Fill' => array('name'=>'Hanalei Fill','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Handlee' => array('name'=>'Handlee','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Hanuman' => array('name'=>'Hanuman','category'=>'serif','variants' => '400,700'  , 'subsets' => 'khmer' ) 
, 'Happy Monkey' => array('name'=>'Happy Monkey','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Headland One' => array('name'=>'Headland One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Henny Penny' => array('name'=>'Henny Penny','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Herr Von Muellerhoff' => array('name'=>'Herr Von Muellerhoff','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Holtwood One SC' => array('name'=>'Holtwood One SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Homemade Apple' => array('name'=>'Homemade Apple','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Homenaje' => array('name'=>'Homenaje','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'IM Fell DW Pica' => array('name'=>'IM Fell DW Pica','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'IM Fell DW Pica SC' => array('name'=>'IM Fell DW Pica SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'IM Fell Double Pica' => array('name'=>'IM Fell Double Pica','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'IM Fell Double Pica SC' => array('name'=>'IM Fell Double Pica SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'IM Fell English' => array('name'=>'IM Fell English','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'IM Fell English SC' => array('name'=>'IM Fell English SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'IM Fell French Canon' => array('name'=>'IM Fell French Canon','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'IM Fell French Canon SC' => array('name'=>'IM Fell French Canon SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'IM Fell Great Primer' => array('name'=>'IM Fell Great Primer','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'IM Fell Great Primer SC' => array('name'=>'IM Fell Great Primer SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Iceberg' => array('name'=>'Iceberg','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Iceland' => array('name'=>'Iceland','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Imprima' => array('name'=>'Imprima','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Inconsolata' => array('name'=>'Inconsolata','category'=>'monospace','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Inder' => array('name'=>'Inder','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Indie Flower' => array('name'=>'Indie Flower','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Inika' => array('name'=>'Inika','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Irish Grover' => array('name'=>'Irish Grover','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Istok Web' => array('name'=>'Istok Web','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Italiana' => array('name'=>'Italiana','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Italianno' => array('name'=>'Italianno','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Jacques Francois' => array('name'=>'Jacques Francois','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Jacques Francois Shadow' => array('name'=>'Jacques Francois Shadow','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Jim Nightshade' => array('name'=>'Jim Nightshade','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Jockey One' => array('name'=>'Jockey One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Jolly Lodger' => array('name'=>'Jolly Lodger','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Josefin Sans' => array('name'=>'Josefin Sans','category'=>'sans-serif','variants' => '100,100italic,300,300italic,400,italic,600,600italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Josefin Slab' => array('name'=>'Josefin Slab','category'=>'serif','variants' => '100,100italic,300,300italic,400,italic,600,600italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Joti One' => array('name'=>'Joti One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Judson' => array('name'=>'Judson','category'=>'serif','variants' => '400,italic,700'  , 'subsets' => 'latin' ) 
, 'Julee' => array('name'=>'Julee','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Julius Sans One' => array('name'=>'Julius Sans One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Junge' => array('name'=>'Junge','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Jura' => array('name'=>'Jura','category'=>'sans-serif','variants' => '300,400,500,600'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Just Another Hand' => array('name'=>'Just Another Hand','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Just Me Again Down Here' => array('name'=>'Just Me Again Down Here','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Kameron' => array('name'=>'Kameron','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Kantumruy' => array('name'=>'Kantumruy','category'=>'sans-serif','variants' => '300,400,700'  , 'subsets' => 'khmer' ) 
, 'Karla' => array('name'=>'Karla','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Kaushan Script' => array('name'=>'Kaushan Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Kavoon' => array('name'=>'Kavoon','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Kdam Thmor' => array('name'=>'Kdam Thmor','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Keania One' => array('name'=>'Keania One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Kelly Slab' => array('name'=>'Kelly Slab','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Kenia' => array('name'=>'Kenia','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Khmer' => array('name'=>'Khmer','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Kite One' => array('name'=>'Kite One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Knewave' => array('name'=>'Knewave','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Kotta One' => array('name'=>'Kotta One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Koulen' => array('name'=>'Koulen','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Kranky' => array('name'=>'Kranky','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Kreon' => array('name'=>'Kreon','category'=>'serif','variants' => '300,400,700'  , 'subsets' => 'latin' ) 
, 'Kristi' => array('name'=>'Kristi','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Krona One' => array('name'=>'Krona One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'La Belle Aurore' => array('name'=>'La Belle Aurore','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Lancelot' => array('name'=>'Lancelot','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Lato' => array('name'=>'Lato','category'=>'sans-serif','variants' => '100,100italic,300,300italic,400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin' ) 
, 'League Script' => array('name'=>'League Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Leckerli One' => array('name'=>'Leckerli One','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Ledger' => array('name'=>'Ledger','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Lekton' => array('name'=>'Lekton','category'=>'sans-serif','variants' => '400,italic,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Lemon' => array('name'=>'Lemon','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Libre Baskerville' => array('name'=>'Libre Baskerville','category'=>'serif','variants' => '400,italic,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Life Savers' => array('name'=>'Life Savers','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Lilita One' => array('name'=>'Lilita One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Lily Script One' => array('name'=>'Lily Script One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Limelight' => array('name'=>'Limelight','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Linden Hill' => array('name'=>'Linden Hill','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Lobster' => array('name'=>'Lobster','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Lobster Two' => array('name'=>'Lobster Two','category'=>'display','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Londrina Outline' => array('name'=>'Londrina Outline','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Londrina Shadow' => array('name'=>'Londrina Shadow','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Londrina Sketch' => array('name'=>'Londrina Sketch','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Londrina Solid' => array('name'=>'Londrina Solid','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Lora' => array('name'=>'Lora','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Love Ya Like A Sister' => array('name'=>'Love Ya Like A Sister','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Loved by the King' => array('name'=>'Loved by the King','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Lovers Quarrel' => array('name'=>'Lovers Quarrel','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Luckiest Guy' => array('name'=>'Luckiest Guy','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Lusitana' => array('name'=>'Lusitana','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Lustria' => array('name'=>'Lustria','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Macondo' => array('name'=>'Macondo','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Macondo Swash Caps' => array('name'=>'Macondo Swash Caps','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Magra' => array('name'=>'Magra','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Maiden Orange' => array('name'=>'Maiden Orange','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Mako' => array('name'=>'Mako','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Marcellus' => array('name'=>'Marcellus','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Marcellus SC' => array('name'=>'Marcellus SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Marck Script' => array('name'=>'Marck Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Margarine' => array('name'=>'Margarine','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Marko One' => array('name'=>'Marko One','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Marmelad' => array('name'=>'Marmelad','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Marvel' => array('name'=>'Marvel','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Mate' => array('name'=>'Mate','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Mate SC' => array('name'=>'Mate SC','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Maven Pro' => array('name'=>'Maven Pro','category'=>'sans-serif','variants' => '400,500,700,900'  , 'subsets' => 'latin' ) 
, 'McLaren' => array('name'=>'McLaren','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Meddon' => array('name'=>'Meddon','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'MedievalSharp' => array('name'=>'MedievalSharp','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Medula One' => array('name'=>'Medula One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Megrim' => array('name'=>'Megrim','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Meie Script' => array('name'=>'Meie Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Merienda' => array('name'=>'Merienda','category'=>'handwriting','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Merienda One' => array('name'=>'Merienda One','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Merriweather' => array('name'=>'Merriweather','category'=>'serif','variants' => '300,300italic,400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Merriweather Sans' => array('name'=>'Merriweather Sans','category'=>'sans-serif','variants' => '300,300italic,400,italic,700,700italic,800,800italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Metal' => array('name'=>'Metal','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Metal Mania' => array('name'=>'Metal Mania','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Metamorphous' => array('name'=>'Metamorphous','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Metrophobic' => array('name'=>'Metrophobic','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Michroma' => array('name'=>'Michroma','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Milonga' => array('name'=>'Milonga','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Miltonian' => array('name'=>'Miltonian','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Miltonian Tattoo' => array('name'=>'Miltonian Tattoo','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Miniver' => array('name'=>'Miniver','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Miss Fajardose' => array('name'=>'Miss Fajardose','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Modern Antiqua' => array('name'=>'Modern Antiqua','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Molengo' => array('name'=>'Molengo','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Molle' => array('name'=>'Molle','category'=>'handwriting','variants' => 'italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Monda' => array('name'=>'Monda','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Monofett' => array('name'=>'Monofett','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Monoton' => array('name'=>'Monoton','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Monsieur La Doulaise' => array('name'=>'Monsieur La Doulaise','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Montaga' => array('name'=>'Montaga','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Montez' => array('name'=>'Montez','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Montserrat' => array('name'=>'Montserrat','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Montserrat Alternates' => array('name'=>'Montserrat Alternates','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Montserrat Subrayada' => array('name'=>'Montserrat Subrayada','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Moul' => array('name'=>'Moul','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Moulpali' => array('name'=>'Moulpali','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Mountains of Christmas' => array('name'=>'Mountains of Christmas','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Mouse Memoirs' => array('name'=>'Mouse Memoirs','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Mr Bedfort' => array('name'=>'Mr Bedfort','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Mr Dafoe' => array('name'=>'Mr Dafoe','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Mr De Haviland' => array('name'=>'Mr De Haviland','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Mrs Saint Delafield' => array('name'=>'Mrs Saint Delafield','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Mrs Sheppards' => array('name'=>'Mrs Sheppards','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Muli' => array('name'=>'Muli','category'=>'sans-serif','variants' => '300,300italic,400,italic'  , 'subsets' => 'latin' ) 
, 'Mystery Quest' => array('name'=>'Mystery Quest','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Neucha' => array('name'=>'Neucha','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin:cyrillic' ) 
, 'Neuton' => array('name'=>'Neuton','category'=>'serif','variants' => '200,300,400,italic,700,800'  , 'subsets' => 'latin-ext:latin' ) 
, 'New Rocker' => array('name'=>'New Rocker','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'News Cycle' => array('name'=>'News Cycle','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Niconne' => array('name'=>'Niconne','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Nixie One' => array('name'=>'Nixie One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nobile' => array('name'=>'Nobile','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Nokora' => array('name'=>'Nokora','category'=>'serif','variants' => '400,700'  , 'subsets' => 'khmer' ) 
, 'Norican' => array('name'=>'Norican','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Nosifer' => array('name'=>'Nosifer','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Nothing You Could Do' => array('name'=>'Nothing You Could Do','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Noticia Text' => array('name'=>'Noticia Text','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin:vietnamese' ) 
, 'Noto Sans' => array('name'=>'Noto Sans','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:devanagari:vietnamese:cyrillic:greek-ext' ) 
, 'Noto Serif' => array('name'=>'Noto Serif','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Nova Cut' => array('name'=>'Nova Cut','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nova Flat' => array('name'=>'Nova Flat','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nova Mono' => array('name'=>'Nova Mono','category'=>'monospace','variants' => '400'  , 'subsets' => 'greek:latin' ) 
, 'Nova Oval' => array('name'=>'Nova Oval','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nova Round' => array('name'=>'Nova Round','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nova Script' => array('name'=>'Nova Script','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nova Slim' => array('name'=>'Nova Slim','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nova Square' => array('name'=>'Nova Square','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Numans' => array('name'=>'Numans','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Nunito' => array('name'=>'Nunito','category'=>'sans-serif','variants' => '300,400,700'  , 'subsets' => 'latin' ) 
, 'Odor Mean Chey' => array('name'=>'Odor Mean Chey','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Offside' => array('name'=>'Offside','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Old Standard TT' => array('name'=>'Old Standard TT','category'=>'serif','variants' => '400,italic,700'  , 'subsets' => 'latin' ) 
, 'Oldenburg' => array('name'=>'Oldenburg','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Oleo Script' => array('name'=>'Oleo Script','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Oleo Script Swash Caps' => array('name'=>'Oleo Script Swash Caps','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Open Sans' => array('name'=>'Open Sans','category'=>'sans-serif','variants' => '300,300italic,400,italic,600,600italic,700,700italic,800,800italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:devanagari:vietnamese:cyrillic:greek-ext' ) 
, 'Open Sans Condensed' => array('name'=>'Open Sans Condensed','category'=>'sans-serif','variants' => '300,300italic,700'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Oranienbaum' => array('name'=>'Oranienbaum','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Orbitron' => array('name'=>'Orbitron','category'=>'sans-serif','variants' => '400,500,700,900'  , 'subsets' => 'latin' ) 
, 'Oregano' => array('name'=>'Oregano','category'=>'display','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Orienta' => array('name'=>'Orienta','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Original Surfer' => array('name'=>'Original Surfer','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Oswald' => array('name'=>'Oswald','category'=>'sans-serif','variants' => '300,400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Over the Rainbow' => array('name'=>'Over the Rainbow','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Overlock' => array('name'=>'Overlock','category'=>'display','variants' => '400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Overlock SC' => array('name'=>'Overlock SC','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ovo' => array('name'=>'Ovo','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Oxygen' => array('name'=>'Oxygen','category'=>'sans-serif','variants' => '300,400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Oxygen Mono' => array('name'=>'Oxygen Mono','category'=>'monospace','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'PT Mono' => array('name'=>'PT Mono','category'=>'monospace','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'PT Sans' => array('name'=>'PT Sans','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'PT Sans Caption' => array('name'=>'PT Sans Caption','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'PT Sans Narrow' => array('name'=>'PT Sans Narrow','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'PT Serif' => array('name'=>'PT Serif','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'PT Serif Caption' => array('name'=>'PT Serif Caption','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Pacifico' => array('name'=>'Pacifico','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Paprika' => array('name'=>'Paprika','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Parisienne' => array('name'=>'Parisienne','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Passero One' => array('name'=>'Passero One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Passion One' => array('name'=>'Passion One','category'=>'display','variants' => '400,700,900'  , 'subsets' => 'latin-ext:latin' ) 
, 'Pathway Gothic One' => array('name'=>'Pathway Gothic One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Patrick Hand' => array('name'=>'Patrick Hand','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin:vietnamese' ) 
, 'Patrick Hand SC' => array('name'=>'Patrick Hand SC','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin:vietnamese' ) 
, 'Patua One' => array('name'=>'Patua One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Paytone One' => array('name'=>'Paytone One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Peralta' => array('name'=>'Peralta','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Permanent Marker' => array('name'=>'Permanent Marker','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Petit Formal Script' => array('name'=>'Petit Formal Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Petrona' => array('name'=>'Petrona','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Philosopher' => array('name'=>'Philosopher','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin:cyrillic' ) 
, 'Piedra' => array('name'=>'Piedra','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Pinyon Script' => array('name'=>'Pinyon Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Pirata One' => array('name'=>'Pirata One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Plaster' => array('name'=>'Plaster','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Play' => array('name'=>'Play','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Playball' => array('name'=>'Playball','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Playfair Display' => array('name'=>'Playfair Display','category'=>'serif','variants' => '400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Playfair Display SC' => array('name'=>'Playfair Display SC','category'=>'serif','variants' => '400,italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Podkova' => array('name'=>'Podkova','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Poiret One' => array('name'=>'Poiret One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Poller One' => array('name'=>'Poller One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Poly' => array('name'=>'Poly','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin' ) 
, 'Pompiere' => array('name'=>'Pompiere','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Pontano Sans' => array('name'=>'Pontano Sans','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Port Lligat Sans' => array('name'=>'Port Lligat Sans','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Port Lligat Slab' => array('name'=>'Port Lligat Slab','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Prata' => array('name'=>'Prata','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Preahvihear' => array('name'=>'Preahvihear','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Press Start 2P' => array('name'=>'Press Start 2P','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:greek:latin:cyrillic' ) 
, 'Princess Sofia' => array('name'=>'Princess Sofia','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Prociono' => array('name'=>'Prociono','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Prosto One' => array('name'=>'Prosto One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Puritan' => array('name'=>'Puritan','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Purple Purse' => array('name'=>'Purple Purse','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Quando' => array('name'=>'Quando','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Quantico' => array('name'=>'Quantico','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Quattrocento' => array('name'=>'Quattrocento','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Quattrocento Sans' => array('name'=>'Quattrocento Sans','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Questrial' => array('name'=>'Questrial','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Quicksand' => array('name'=>'Quicksand','category'=>'sans-serif','variants' => '300,400,700'  , 'subsets' => 'latin' ) 
, 'Quintessential' => array('name'=>'Quintessential','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Qwigley' => array('name'=>'Qwigley','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Racing Sans One' => array('name'=>'Racing Sans One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Radley' => array('name'=>'Radley','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Raleway' => array('name'=>'Raleway','category'=>'sans-serif','variants' => '100,200,300,400,500,600,700,800,900'  , 'subsets' => 'latin' ) 
, 'Raleway Dots' => array('name'=>'Raleway Dots','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rambla' => array('name'=>'Rambla','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rammetto One' => array('name'=>'Rammetto One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ranchers' => array('name'=>'Ranchers','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rancho' => array('name'=>'Rancho','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Rationale' => array('name'=>'Rationale','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Redressed' => array('name'=>'Redressed','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Reenie Beanie' => array('name'=>'Reenie Beanie','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Revalia' => array('name'=>'Revalia','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ribeye' => array('name'=>'Ribeye','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ribeye Marrow' => array('name'=>'Ribeye Marrow','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Righteous' => array('name'=>'Righteous','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Risque' => array('name'=>'Risque','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Roboto' => array('name'=>'Roboto','category'=>'sans-serif','variants' => '100,100italic,300,300italic,400,italic,500,500italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Roboto Condensed' => array('name'=>'Roboto Condensed','category'=>'sans-serif','variants' => '300,300italic,400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Roboto Slab' => array('name'=>'Roboto Slab','category'=>'serif','variants' => '100,300,400,700'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Rochester' => array('name'=>'Rochester','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Rock Salt' => array('name'=>'Rock Salt','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Rokkitt' => array('name'=>'Rokkitt','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Romanesco' => array('name'=>'Romanesco','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ropa Sans' => array('name'=>'Ropa Sans','category'=>'sans-serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rosario' => array('name'=>'Rosario','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Rosarivo' => array('name'=>'Rosarivo','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rouge Script' => array('name'=>'Rouge Script','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Rubik Mono One' => array('name'=>'Rubik Mono One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rubik One' => array('name'=>'Rubik One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ruda' => array('name'=>'Ruda','category'=>'sans-serif','variants' => '400,700,900'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rufina' => array('name'=>'Rufina','category'=>'serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ruge Boogie' => array('name'=>'Ruge Boogie','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ruluko' => array('name'=>'Ruluko','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rum Raisin' => array('name'=>'Rum Raisin','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Ruslan Display' => array('name'=>'Ruslan Display','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Russo One' => array('name'=>'Russo One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Ruthie' => array('name'=>'Ruthie','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Rye' => array('name'=>'Rye','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sacramento' => array('name'=>'Sacramento','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sail' => array('name'=>'Sail','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Salsa' => array('name'=>'Salsa','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sanchez' => array('name'=>'Sanchez','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sancreek' => array('name'=>'Sancreek','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sansita One' => array('name'=>'Sansita One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sarina' => array('name'=>'Sarina','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Satisfy' => array('name'=>'Satisfy','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Scada' => array('name'=>'Scada','category'=>'sans-serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Schoolbell' => array('name'=>'Schoolbell','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Seaweed Script' => array('name'=>'Seaweed Script','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sevillana' => array('name'=>'Sevillana','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Seymour One' => array('name'=>'Seymour One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Shadows Into Light' => array('name'=>'Shadows Into Light','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Shadows Into Light Two' => array('name'=>'Shadows Into Light Two','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Shanti' => array('name'=>'Shanti','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Share' => array('name'=>'Share','category'=>'display','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Share Tech' => array('name'=>'Share Tech','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Share Tech Mono' => array('name'=>'Share Tech Mono','category'=>'monospace','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Shojumaru' => array('name'=>'Shojumaru','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Short Stack' => array('name'=>'Short Stack','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Siemreap' => array('name'=>'Siemreap','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Sigmar One' => array('name'=>'Sigmar One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Signika' => array('name'=>'Signika','category'=>'sans-serif','variants' => '300,400,600,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Signika Negative' => array('name'=>'Signika Negative','category'=>'sans-serif','variants' => '300,400,600,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Simonetta' => array('name'=>'Simonetta','category'=>'display','variants' => '400,italic,900,900italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sintony' => array('name'=>'Sintony','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sirin Stencil' => array('name'=>'Sirin Stencil','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Six Caps' => array('name'=>'Six Caps','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Skranji' => array('name'=>'Skranji','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Slackey' => array('name'=>'Slackey','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Smokum' => array('name'=>'Smokum','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Smythe' => array('name'=>'Smythe','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sniglet' => array('name'=>'Sniglet','category'=>'display','variants' => '400,800'  , 'subsets' => 'latin-ext:latin' ) 
, 'Snippet' => array('name'=>'Snippet','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Snowburst One' => array('name'=>'Snowburst One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sofadi One' => array('name'=>'Sofadi One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sofia' => array('name'=>'Sofia','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sonsie One' => array('name'=>'Sonsie One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Sorts Mill Goudy' => array('name'=>'Sorts Mill Goudy','category'=>'serif','variants' => '400,italic'  , 'subsets' => 'latin-ext:latin' ) 
, 'Source Code Pro' => array('name'=>'Source Code Pro','category'=>'monospace','variants' => '200,300,400,500,600,700,900'  , 'subsets' => 'latin-ext:latin' ) 
, 'Source Sans Pro' => array('name'=>'Source Sans Pro','category'=>'sans-serif','variants' => '200,200italic,300,300italic,400,italic,600,600italic,700,700italic,900,900italic'  , 'subsets' => 'latin-ext:latin:vietnamese' ) 
, 'Special Elite' => array('name'=>'Special Elite','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Spicy Rice' => array('name'=>'Spicy Rice','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Spinnaker' => array('name'=>'Spinnaker','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Spirax' => array('name'=>'Spirax','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Slabo 13px' => array('name'=>'Slabo 13px','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Squada One' => array('name'=>'Squada One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Stalemate' => array('name'=>'Stalemate','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Stalinist One' => array('name'=>'Stalinist One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Stardos Stencil' => array('name'=>'Stardos Stencil','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Stint Ultra Condensed' => array('name'=>'Stint Ultra Condensed','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Stint Ultra Expanded' => array('name'=>'Stint Ultra Expanded','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Stoke' => array('name'=>'Stoke','category'=>'serif','variants' => '300,400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Strait' => array('name'=>'Strait','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sue Ellen Francisco' => array('name'=>'Sue Ellen Francisco','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Sunshiney' => array('name'=>'Sunshiney','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Supermercado One' => array('name'=>'Supermercado One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Suwannaphum' => array('name'=>'Suwannaphum','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Swanky and Moo Moo' => array('name'=>'Swanky and Moo Moo','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Syncopate' => array('name'=>'Syncopate','category'=>'sans-serif','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Tangerine' => array('name'=>'Tangerine','category'=>'handwriting','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Taprom' => array('name'=>'Taprom','category'=>'display','variants' => '400'  , 'subsets' => 'khmer' ) 
, 'Tauri' => array('name'=>'Tauri','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Telex' => array('name'=>'Telex','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Tenor Sans' => array('name'=>'Tenor Sans','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:latin:cyrillic' ) 
, 'Text Me One' => array('name'=>'Text Me One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'The Girl Next Door' => array('name'=>'The Girl Next Door','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Tienne' => array('name'=>'Tienne','category'=>'serif','variants' => '400,700,900'  , 'subsets' => 'latin' ) 
, 'Tinos' => array('name'=>'Tinos','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:vietnamese:cyrillic:greek-ext' ) 
, 'Titan One' => array('name'=>'Titan One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Titillium Web' => array('name'=>'Titillium Web','category'=>'sans-serif','variants' => '200,200italic,300,300italic,400,italic,600,600italic,700,700italic,900'  , 'subsets' => 'latin-ext:latin' ) 
, 'Trade Winds' => array('name'=>'Trade Winds','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Trocchi' => array('name'=>'Trocchi','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Trochut' => array('name'=>'Trochut','category'=>'display','variants' => '400,italic,700'  , 'subsets' => 'latin' ) 
, 'Trykker' => array('name'=>'Trykker','category'=>'serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Tulpen One' => array('name'=>'Tulpen One','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Ubuntu' => array('name'=>'Ubuntu','category'=>'sans-serif','variants' => '300,300italic,400,italic,500,500italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Ubuntu Condensed' => array('name'=>'Ubuntu Condensed','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Ubuntu Mono' => array('name'=>'Ubuntu Mono','category'=>'monospace','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin-ext:cyrillic-ext:greek:latin:cyrillic:greek-ext' ) 
, 'Ultra' => array('name'=>'Ultra','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Uncial Antiqua' => array('name'=>'Uncial Antiqua','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Underdog' => array('name'=>'Underdog','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Unica One' => array('name'=>'Unica One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'UnifrakturCook' => array('name'=>'UnifrakturCook','category'=>'display','variants' => '700'  , 'subsets' => 'latin' ) 
, 'UnifrakturMaguntia' => array('name'=>'UnifrakturMaguntia','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Unkempt' => array('name'=>'Unkempt','category'=>'display','variants' => '400,700'  , 'subsets' => 'latin' ) 
, 'Unlock' => array('name'=>'Unlock','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Unna' => array('name'=>'Unna','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'VT323' => array('name'=>'VT323','category'=>'monospace','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Vampiro One' => array('name'=>'Vampiro One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Varela' => array('name'=>'Varela','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Varela Round' => array('name'=>'Varela Round','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Vast Shadow' => array('name'=>'Vast Shadow','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Vibur' => array('name'=>'Vibur','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Vidaloka' => array('name'=>'Vidaloka','category'=>'serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Viga' => array('name'=>'Viga','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Voces' => array('name'=>'Voces','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Volkhov' => array('name'=>'Volkhov','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Vollkorn' => array('name'=>'Vollkorn','category'=>'serif','variants' => '400,italic,700,700italic'  , 'subsets' => 'latin' ) 
, 'Voltaire' => array('name'=>'Voltaire','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Waiting for the Sunrise' => array('name'=>'Waiting for the Sunrise','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Wallpoet' => array('name'=>'Wallpoet','category'=>'display','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Walter Turncoat' => array('name'=>'Walter Turncoat','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Warnes' => array('name'=>'Warnes','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Wellfleet' => array('name'=>'Wellfleet','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Wendy One' => array('name'=>'Wendy One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin-ext:latin' ) 
, 'Wire One' => array('name'=>'Wire One','category'=>'sans-serif','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Yanone Kaffeesatz' => array('name'=>'Yanone Kaffeesatz','category'=>'sans-serif','variants' => '200,300,400,700'  , 'subsets' => 'latin-ext:latin' ) 
, 'Yellowtail' => array('name'=>'Yellowtail','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Yeseva One' => array('name'=>'Yeseva One','category'=>'display','variants' => '400'  , 'subsets' => 'latin-ext:latin:cyrillic' ) 
, 'Yesteryear' => array('name'=>'Yesteryear','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
, 'Zeyada' => array('name'=>'Zeyada','category'=>'handwriting','variants' => '400'  , 'subsets' => 'latin' ) 
 
) ;


$leap_websafe_fonts = array("Arial","Helvetica Neue","Helvetica",'Impact','Tahoma',"Verdana","Lucida Grande","Lucida Sans");


$leap_websafe_fonts = array(
"Century Gothic, CenturyGothic, AppleGothic, sans-serif",
"Tahoma, Geneva, sans-serif",
"Palatino Linotype, Book Antiqua, Palatino, serif",
"Impact, Charcoal, sans-serif",
"Lucida San Unicode, Lucida Grande, sans-serif",
"Arial Black, Gadget, sans-serif",
"Times New Roman, Times, serif",
"Arial Narrow, sans-serif",
"Verdana, Geneva, sans-serif",
"Copperplate, Copperplate Gothic Light, sans-serif",
"Lucida Console, Monaco, monospace",
"Gill Sans, Gill Sans MT, Calibri, sans-serif",
"Trebuchet MS, Helvetica, sans-serif",
"Courier New, Courier, monospace",
"Arial, Helvetica, sans-serif",
"Georgia, Serif",
"Helvetica Neue, Helvetica, Arial, sans-serif",
"Lucida Bright, Georgia, serif",
"Garamond, Baskerville, Baskerville Old Face, Hoefler Text, Times New Roman, serif",
"Goudy Old Style, Garamond, Big Caslon, Times New Roman, serif",
);

 ?>