/**
 *
 * Contains Code for the LEAP JS Plugin 
 *
 */


 jQuery(function(){

 	var chat_box  = jQuery('.leap-chat-box') , input = chat_box.find('.leap-chat-box-footer--input') , canvas = chat_box.find('.leap-chat-box-body--canvas') , indicator = chat_box.find('.leap-chat-typing-indicator') , indicator_timer , indicator_lock = false ; 	  
 		

	var LEAP_CHAT = {

	                status : 'new-connection',
                                  message : '',
                                  message_stamp : '',
                                  
                                  user_msg : '',
                                  user_id : '',
                                  user_flag : '',
                                  user_name: '',
                                  user_data : [],
                                  reconnected : false,
                                  operator_id : '',
                                  audio_notice : false,
	                 runOnce : true,	
	                 lock : false,
	                 poller : false,
	                pending : [],
		  sendLock : false,
		  isPending : false,
		pendingLock : false,
		  pendingTimer : '',
	                 timestamp: '',

	                 botName : "Demo Operator", 
	                 botAvatar : "http://demo1.artillegence.com/leap/wp-content/uploads/sites/37/2015/07/bot_Av.png", 
	                 botDesign : "Dummy Operator for Demo only.",
	                 bot : function(url,opts,callback){

	                 		switch(opts.type)	
	                 		{
	                 			case 'visitor_tree' : 

	                 				callback({ status : 'connected' }); 
	                 				break; 
	                 			case 'user_status' :  callback('connected');   break;	
	                 			case 'setup_chat' : callback({
	                 				operator_id : LEAP_CHAT.botName,
	                 				operator_avatar : LEAP_CHAT.botAvatar,
	                 				operator_desig : LEAP_CHAT.botDesign
	                 			});  break;
	                 			
	                 			case 'get-user-messages' :  callback(LEAP_CHAT.botLogic(opts));  break;

	                 		}

	                 },

	                 botLogic : function(opts){

	                 		var botmsg = {} ,m = LEAP_CHAT.user_msg.toLowerCase() , rm ='';
	                 		var lorem = new Lorem;

	                 		if(m.indexOf('hi') > -1 || m.indexOf('hello') > -1 ){
	                 			rm = ' Howdy ';
	                 		}
	                 		else if(m.indexOf('how') > -1 || m.indexOf('what') > -1 ){
	                 			rm = ' I am great, How about you ? ';
	                 		}
	                 		else if(m.indexOf('leap chat' > -1)  ){
	                 			rm = ' Leap Chat is a live chat plugin with edge cutting features. ';
	                 		}
	                 		else if(m.indexOf('fuck') > -1 || m.indexOf('ass') > -1  ){
	                 			rm = 'Why the bad langunage :( ';
	                 		}
	                 		else if(m.indexOf('bye') > -1 || m.indexOf('c u' > -1)  ){
	                 			rm = 'Bye Bye, it\'s a pleasure to meet you ';

	                 			setTimeout(function(){

	                 			chat_box.addClass('end-leap-chat');
			    	chat_box.removeClass('hide-leap-intro');

		                                      chat_box.find('.leap-chat-box-close-modal').fadeOut('normal');
		                                      jQuery('.leap-start-overlay').hide();
		           	           	    LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive','');
				LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp','');


	                 			},2000);
	                 		}
	                 		else rm = lorem.createText( Math.floor( Math.random() * 20 ) ,3);

	                 		botmsg[LEAP_CHAT.getMessageTimeStamp()] =  rm;	
	                 		if(rm==='') botmsg = '';

	                 		
	                 		return botmsg;
	                 },

		setup: function(){

			
			LEAP_CHAT.user_id = LEAP_CHAT.uniqueid();

			if( ! LEAP_CHAT.checkRegistry('leap-id'))
			{
				LEAP_CHAT.addLocalRegistry('leap-id',LEAP_CHAT.user_id);
			}
			else
			{
				LEAP_CHAT.user_id =  LEAP_CHAT.getRegistry('leap-id');
			}


			jQuery('#leap-chat').attr('id',LEAP_CHAT.user_id);

			LEAP_CHAT.audio_notice  = new MediaElementPlayer('#leap-chat-audio',{
				enableKeyboard: false
			});

			//if( ! chat_box.hasClass('leap-is-offline')  )
			//LEAP_CHAT.checkUserThread();
			
		},
		checkUserThread : function(){

			 LEAP_CHAT.bot(leap_listener_url, { 
				              type:'user_status' , 
				              action: 'leap_chat_Listener', 
				              'user_id' :  LEAP_CHAT.user_id,
				            },function(data){
				              	
				                          if(data!=''){
				                          	LEAP_CHAT.status = data;

				                          	if( LEAP_CHAT.user_name==''  &&  LEAP_CHAT.checkRegistry('leap-name'))
						{
							LEAP_CHAT.user_name =  LEAP_CHAT.getRegistry('leap-name');
							
						}
			
				                          	if(data == 'disconnect' || data == 'connected')
				                          	{
				                          		chat_box.removeClass('leap-hide-chat');
				                          		LEAP_CHAT.status = 'connected';
				                          		LEAP_CHAT.reconnected = true;
				                          		LEAP_CHAT.setupConnection();
				                          	}

				                          }             	                             

				  });

		},

		chatArchiver : function(message,timestamp){


			var archive = "";

			if(LEAP_CHAT.user_id!=''){

				
				if(LEAP_CHAT.checkRegistry(LEAP_CHAT.user_id+'-archive'))
				{
					archive =  LEAP_CHAT.getRegistry(LEAP_CHAT.user_id+'-archive');
				}
				
				archive  += message;				
				LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive',archive);
				LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp',timestamp);
			}

			
			
		},
		init : function(){

			LEAP_CHAT.user_name =  chat_box.find('#leap-chat-name').val();
			
			chat_box.find('.leap-chat-box-body--canvas').html('');
			LEAP_CHAT.reconnected = false;
			LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive','');
			LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp','');

			if(LEAP_CHAT.user_name!='')
			{
				LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_name);
			}	
			
			LEAP_CHAT.requestNewConnection();		
				
			chat_box.addClass('leap-init');

		},

		getStatus :  function(){

			if(LEAP_CHAT.lock ) return;
			/**
			  * Temporary Status lock
			  *
			  */

			LEAP_CHAT.lock = true;
			 LEAP_CHAT.bot(leap_listener_url, { 
				              type:'user_status' , 
				              action: 'leap_chat_Listener', 
				              'user_id' :  LEAP_CHAT.user_id,
				            },function(data){
				              	
				                          if(data!=''){
				                          	LEAP_CHAT.lock = false;
				                          	LEAP_CHAT.status = data;

				                          }             	                             

				  });


		},

		requestNewConnection : function(){

			var checker ;
			
			LEAP_CHAT.status = 'new-connection';

			jQuery(' .leap-start-overlay').fadeIn('fast');

			 LEAP_CHAT.bot(leap_listener_url, { 
             
				              type:'visitor_tree' , 
				              action: 'leap_chat_Listener', 
				              'user_id' :  LEAP_CHAT.user_id,
				              'user_name' :  LEAP_CHAT.user_name,
				              'flag' :  LEAP_CHAT.status,

				            },function(data){


				            	if(typeof data == 'string' && data=='offline')
				            	{
				            		jQuery('.start-leap-chap').html(leap_localize.offline_message);
				            		return;
				            	}

				            	if(typeof window.LEAP_USER_INFO === "string")
				            	jQuery.get("http://ipinfo.io/"+window.LEAP_USER_INFO, function(response) {
					    window.LEAP_USER_INFO = response;
					}, "jsonp");
				            	
				         
				            	
				            	LEAP_CHAT.lock = false;
				            	checker =  setInterval(function(){

				            		LEAP_CHAT.getStatus();

				            		if(LEAP_CHAT.status  == 'connected'){
				            			clearInterval(checker);
				            			LEAP_CHAT.setupConnection();
				            		}

				            	},2000);

				});

		},

		userAuth : function(){
			
			setInterval(function(){

				 LEAP_CHAT.bot(leap_listener_url, { 
             
					              type:'user-auth' , 
					              action: 'leap_chat_Listener', 
					              user_id :  LEAP_CHAT.user_id,
					   
					            },function(data){
					              

					  });

			},30000);

		},

		setupConnection : function(){

			chat_box.find('.leap-chat-box-intro--form').find('.leap-chat--input').each(function(){
				temp = jQuery(this).find('textarea,select,input[type=text]');
				LEAP_CHAT.user_data.push({  name : jQuery(this).find('label').html() ,  value : temp.val()  });
			});

			var f = false;
			if( ! LEAP_CHAT.reconnected ) 
				f = true;

			 LEAP_CHAT.bot(leap_listener_url, { 
             
				              type:'setup_chat' , 
				              action: 'leap_chat_Listener', 
				              forceNewConnection : f,
				              'user_id' :  LEAP_CHAT.user_id,
				              'flag' :  LEAP_CHAT.status,
				               'user_data' :  LEAP_CHAT.user_data,
			          	               'technical' : window.jscd,
			          	               'location' : window.LEAP_USER_INFO ,
				            },function(data){
				            	
				            	if(typeof data === "string")	
				            	data = JSON.parse(data);	
				            	LEAP_CHAT.operator_id  = data.operator_id; 
				            	LEAP_CHAT.status  = data.flag; 

				            	 //has-operator-meta
				            	 LEAP_START_MESSAGE  = 'Howdy, I am a Dummy bot for LEAP Chat. I will try to answer all your questions if I don\'t understand something I will add some lorem ipsum :D';
				            	 LEAP_CHAT.operator_msg  = LEAP_START_MESSAGE.replace('{name}',data.operator_id);
					
				            	 if( chat_box.find('.leap-chat-operator-meta').length  > 0 )
				            	 {
				            	 	chat_box.addClass('has-operator-meta');
				            	 	
				            	 	if(typeof data.operator_avatar !== "undefined" && data.operator_avatar!=='' )
				            	 		chat_box.find('.leap-chat-avatar img').attr('src',data.operator_avatar);
				            	 	else{
				            	 		chat_box.find('.leap-chat-operator-meta').addClass('no-avatar');
				            	 		chat_box.find('.leap-chat-avatar img').hide();
				            	 	}
				            	 	if(typeof data.operator_id !== "undefined" && data.operator_id!=='' )
				            	 		chat_box.find('.leap-chat-operator-meta h4').html(  data.operator_id );

				            	 	if(typeof data.operator_desig !== "undefined" && data.operator_desig!=='' )
				            	 		chat_box.find('.leap-chat-operator-meta h6').html(  data.operator_desig );
				            	 }

					      jQuery('.leap-start-overlay').fadeOut('fast',function(){
					      		chat_box.addClass('hide-leap-intro');
					      		
					      		if( ! LEAP_CHAT.reconnected ) {
					      			var  label = "<span>"+LEAP_CHAT.operator_id+"</span>";
								   
					                                                            LEAP_CHAT.timestamp = '';
							            	messages = jQuery( "<div class='leap-chat-box-operator-wrap bounceInLeft animated'>"+label+"<div class='leap-chat-box-operator-msg '>"+LEAP_CHAT.operator_msg+"</div></div>");
							            	canvas.append(messages);
							            	 LEAP_CHAT.smiley(messages);
							            	 canvas[0].scrollTop = canvas[0].scrollHeight;
							            	if(LEAP_CHAT.audio_notice)
							          	  	LEAP_CHAT.audio_notice.play();
							          	}
							     else
							     {
							     	if(LEAP_CHAT.checkRegistry(LEAP_CHAT.user_id+'-archive'))
								{
									archive =  LEAP_CHAT.getRegistry(LEAP_CHAT.user_id+'-archive');
									canvas.prepend(archive);
									canvas.find('.animated').removeClass('animated');
									LEAP_CHAT.smiley(canvas);
									LEAP_CHAT.timestamp = LEAP_CHAT.getRegistry(LEAP_CHAT.user_id+'-timestamp');
									canvas[0].scrollTop = canvas[0].scrollHeight;
								}
							     }     	
					      });

					      LEAP_CHAT.poller = false;
					    //  LEAP_CHAT.listener();
					      LEAP_CHAT.userAuth();
				            

				});

		},

		uniqueid : function(){
   
		           // always start with a letter (for DOM friendlyness)
		            var idstr=String.fromCharCode(Math.floor((Math.random()*25)+65));
		           
		            do {                
		            // between numbers and characters (48 is 0 and 90 is Z (42-48 = 90)
		           
		                     var ascicode=Math.floor((Math.random()*42)+48);
		                     if (ascicode<58 || ascicode>64){
		                    // exclude all chars between : (58) and @ (64)
		                            idstr+=String.fromCharCode(ascicode);    
		                    }                
		            } while (idstr.length<32);

		              return (idstr);
		 },
		
		getDueMessages : function(){

			if(LEAP_CHAT.lock) return;

			var messages = [], istyping = false;
			LEAP_CHAT.lock = true;
 			LEAP_CHAT.bot(leap_listener_url, { 
             
			              type:'get-user-messages' , 
			              action: 'leap_chat_Listener', 
			              'user_id' :  LEAP_CHAT.user_id,
			              'timestamp' :  LEAP_CHAT.timestamp,


			            },function(data){

			            	if(data === '' || ! data || data == "0" )
			            	{
			            		LEAP_CHAT.lock = false;
			            		return;
			            	}

			            	if(data === 'killed')
			            	{
			            		chat_box.addClass('end-leap-chat')
			            		LEAP_CHAT.poller = true;
			            		return;
			            	}

			            	if(typeof data === "string")
			            	data = JSON.parse(data);

			            	if(typeof data !== "object")
			            	{
			            		LEAP_CHAT.lock = false;
			            		return;
			            	}

			            	indicator_lock = false;
			            	var currentdate = new Date(), time = "<small>" + formatAMPM(currentdate) + "</small>",label = "<span>"+LEAP_CHAT.operator_id+"</span>";

			            	if(canvas.children().last().hasClass('leap-chat-box-operator-wrap'))
				{
					label = '';
					time = '';
				}

			            	jQuery.each(data,function(index,msg){

			            		  LEAP_CHAT.timestamp = index;

			            		if(msg=='<...>' && ! indicator_lock )
			            		{
			            			if(typeof indicator_timer == "function")
			            				clearTimeout(indicator_timer);
			            			istyping = true;
			            			
			            			indicator.css("opacity",1);

			            			indicator_timer = setTimeout(function(){
			            				indicator_lock = false;
			            				indicator.css("opacity",0);
			            			},4000);
			            			
			            			
			            		}
								else			            		
			            		{
			            			if(msg!=='<...>')
			            			messages.push("<div class='leap-chat-box-operator-msg '>"+msg+"</div>");
			            			indicator.css("opacity",0);
			            			istyping = false;
			            			indicator_lock = true;
			            		}
                                                                                       
			            	});
			            	LEAP_CHAT.lock = false;

			            	if(istyping) return;

			            	messages =  "<div class='leap-chat-box-operator-wrap bounceInLeft animated'>"+label+time+""+messages.join('')+"</div>";
			          	  LEAP_CHAT.chatArchiver(messages,LEAP_CHAT.timestamp);
			            	messages = jQuery(messages);
			            	canvas.append(messages);
			            	 LEAP_CHAT.smiley(messages);
			            	 canvas[0].scrollTop = canvas[0].scrollHeight;
			            	if(LEAP_CHAT.audio_notice)
			          	  	LEAP_CHAT.audio_notice.play();

			});
			
		},
		getMessageTimeStamp : function(){

			 var currentdate = new Date(); 
			 var datetime = LEAP_CHAT.user_id + currentdate.getDate() +  (parseInt(currentdate.getMonth())    + 1)  + currentdate.getFullYear()  + currentdate.getHours()   + currentdate.getMinutes()  + currentdate.getSeconds(); 

			 return datetime;
		},
		listener : function(){

			
			LEAP_CHAT.poll(function(){ 
				
				LEAP_CHAT.getDueMessages();
				
				return LEAP_CHAT.poller;

			} ,  2000); 

		},

		  poll : function(fn,  interval) {

			    (function p() {
			            
			            if(fn()) {
			             //   callback();
			            }
			            else {
			                setTimeout(p, interval);
			            }
			     
			    })();
			},

			smiley : function(obj){

				 jQuery.post(leap_listener_url, { 
             
				              type:'translate_smiley' , 
				              action: 'leap_chat_Listener', 
				              'text' : obj.html(),

				            },function(data){
				              	
				                  if(data!='')
				                  {
				                  		obj.html(window.wp.emoji.parse(data) );	
				                  }		                                                             

				  });	

			},

			ajaxSend : function(message){
				
				LEAP_CHAT.sendLock = true;
				LEAP_CHAT.bot(leap_listener_url,{
		                                                        user_id : LEAP_CHAT.user_id ,
		                                                        message : message,
		                                                       type: "set-user-message",
		                                                        action: 'leap_chat_Listener'

		                                                    },function(data){
		                                                    		setTimeout(function(){ LEAP_CHAT.sendLock = false;

		                                                    			
		                                                    		 },1000);
		                                                    });	

			},
			sendPendingMessages: function(){

				if(LEAP_CHAT.pendingLock) return; // Wait for earlier messags to be delivered

				LEAP_CHAT.pendingLock = true;
				
				
				LEAP_CHAT.sendLock = true;

				LEAP_CHAT.pendingTimer = setInterval(function(){

						if(! LEAP_CHAT.isPending){

							LEAP_CHAT.sendLock = true;
							LEAP_CHAT.isPending = true;	
							var msg = LEAP_CHAT.pending;
							LEAP_CHAT.pending = [];

							LEAP_CHAT.bot(leap_listener_url,{
					                                                        user_id : LEAP_CHAT.user_id ,
					                                                        message : msg,
					                                                       type: "set-user-message",
					                                                        action: 'leap_chat_Listener'

					                                                    },function(data){
					                                                    		LEAP_CHAT.sendLock = false;	
					                                                  		LEAP_CHAT.pendingLock = false;
					                                                  		LEAP_CHAT.isPending = false;
					                                                  		clearInterval(LEAP_CHAT.pendingTimer);

					                                                  		if(LEAP_CHAT.pending.length > 0)
					                                                  			LEAP_CHAT.sendPendingMessages();
					                                                    });

						}

				},1000);

			},
			sendMessage : function(){
				
				LEAP_CHAT.user_msg =  input.val();
				if(LEAP_CHAT.user_msg =='') return;	


				

				

				var currentdate = new Date();
				var label = "<span>"+LEAP_CHAT.user_name+"</span>";
	                                                        var time = "<small>" + formatAMPM(currentdate) + "</small>";
				LEAP_CHAT.user_flag = 'sent';
				LEAP_CHAT.message_stamp = LEAP_CHAT.getMessageTimeStamp();
				


				if(canvas.children().last().hasClass('leap-chat-box-user-msg'))
				{
					time = '';
					label = '';
				}

				var currentdate = new Date();

				obj = jQuery("<div class='leap-chat-box-user-msg bounceInRight animated'>"+time+label+LEAP_CHAT.user_msg+"</div>");
				canvas.append(obj);
				
				LEAP_CHAT.smiley(obj);
				
				LEAP_CHAT.chatArchiver("<div class='leap-chat-box-user-msg bounceInRight animated'>"+time+label+LEAP_CHAT.user_msg+"</div>",LEAP_CHAT.timestamp);
				
				input.val('');
				canvas[0].scrollTop = canvas[0].scrollHeight;
				if(LEAP_CHAT.audio_notice)
					LEAP_CHAT.audio_notice.play();

				input.focus();

				setTimeout(function(){
					LEAP_CHAT.getDueMessages(LEAP_CHAT.user_msg);
				},2000);

			},

			die : function(){

				 LEAP_CHAT.bot(leap_listener_url, { 
					              type:'set_user_status' , 
					              action: 'leap_chat_Listener', 
					              status : 'disconnect',
					              'user_id' :  LEAP_CHAT.user_id,
					              'operator_id' :  LEAP_CHAT.operator_id,
					            },function(data){
					              	
					                          if(data!=''){
					                          	LEAP_CHAT.status = 'disconnect';
					                          }             	                             

					  });

			},

		 /**
		        *
		        * Add to Cache 
		        *
		        **/
		        
		        addLocalRegistry : function(key,widget_string)
		        {

		                if(Modernizr.localstorage)
		                {
		                        localStorage.setItem(key,widget_string);
		                }

		        },

		        /**
		        *
		        * Check if Key exists
		        *
		        **/
		        
		        checkRegistry : function(key)
		        { 
		              
		                if( Modernizr.localstorage && localStorage.getItem(key) )
		                        return true;
		                else
		                        return false;
		        },

		        /**
		        *
		        * Get Data from cache
		        *
		        **/
		        
		        getRegistry : function(key)
		        {
		        	if(Modernizr.localstorage)
		                  		return localStorage.getItem(key);
		                  	else 
		                  		return '';
		        },



	}

	  
                             jQuery(document).on('keydown','#leap-chat-name',function(e){
                           if (e.keyCode == 13) {
                                    jQuery('.leap-start-chat a').trigger('click');
                                    return false;
                                 }

                        });

                             var keyinterval;
                                  jQuery(document).on('keypress','.leap-chat-box-footer--input',function(e){
                      
                             var    val = jQuery(this).val() ,qar =  val.length;
                             if(qar > 2 && ! LEAP_CHAT.sendLock && e.keyCode != 13)
                             {
                             	LEAP_CHAT.sendLock = true;
                             		if(typeof keyinterval == "function")
                             			clearTimeout(keyinterval);

                                         LEAP_CHAT.bot(leap_listener_url,{
                                                      user_id : LEAP_CHAT.user_id ,
                                                      message : '<...>'+val,
                                                     type: "set-user-message",
                                                      action: 'leap_chat_Listener'

                                                  },function(data){
                                                  	LEAP_CHAT.sendLock = false; 
                                          });
                             }


                        });

                  jQuery('.leap-chat-restart').click(function(e){

                  		e.preventDefault();
		chat_box.removeClass('end-leap-chat hide-leap-intro leap-init');	

                  });      

                  

                  jQuery('.leap-offline-button a').click(function(e){
		e.preventDefault();
		var contact_test = false,input,val,fields = {};
		

		chat_box.find('.leap-offline-form div.leap-chat--input').each(function(){
			input = jQuery(this).find('input,textarea,select');
			val = input.val();
			if( jQuery.trim(val) === '' )
			{
				contact_test = true;
				jQuery(this).addClass('leap-input-error');
			}
			else
				jQuery(this).removeClass('leap-input-error');

			fields[jQuery(this).find('label').html()] = val;

		});

		if(contact_test)
		{
			jQuery('.leap-chat-box-intro--form').scrollTop(0);
			return;
		}

		jQuery('.leap-offline-form').css("opacity",0.4);
		obj = jQuery(this);
		obj.html('Sending...');

		LEAP_CHAT.bot(leap_listener_url,{
                                                        type: "offline-message",
                                                      action: 'leap_chat_Listener',
                                                      fields : fields,
                                                  },function(data){
                                                  	jQuery('.leap-offline-form div.leap-chat--input').each(function(){
                                                  		jQuery(this).find('input,textarea').val('');	
                                                  	 });
                                                  	obj.html('Sent !');
                                                  	jQuery('.leap-offline-form').fadeOut('fast');
                                                  	jQuery('.leap-offline-success-message').css("top","30px");
                                          });

		
	});

	jQuery('.leap-start-chat a').click(function(e){
		e.preventDefault();
		var contact_test = false;

		if( jQuery.trim(chat_box.find('#leap-chat-name').val()) === '' )
		{
			contact_test = true;
		}

		if(contact_test)
		{
			
			chat_box.find('#leap-chat-name').parent().addClass('leap-input-error');
			chat_box.find('.leap-chat-box-intro--form').scrollTop(0);
			return;
		}

		LEAP_CHAT.addLocalRegistry('leap-name',chat_box.find('#leap-chat-name').val());
		LEAP_CHAT.init();
	});

	jQuery('div.leap-chat-box-compact-bar').click(function(e){
		e.preventDefault();
		chat_box.removeClass('leap-hide-chat');

	});

	jQuery('div.leap-chat-box-expand-bar').click(function(e){
		e.preventDefault();
		chat_box.removeClass('leap-hide-chat hide-leap-intro');

	});

	

	jQuery('.leap-chat-box-close').click(function(e){
		e.preventDefault();

		if(chat_box.hasClass('end-leap-chat') || chat_box.hasClass('leap-is-offline') ||  LEAP_CHAT.status === 'new-connection')
			chat_box.addClass('leap-hide-chat');
		else{
			chat_box.find('.leap-chat-box-close-modal').fadeIn('normal');
		}

	});


	jQuery('.leap-modal-close').click(function(e){
		e.preventDefault();
		chat_box.find('.leap-chat-box-close-modal').fadeOut('normal');
	});

	jQuery('.leap-kill-session').click(function(e){
		    e.preventDefault();

		    	chat_box.addClass('leap-hide-chat');
		    	chat_box.removeClass('hide-leap-intro');
	                                      chat_box.find('.leap-chat-box-close-modal').fadeOut('normal');
	                                      jQuery('.leap-start-overlay').hide();
	                                      
	                               LEAP_CHAT.bot(   leap_listener_url , {

	                                                   type: "kill_session",
	                                                    user_id:  LEAP_CHAT.user_id,
	                                                   action: 'leap_chat_Listener'

	                                   } , function(data){
	                                 
	                                       	LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-archive','');
				LEAP_CHAT.addLocalRegistry(LEAP_CHAT.user_id+'-timestamp','');

	                                   });

	});

	input.keydown(function(event) {
		    if (event.keyCode == 13) {
		      	LEAP_CHAT.sendMessage();
		        return false;
		     }
		});

	jQuery('.leap-chat-box-footer--send').click(function(e){
		e.preventDefault();
		LEAP_CHAT.sendMessage();

		});
	

	   window.onbeforeunload = LEAPKILLCHAT;


    	function LEAPKILLCHAT() {   LEAP_CHAT.die();   }
	function formatAMPM(date) {
	  var hours = date.getHours();
	  var minutes = date.getMinutes();
	  var ampm = hours >= 12 ? 'pm' : 'am';
	  hours = hours % 12;
	  hours = hours ? hours : 12; // the hour '0' should be '12'
	  minutes = minutes < 10 ? '0'+minutes : minutes;
	  var strTime = hours + ':' + minutes + ' ' + ampm;
	  return strTime;
	}

	LEAP_CHAT.setup();
	/**
	  *  Kill Any session if open
	  *
	  **/


    	
 });


/* Modernizr 2.7.1 (Custom Build) | MIT & BSD
 * Build: http://modernizr.com/download/#-localstorage-sessionstorage-webworkers
 */
;window.Modernizr=function(a,b,c){function t(a){i.cssText=a}function u(a,b){return t(prefixes.join(a+";")+(b||""))}function v(a,b){return typeof a===b}function w(a,b){return!!~(""+a).indexOf(b)}function x(a,b,d){for(var e in a){var f=b[a[e]];if(f!==c)return d===!1?a[e]:v(f,"function")?f.bind(d||b):f}return!1}var d="2.7.1",e={},f=b.documentElement,g="modernizr",h=b.createElement(g),i=h.style,j,k={}.toString,l={},m={},n={},o=[],p=o.slice,q,r={}.hasOwnProperty,s;!v(r,"undefined")&&!v(r.call,"undefined")?s=function(a,b){return r.call(a,b)}:s=function(a,b){return b in a&&v(a.constructor.prototype[b],"undefined")},Function.prototype.bind||(Function.prototype.bind=function(b){var c=this;if(typeof c!="function")throw new TypeError;var d=p.call(arguments,1),e=function(){if(this instanceof e){var a=function(){};a.prototype=c.prototype;var f=new a,g=c.apply(f,d.concat(p.call(arguments)));return Object(g)===g?g:f}return c.apply(b,d.concat(p.call(arguments)))};return e}),l.localstorage=function(){try{return localStorage.setItem(g,g),localStorage.removeItem(g),!0}catch(a){return!1}},l.sessionstorage=function(){try{return sessionStorage.setItem(g,g),sessionStorage.removeItem(g),!0}catch(a){return!1}},l.webworkers=function(){return!!a.Worker};for(var y in l)s(l,y)&&(q=y.toLowerCase(),e[q]=l[y](),o.push((e[q]?"":"no-")+q));return e.addTest=function(a,b){if(typeof a=="object")for(var d in a)s(a,d)&&e.addTest(d,a[d]);else{a=a.toLowerCase();if(e[a]!==c)return e;b=typeof b=="function"?b():b,typeof enableClasses!="undefined"&&enableClasses&&(f.className+=" "+(b?"":"no-")+a),e[a]=b}return e},t(""),h=j=null,e._version=d,e}(this,this.document);

/**
 * JavaScript Client Detection
 * (C) viazenetti GmbH (Christian Ludwig)
 */

(function (window) {
    {
        var unknown = '-';

        // screen
        var screenSize = '';
        if (screen.width) {
            width = (screen.width) ? screen.width : '';
            height = (screen.height) ? screen.height : '';
            screenSize += '' + width + " x " + height;
        }

        //browser
        var nVer = navigator.appVersion;
        var nAgt = navigator.userAgent;
        var browser = navigator.appName;
        var version = '' + parseFloat(navigator.appVersion);
        var majorVersion = parseInt(navigator.appVersion, 10);
        var nameOffset, verOffset, ix;

        // Opera
        if ((verOffset = nAgt.indexOf('Opera')) != -1) {
            browser = 'Opera';
            version = nAgt.substring(verOffset + 6);
            if ((verOffset = nAgt.indexOf('Version')) != -1) {
                version = nAgt.substring(verOffset + 8);
            }
        }
        // MSIE
        else if ((verOffset = nAgt.indexOf('MSIE')) != -1) {
            browser = 'Microsoft Internet Explorer';
            version = nAgt.substring(verOffset + 5);
        }
        // Chrome
        else if ((verOffset = nAgt.indexOf('Chrome')) != -1) {
            browser = 'Chrome';
            version = nAgt.substring(verOffset + 7);
        }
        // Safari
        else if ((verOffset = nAgt.indexOf('Safari')) != -1) {
            browser = 'Safari';
            version = nAgt.substring(verOffset + 7);
            if ((verOffset = nAgt.indexOf('Version')) != -1) {
                version = nAgt.substring(verOffset + 8);
            }
        }
        // Firefox
        else if ((verOffset = nAgt.indexOf('Firefox')) != -1) {
            browser = 'Firefox';
            version = nAgt.substring(verOffset + 8);
        }
        // MSIE 11+
        else if (nAgt.indexOf('Trident/') != -1) {
            browser = 'Microsoft Internet Explorer';
            version = nAgt.substring(nAgt.indexOf('rv:') + 3);
        }
        // Other browsers
        else if ((nameOffset = nAgt.lastIndexOf(' ') + 1) < (verOffset = nAgt.lastIndexOf('/'))) {
            browser = nAgt.substring(nameOffset, verOffset);
            version = nAgt.substring(verOffset + 1);
            if (browser.toLowerCase() == browser.toUpperCase()) {
                browser = navigator.appName;
            }
        }
        // trim the version string
        if ((ix = version.indexOf(';')) != -1) version = version.substring(0, ix);
        if ((ix = version.indexOf(' ')) != -1) version = version.substring(0, ix);
        if ((ix = version.indexOf(')')) != -1) version = version.substring(0, ix);

        majorVersion = parseInt('' + version, 10);
        if (isNaN(majorVersion)) {
            version = '' + parseFloat(navigator.appVersion);
            majorVersion = parseInt(navigator.appVersion, 10);
        }

        // mobile version
        var mobile = /Mobile|mini|Fennec|Android|iP(ad|od|hone)/.test(nVer);

        // cookie
        var cookieEnabled = (navigator.cookieEnabled) ? true : false;

        if (typeof navigator.cookieEnabled == 'undefined' && !cookieEnabled) {
            document.cookie = 'testcookie';
            cookieEnabled = (document.cookie.indexOf('testcookie') != -1) ? true : false;
        }

        // system
        var os = unknown;
        var clientStrings = [
            {s:'Windows 10', r:/(Windows 10.0|Windows NT 10.0)/},
            {s:'Windows 8.1', r:/(Windows 8.1|Windows NT 6.3)/},
            {s:'Windows 8', r:/(Windows 8|Windows NT 6.2)/},
            {s:'Windows 7', r:/(Windows 7|Windows NT 6.1)/},
            {s:'Windows Vista', r:/Windows NT 6.0/},
            {s:'Windows Server 2003', r:/Windows NT 5.2/},
            {s:'Windows XP', r:/(Windows NT 5.1|Windows XP)/},
            {s:'Windows 2000', r:/(Windows NT 5.0|Windows 2000)/},
            {s:'Windows ME', r:/(Win 9x 4.90|Windows ME)/},
            {s:'Windows 98', r:/(Windows 98|Win98)/},
            {s:'Windows 95', r:/(Windows 95|Win95|Windows_95)/},
            {s:'Windows NT 4.0', r:/(Windows NT 4.0|WinNT4.0|WinNT|Windows NT)/},
            {s:'Windows CE', r:/Windows CE/},
            {s:'Windows 3.11', r:/Win16/},
            {s:'Android', r:/Android/},
            {s:'Open BSD', r:/OpenBSD/},
            {s:'Sun OS', r:/SunOS/},
            {s:'Linux', r:/(Linux|X11)/},
            {s:'iOS', r:/(iPhone|iPad|iPod)/},
            {s:'Mac OS X', r:/Mac OS X/},
            {s:'Mac OS', r:/(MacPPC|MacIntel|Mac_PowerPC|Macintosh)/},
            {s:'QNX', r:/QNX/},
            {s:'UNIX', r:/UNIX/},
            {s:'BeOS', r:/BeOS/},
            {s:'OS/2', r:/OS\/2/},
            {s:'Search Bot', r:/(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\/Teoma|ia_archiver)/}
        ];
        for (var id in clientStrings) {
            var cs = clientStrings[id];
            if (cs.r.test(nAgt)) {
                os = cs.s;
                break;
            }
        }

        var osVersion = unknown;

        if (/Windows/.test(os)) {
            osVersion = /Windows (.*)/.exec(os)[1];
            os = 'Windows';
        }

        switch (os) {
            case 'Mac OS X':
                osVersion = /Mac OS X (10[\.\_\d]+)/.exec(nAgt)[1];
                break;

            case 'Android':
                osVersion = /Android ([\.\_\d]+)/.exec(nAgt)[1];
                break;

            case 'iOS':
                osVersion = /OS (\d+)_(\d+)_?(\d+)?/.exec(nVer);
                osVersion = osVersion[1] + '.' + osVersion[2] + '.' + (osVersion[3] | 0);
                break;
        }
        
        // flash (you'll need to include swfobject)
        /* script src="//ajax.googleapis.com/ajax/libs/swfobject/2.2/swfobject.js" */
        var flashVersion = 'no check';
        if (typeof swfobject != 'undefined') {
            var fv = swfobject.getFlashPlayerVersion();
            if (fv.major > 0) {
                flashVersion = fv.major + '.' + fv.minor + ' r' + fv.release;
            }
            else  {
                flashVersion = unknown;
            }
        }
    }

    window.jscd = {
        screen: screenSize,
        browser: browser,
        browserVersion: version,
        mobile: mobile,
        os: os,
        osVersion: osVersion,
        cookies: cookieEnabled,
        flashVersion: flashVersion
    };
}(this));


var Lorem;
(function() {

    //Create a class named Lorem and constructor
    Lorem = function() {
        //Default values.
        this.type = null;
        this.query = null;
        this.data = null;
    };
    //Static variables
    Lorem.IMAGE = 1;
    Lorem.TEXT = 2;
    Lorem.TYPE = {
        PARAGRAPH: 1,
        SENTENCE: 2,
        WORD: 3
    };
    //Words to create lorem ipsum text.
    Lorem.WORDS = [
        "Far","far","away,","behind","the","word","mountains,","far","from","the","countries","Vokalia","and","Consonantia,","there","live","the","blind","texts.","Separated","they","live","in","Bookmarksgrove","right","at","the","coast","of","the","Semantics,","a","large","language","ocean.","A","small","river","named","Duden","flows","by","their","place","and","supplies","it","with","the","necessary","regelialia.","It","is","a","paradisematic","country,","in","which","roasted","parts","of","sentences","fly","into","your","mouth.","Even","the","all-powerful","Pointing","has","no","control","about","the","blind","texts","it","is","an","almost","unorthographic","life","One","day","however","a","small","line","of","blind","text","by","the","name","of","Lorem","Ipsum","decided","to","leave","for","the","far","World","of","Grammar.","The","Big","Oxmox","advised","her","not","to","do","so,","because","there","were","thousands","of","bad","Commas,","wild","Question","Marks","and","devious","Semikoli,","but","the","Little","Blind","Text","didn't","listen","She","packed","her","seven","versalia","put","her","initial","into","the","belt","and","made","herself","on","the","way","When","she","reached","the","first","hills","of","the","Italic","Mountains,","she","had","a","last","view","back","on","the","skyline","of","her","hometown","Bookmarksgrove","the","headline","of","Alphabet","Village","and","the","subline","of","her","own","road,","the","Line","Lane.","Pityful","a","rethoric","question","ran","over","her","cheek,","then"];
//random integer method.
    Lorem.prototype.randomInt = function (min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };
    //text creator method with parameters: how many, what
    Lorem.prototype.createText = function(count, type) {
        switch (type) {
            //paragraphs are loads of sentences.
            case Lorem.TYPE.PARAGRAPH:
                var paragraphs = new Array;
                for (var i = 0; i < count; i++) {
                    var paragraphLength = this.randomInt(10, 20);
                    var paragraph = this.createText(paragraphLength, Lorem.TYPE.SENTENCE);
                    paragraphs.push('<p>'+paragraph+'</p>');
                }
                return paragraphs.join('\n');
                break;
            //sentences are loads of words.
            case Lorem.TYPE.SENTENCE:
                var sentences = new Array;
                for (var i = 0; i < count; i++) {
                    var sentenceLength = this.randomInt(5, 10);
                    var words = this.createText(sentenceLength, Lorem.TYPE.WORD).split(' ');
                    words[0] = words[0].substr(0, 1).toUpperCase() + words[0].substr(1);
                    var sentence = words.join(' ');

                    sentences.push(sentence);
                }
                return (sentences.join('. ') + '.').replace(/(\.\,|\,\.)/g, '.');
                break;
            //words are words
            case Lorem.TYPE.WORD:
                var wordIndex = this.randomInt(0, Lorem.WORDS.length - count - 1);

                return Lorem.WORDS.slice(wordIndex, wordIndex + count).join(' ').replace(/\.|\,/g, '');
                break;
        }
    };
    Lorem.prototype.createLorem = function(element) {

        var lorem = new Array;
        var count;
        
        if (/\d+-\d+[psw]/.test(this.query)){
            var range = this.query.replace(/[a-z]/,'').split("-");
            count = Math.floor(Math.random() * parseInt(range[1])) + parseInt(range[0]);
        }else{
            count = parseInt(this.query); 
        }
        
        if (/\d+p/.test(this.query)) {
            var type = Lorem.TYPE.PARAGRAPH;
        }
        else if (/\d+s/.test(this.query)) {
            var type = Lorem.TYPE.SENTENCE;
        }
        else if (/\d+w/.test(this.query)) {
            var type = Lorem.TYPE.WORD;
        }

        lorem.push(this.createText(count, type));
        lorem = lorem.join(' ');

        if (element) {
            if (this.type == Lorem.TEXT)
                element.innerHTML += lorem;
            else if (this.type == Lorem.IMAGE) {
                //TODO: for now, using lorempixum.
                var path = '';
                var options = this.query.split(' ');
                if (options[0] == 'gray') {
                    path += '/g';
                    options[0] = '';
                }
                if (element.getAttribute('width'))
                    path += '/' + element.getAttribute('width');

                if (element.getAttribute('height'))
                    path += '/' + element.getAttribute('height');

                path += '/' + options.join(' ').replace(/(^\s+|\s+$)/, '');
                element.src = 'http://lorempixum.com'+path.replace(/\/\//, '/');
            }
        }

        if (element == null)
            return lorem;
    };

    //Register as jQuery
    if (typeof jQuery != 'undefined') {
        (function($) {
            $.fn.lorem = function() {
                $(this).each(function() {
                    var lorem = new Lorem;
                    lorem.type = $(this).is('img') ? Lorem.IMAGE : Lorem.TEXT;
                    //data-lorem can be taken with data function (thanks to http://forrst.com/people/webking)
                    lorem.query = $(this).data('lorem');
                    lorem.createLorem(this);
                })
            };

            //If developer run this javascript, then we can run the lorem.js
            $(document).ready(function() {
                $('[data-lorem]').lorem();
            });
        })(jQuery);
    }

})();